2022-02-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	NEWS: update before release
	* NEWS: Prepare for the 4.9.0 release: minor re-ordering, and update
	entries with bug numbers.

2022-02-01  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	Run 'make update-gnulib-to-latest' in order to use the latest version
	for the imminent release.

	* bootstrap: Sync from gnulib/build-aux/bootstrap.
	* gnulib: Update to latest.

2022-01-31  Andreas Metzler  <ametzler@bebt.de>
	    Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: improve description of 'find -delete'
	* doc/find.texi (Action -delete): Improve and re-structure:
	Mention that -delete is able to remove directories (if they are empty),
	that failure to delete a file changes the exit code to nonzero, and
	clarify better the relation between -delete, -depth and -prune.
	* find/find.1 (-delete): Align with the above mentioned section in the
	Texinfo manual.

	Fixes https://savannah.gnu.org/bugs/?61774
	Originally reported by Chris Davies in
	  https://bugs.debian.org/1003339

2022-01-06  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: avoid warnings from sparse tool
	https://sparse.docs.kernel.org/
	Running the tool against unviled the following warnings:

	  find/parser.c:328:7: warning: Using plain integer as NULL pointer
	  find/parser.c:328:10: warning: Using plain integer as NULL pointer
	  find/parser.c:328:13: warning: Using plain integer as NULL pointer
	  find/parser.c:466:49: warning: Using plain integer as NULL pointer
	  find/parser.c:656:45: warning: Using plain integer as NULL pointer
	  find/print.c:1024:30: warning: Using plain integer as NULL pointer
	  lib/regexprops.c:531:7: warning: symbol 'options' shadows an earlier one
	  lib/regextype.c:48:24: warning: symbol 'regex_map' was not declared. Should it be static?
	  locate/locate.c:131:25: warning: symbol 'check_existence' was not declared. Should it be static?
	  locate/locate.c:207:12: warning: symbol 'metacharacters' was not declared. Should it be static?
	  xargs/xargs.c:902:24: warning: symbol 'state' shadows an earlier one
	  xargs/xargs.c:542:23: warning: Using plain integer as NULL pointer

	The fixes for these findings are all trivial, so let's apply them.

	* find/parser.c (parse_table): Initialize pointer-type members of
	the last element with NULL instead of 0.
	(get_noop): Compare to NULL as end condition of for-loop.
	(find_parser): Likewise.
	* find/print.c (do_fprintf): Initialize linkname with NULL instead of 0.
	* lib/regexprops.c (describe_all): Rename local variable options
	to regopts to avoid name shadowing.
	* lib/regextype.c (regex_map): Declare static.
	* locate/locate.c (check_existence): Likewise.
	(metacharacters): Likewise.
	* xargs/xargs.c (main): Set eof_str to NULL instead of 0.

2022-01-06  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	Run 'make update-gnulib-to-latest', mainly due to:

	  > license: fix GPLv3 texts to use a comma instead of semicolon.

	* bootstrap: Sync from gnulib/build-aux/bootstrap.
	* gnulib: Update to latest.

2022-01-05  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: fix GPLv3 texts to use a comma instead of semicolon
	See: https://www.gnu.org/licenses/gpl-3.0.html#howto
	Run:
	  $ git grep -l 'Foundation; either version 3' \
	      | xargs sed -i '/Foundation; either version 3/ s/n; e/n, e/'

	* bootstrap.conf: Adjust GPLv3 header via the above command.
	* build-aux/gen-changelog.sh: Likewise.
	* lib/die.h: Likewise.

2022-01-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update copyright year number ranges
	Run 'make update-copyright'.

	* lib/regexprops.c (copying): Update the year number manually.
	The format of the copyright year number range in Texinfo files is
	"YEAR1--YEAR2" now, i.e., with 2x '-'.
	* tests/sample-test: Adjust to use the single most recent year.
	* All other files: Update copyright years via the above make run.

2022-01-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	Run 'make update-gnulib-to-latest', mainly to update the copyright
	year numbers with:

	  > maint: run 'make update-copyright'

	* bootstrap: Sync from gnulib/build-aux/bootstrap.
	* gnulib: Update to latest.
	* tests/init.sh: Sync from 'gnulib/tests/init.sh'.

2021-12-31  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: fix 'xargs --open-tty' example
	doc/find.texi (xargs options): Change 'grep -lz' to 'grep -lZ' as
	input for 'xargs -0o' as only the latter will write a NUL after
	each file name.  Add -n1 to the xargs call.

	Reported by Robin A. Meade in
	https://savannah.gnu.org/bugs/?61341

2021-12-31  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: avoid FP from 'find -files0-from DIR' on certain platforms
	On most modern systems like GNU/Linux, read(2)-ing from a directory file
	descriptor will fail with EISDIR, but it succeeds e.g. on GNU/Hurd and
	AIX-7.1/AIX-7.2.

	tests/find/files0-from.sh: Skip the test case excercising a directory
	argument for the -files0-from option when the system allows reading
	from a directory.

2021-12-29  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	Run 'make update-gnulib-to-latest'.

	* bootstrap: Sync from gnulib/build-aux/bootstrap.
	* gnulib: Update to latest.

2021-12-29  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: fix visiting of files with inode number Zero
	On GNU/Hurd, the value 0 is a valid inode number, and is e.g. used
	for /dev/console and /dev/tty.  The find(1) program aborted on this
	platform when the user specified the -inum test and when the search
	visited such a file.

	  $ find /dev/null /dev/tty -inum 40799 -printf '%i:%p\n'
	  40799:/dev/null
	  find: util.c:330: get_info: Assertion `p->st_ino' failed.
	  Aborted

	Likewise, 'find -printf %i' aborted when hitting such a file.

	* find/defs.h (get_info): Remove declaration.
	* find/pred.c (pred_inum): Remove the redundant assert for ST_INO
	as parse_inum sets need_inum=true which ensures that the inode number
	is known.
	* find/util.c (get_info): Declare static, and simplify: remove the
	assertions for the inode number and file type.
	While at it, add condition !state.have_stat in the need_stat case
	for consistency.
	* tests/find/inode-zero.sh: Add test.
	* tests/local.mk (all_tests): Reference it.

	Problem introduced by the inum optimisation in commit 2bf001636e6.

	Reported by Andrea Monaco <andrea.monaco@autistici.org> in
	https://lists.gnu.org/r/bug-findutils/2021-12/msg00008.html

2021-12-25  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: avoid '-D stat' side effect on SELinux handling with -L or -H
	With the '-D stat' debugging option turned on, 'find -L' determined the
	SELinux context information as if the -L (or -H) option was not given:

	  $ strace -ve getxattr,lgetxattr find -L . -maxdepth 0 -printf '%Z:%p\n'
	  getxattr(".", "security.selinux", 0x55b29a2b2d40, 255) = -1 ENODATA (No data available)
	  ...

	  $ strace -ve getxattr,lgetxattr find -D stat -L . -maxdepth 0 -printf '%Z:%p\n'
	  lgetxattr(".", "security.selinux", 0x5649c91d8d40, 255) = -1 ENODATA (No data available)
	  ...

	* find/parser.c (set_follow_state): Move the DebugStat handling after
	the switch statement, thus eliminating the if/else.

	Bug present since adding the SELinux implementation in v4.5.5-42-g1a05af6a.

2021-11-28  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: add description for birth time in 'find -printf' format
	find(1) supports both searching for and printing of the birth time
	of a file since 2007, but the documenation lacked the description
	for the latter.

	* doc/find.texi (node Time Directives): Add item for %B.
	(node Time Formats): Mention that the described formats also apply to
	the %B directive.
	* find/find.1 (-printf format): Add description of %B.
	* NEWS (Documentation Changes): Mention the change.

	Fixes https://savannah.gnu.org/bugs/?61327

2021-11-27  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: allow -files0-from input file to be empty
	Do no longer output an error diagnostic when the input file of
	the -files0-from option is empty.

	* find/ftsfind.c (process_all_startpoints): Remove error diagnostic.
	* doc/find.texi (node Starting points): Adjust documentation.
	* find/find.1: Likewise.
	* tests/find/files0-from.sh: Adjust test.

	Suggested by Stephane Chazelas in
	https://savannah.gnu.org/bugs/?60383#comment11

2021-11-27  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: fix error diagnostic
	* find/testsuite/config/unix.exp (safe_path): Change $PATH to PATH
	as the message refers to the name of the environment variable, i.e.,
	not its value.

2021-11-27  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: skip -execdir test if PATH contains unsafe directory
	* find/testsuite/find.gnu/sv-bug-27563-execdir.exp: Guard test by
	'safe_path' condition to avoid false-positive failures in case the
	PATH variable contains the current directory '.' ... which lets the
	`find -execdir` action fail with an error diagnostic.

	Reported by Paxsali <akis.kapo@googlemail.com> in
	https://savannah.gnu.org/bugs/?60383

2021-11-27  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	Run 'make update-gnulib-to-latest' - thus pulling in 357 commits,
	including the following which was also discussed in:
	  https://savannah.gnu.org/bugs/?60383
	  > test-framework-sh: remove unsafe entries from PATH

	* gnulib: Update to latest.
	* cfg.mk (local-checks-to-skip): Add and therefore disable sc_indent
	as auto indent is too invasive for now.
	* m4/mkinstalldirs.m4: Fix repeated word: s/can can/can/.  Reported by
	a new rule in sc_prohibit_doubled_word.
	* m4/noreturn.m4: Likewise.
	* tests/init.sh: Likewise.

2021-10-20  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: improve maintainer description of the online manual
	* doc/find-maint.texi (User Documentation): Add details how to
	update the online manual from Git via the CVS web repository.

2021-10-20  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: copy online docs from 'doc/manual' to apply the GNU stylesheet
	The script to copy the documentation for the web to the CVS checkout
	directory took the files from 'doc'.  But as those files do not
	reference the GNU stylesheet, the resulting online documentation
	didn't look as fancy as usual.
	Instead, copy the files from 'doc/manual' which gets created by the make
	target 'web-manual'.

	* build-aux/update-online-manual.sh: Call the 'web-manual' make target
	instead of building the documentation files in 'doc/' explicitly.
	Adjust the commands to copy the just-generated files accordingly.
	Remove the PostScript format as that does not get generated by the
	'web-manual' target; it is probably no longer used nowadays anyway.

	* NEWS (Documentation Changes): Mention the change.

	Reported by Charles Burkitt <cecburkitt@gmail.com> in
	https://lists.gnu.org/r/bug-findutils/2021-10/msg00008.html

2021-10-10  Renaud Pacalet  <renaud.pacalet@telecom-paristech.fr>  (tiny change)

	doc: fix typo in "Full Name Patterns"
	* doc/find.texi (subsection Full Name Patterns): Change 2nd '-wholename'
	to '-iwholename' to complete the enumeration of related options.
	Fixes https://savannah.gnu.org/bugs/?61303

2021-09-20  Bernhard Voelker  <mail@bernhard-voelker.de>

	oldfind: remove
	The FTS-based find is the default for a long time; oldfind has not been
	installed since 4.5.18 (2015), and was only just used in tests.

	* NEWS: Document the change.
	* doc/find-maint.texi (Factor Out Repeated Code): Remove mentioning of
	oldfind.
	* find/.gitignore (/oldfind): Remove entry.
	* find/Makefile.am (check_PROGRAMS): Remove.
	(oldfind_SOURCES): Remove.
	* find/defs.h (struct dir_id): Remove, it was only used in oldfind.c.
	(symlink_handling): Likewise.
	Adjust comments wrt oldfind otherwise.
	* find/oldfind.c: Remove.
	* find/testsuite/config/unix.exp: Remove the code to search for and
	to run tests with oldfind.
	* find/testsuite/find.posix/dotdotfiles.exp: Adjust comment.
	* po/POTFILES.in (find/oldfind.c): Remove entry.
	* tests/find/debug-missing-arg.sh: Remove run with oldfind.
	* tests/find/exec-plus-last-file.sh: Likewise.
	* tests/find/execdir-fd-leak.sh: Likewise.
	* tests/find/many-dir-entries-vs-OOM.sh: Likewise.
	* tests/find/name-lbracket-literal.sh: Likewise.
	* tests/find/printf_escape_c.sh: Likewise.
	* tests/find/printf_escapechars.sh: Likewise.
	* tests/find/printf_inode.sh: Likewise.
	* tests/find/refuse-noop.sh: Likewise.
	* tests/find/type_list.sh: Likewise.
	* tests/local.mk (built_programs): Remove oldfind from list.

2021-09-19  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: improve readability of --help output
	* find/util.c (usage): Start sentences with upper case.
	Add extra newlines to put each section (operators, options, tests, and
	actions) on its own line.
	Move the typical generic options --help and --version to the end.
	* NEWS (Documentation Changes): Mention the change.

2021-09-18  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: generate ChangeLog with --no-cluster
	* build-aux/gen-changelog.sh: Call gitlog-to-changelog with the
	--no-cluster option.  The resulting ChangeLog reads better, because
	each commit get its own date/author line.

2021-09-18  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: remove redundant function error_severity and avoid magic numbers
	The struct state field exit_status is only set to 0 (EXIT_SUCCESS) or
	to 1 (EXIT_FAILURE) throughout the code.
	Therefore, remove the more complicated wrapper function error_severity
	which was only used in very few cases anyway.
	While at it, replace the above magic numbers by EXIT_OKAY/EXIT_SUCCESS.

	* find/defs.h (error_severity): Remove.
	* find/util.c (error_severity): Remove, and update all callers by replacing
	it by the direct assignment to state.exit_status.
	(get_statinfo): Use the above better names.
	(report_file_err): Likewise.
	* find/exec.c (launch): Likewise.
	* find/ftsfind.c (consider_visiting): Likewise.
	(find): Likewise.
	(process_all_startpoints): Likewise.
	(main): Likewise.
	* find/pred.c (pred_delete): Likewise.
	(pred_empty): Likewise.
	(match_lname): Likewise.
	(pred_xtype): Likewise.
	* find/print.c (do_fprintf): Likewise.

2021-09-18  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: fix typos in comments
	* find/tree.c (get_expr): Add missing closing paren.
	* find/util.c (insert_primary): s/insure/ensure/
	(fatal_nontarget_file_error): s/isssue/issue/
	* xargs/xargs.c (XargsStatusValues): s/exites/exited/

2021-08-18  Bernhard Voelker  <mail@bernhard-voelker.de>

	tree.c: avoid segfault with closing parenthesis ')' after -files0-from
	Prompted by the following warning of GCC-11.1.1:

	  tree.c: In function 'get_expr':
	  tree.c:140:31: warning: dereference of NULL 'prev_pred' [CWE-476] \
	  [-Wanalyzer-null-dereference]
	    140 |       if ((UNI_OP == prev_pred->p_type
	        |                      ~~~~~~~~~^~~~~~~~

	Former versions of find are not vulnerable to this, because a closing
	parenthesis ')' without anything before was treated as a pathname
	rather than an option.
	But this is possible now with the recent introduction of the -files0-from
	option (see commit 11576f4e6a) - yet still an invalid invocation.
	Reproducer for a crash:
	  $ find -files0-from FILE ')' -print
	  Segmentation fault (core dumped)

	In the similar case when the user didn't specify any action, and find(1)
	adds the default action via '( user-expr ) -print', the error diagnostic
	was very confusing, too:
	  $ find -files0-from FILE ')'
	  find: invalid expression; empty parentheses are not allowed.

	* find/tree.c (get_expr): Handle the cases when there's no predicate
	before CLOSE_PAREN, and output a useful error diagnostic.
	* tests/find/files0-from.sh: Add a test case for it.

2021-06-25  James Youngman  <james@youngman.org>

	Fix Savannah bug 60823: unescaped `@' in find.texi code example.

2021-05-08  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: add -files0-from option
	* bootstrap.conf (gnulib_modules): Add argv-iter and same-inode.
	* find/defs.h (struct options): Add files0_from and ok_prompt_stdin
	members.
	* find/ftsfind.c (argv-iter.h, same-inode.h, xalloc.h): Add #include
	for gnulib headers.
	(process_all_startpoints): Change loop over starting point arguments
	to a loop using the argv_iter gnulib module.
	* find/parser.c (parse_table): Add option.
	(parse_files0_from): Declare and define function.
	(insert_exec_ok): Set options flag ok_prompt_stdin to true for
	the -ok and -okdir action.
	* find/util.c (usage): Add new option.
	(set_option_defaults): Initialize new struct members.
	* doc/find.texi (node Starting points): Add new section describing
	the regular processing of starting points, and that with the new
	option.  Also mention in the description of -ok and -okdir that they
	conflict with the new option.
	* find/find.1: Document the new option here as well.
	* tests/find/files0-from.sh: Add test.
	* tests/local.mk (all_tests): Reference it.
	* NEWS (New features in find): Mention the new option.

2021-05-08  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	Run 'make update-gnulib-to-latest'.

	* bootstrap: Sync from gnulib/build-aux/bootstrap.
	* gnulib: Update to latest.

2021-05-04  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: fix typo in comment
	* xargs/testsuite/xargs.posix/rc-125.exp: s/compinent/component/

2021-05-04  Bernhard Voelker  <mail@bernhard-voelker.de>

	README: add GNU Project notice
	* README: Add section to attract more people towards the GNU project.
	Inspired by a suggestion from Jose E. Marchesi <jemarch@gnu.org> on
	the gnu-prog-discuss mailing list.

2021-04-23  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: fix typo in comments in parser.c
	* find/parser.c: s/fnd/find/; s/consiming/consuming/

2021-02-23  Andrew Gaul  <gaul@gaul.org>  (tiny change)

	updatedb: exclude s3fs filesystems by default
	s3fs is a popular way to access S3-compatible object storage.
	Its users have reported many bugs being surprised that updatedb crawls
	these remote storage systems which causes poor performance:
	https://github.com/s3fs-fuse/s3fs-fuse/issues?q=is%3Aissue+updatedb

	* locate/updatedb.sh (PRUNEFS): Add 'fuse.s3fs'.

2021-01-31  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: show environment variables in a consistent style
	In manual pages, set environment variables in bold;
	in the texinfo manual, use the @env{} macro consistently.
	Additionally, talk about PATH instead of $PATH in all manuals.

	* doc/find.texi: Do the above.
	* find/find.1: Likewise.
	* NEWS (Documentation Changes): Mention the fix.

	Reported by Helge Kreutzmann in
	https://savannah.gnu.org/bugs/?59963

2021-01-31  Helge Kreutzmann  <debian@helgefjell.de>  (tiny change)

	find.1: fix some formatting issues
	* find/find.1 (Safer `...` approach): When referring to stat(2), change
	the formatting so that only the function name 'stat' is set in bold,
	not the '(2)'.
	(Pruning ...): Change formatting of the tilde backup suffix in the example
	to use simple quoting without additional markup.

	Fixes https://savannah.gnu.org/bugs/?59963

2021-01-31  Bernhard Voelker  <mail@bernhard-voelker.de>

	xargs.1: clarify 'echo' as the default command
	The default command changed from '/bin/echo' to 'echo' in version 4.5.11,
	but the commit 804ff7b90e only adjusted the Texinfo manual.

	* xargs/xargs.1 (.SH DESCRIPTION): Change the default command here
	in the man page as well.

2021-01-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: post-release administrativa
	* NEWS: Add new dummy release header.

2021-01-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	build: fix linking on AIX7.2
	Linking on AIX7.2 fails:
	  ld: 0711-317 ERROR: Undefined symbol: .pthread_mutex_lock
	  ld: 0711-317 ERROR: Undefined symbol: .pthread_mutex_unlock

	Bruno Haible noticed that $(LIB_MBRTOWC) and $(LIB_SETLOCALE_NULL)
	expand to -lpthread on that platform, so let's add them to LDADD.

	Maybe we should better depend on a 'gnulib.mk' file generated by
	'gnulib-import' in the long run, but let's fix this issue with the
	simpler solution for now.

	* find/Makefile.am (LDADD): Add $(LIB_SETLOCALE_NULL) and $(LIB_MBRTOWC).
	* locate/Makefile.am (LDADD): Likewise.
	* xargs/Makefile.am (LDADD): Likewise.
	* lib/Makefile.am (regexprops_LDADD): Add definition.

2021-01-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	NEWS: update before release
	* NEWS: Prepare for the 4.8.0 release: minor re-ordering, and update
	entries with bug numbers.

2021-01-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: fix GCC format attribute of checked_fprintf
	* gnulib-local/lib/gcc-function-attributes.h: Rename
	_GL_ATTRIBUTE_FORMAT_PRINTF to _GL_ATTRIBUTE_FORMAT_PRINTF_STANDARD
	following gnulib's change:
	https://git.sv.gnu.org/cgit/gnulib.git/commit/?id=387d654c
	* find/print.c (checked_fprintf): Use it.

2021-01-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	Run 'make update-gnulib-to-latest'.  Let's use this latest version
	for the imminent 4.8.0 release.

	* bootstrap: Sync from gnulib/build-aux/bootstrap.
	* gnulib: Update to latest.

2021-01-07  Andreas Metzler  <ametzler@bebt.de>
	    Bernhard Voelker  <mail@bernhard-voelker.de>

	xargs: warn on conflicting options -L, -I, -n
	* xargs/xargs.c (warn_mutually_exclusive): Add function to output the
	new warning diagnostic.
	(main): Call the above new function in order to show a warning message
	if conflicting options (-L -l -I -i -n) are specified.
	* xargs/xargs.1: Explicitly document the fact that -L -l -I -i -n
	options are mutually exclusive and how xargs behaves when more than one
	of these options are specified.
	* doc/find.texi (node Conflicting xargs options): Likewise, add this
	section with examples.
	* xargs/testsuite/config/unix.exp (xargs_start): Replace the full path
	of the xargs executable in the stderr output file by its basename.
	* xargs/testsuite/xargs.gnu/P3-n1-IARG.xe: Add file containing the
	expected output with the new warning diagnostic.
	* xargs/testsuite/xargs.posix/L2-n2.xe: Likewise.
	* xargs/testsuite/xargs.posix/rc-123.xe: Likewise.
	* xargs/testsuite/xargs.sysv/l1n4.xe: Likewise.
	* xargs/testsuite/xargs/testsuite/xargs.gnu/P3-n1-IARG.exp: Ensure the
	error diagnostic is in C locale to avoid false positives in other locales.
	* xargs/testsuite/xargs.posix/L2-n2.exp: Likewise.
	* xargs/testsuite/xargs.posix/rc-123.exp: Likewise.
	* xargs/testsuite/xargs.sysv/l1n4.exp: Likewise.
	* tests/xargs/conflicting_opts.sh: Add test coverage for combinations
	of the mutually exclusive options -I -L and -n.
	* xargs/testsuite/Makefile.am (EXTRA_DIST_EXP): Reference the new tests.
	(EXTRA_DIST_XO): Reference the new *.xo files.
	(EXTRA_DIST_XE): Reference the new *.xe files.
	* NEWS (Improvements): Mention the change.


	Discussed at https://savannah.gnu.org/bugs/?52137
	Duplicate of https://savannah.gnu.org/bugs/?58156

2021-01-07  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: avoid warning for printing pid_t on Solaris 11
	The type pid_t is defined as long on Solaris 11.  Therefore, GCC
	issued a -Wformat warning there when attempting to print as %d.

	* find/exec.c: (launch): When writing the debug message, treat child_pid
	as the wider long type.

2021-01-07  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: avoid FP on Solaris 11
	'ls -i' outputs leading blanks before the inode number on Solaris 11.
	The 'exp' reference file should not contain them.

	* tests/find/printf_inode.sh (make_canonical): Strip off leading
	blanks.

2021-01-07  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: avoid overfull \hbox issues in find.texi
	"Overfull \hbox" results lines exceeding the page width, and therefore
	may not even be readable.  At least they are ugly.

	* doc/find.texi (node O_NOFOLLOW): Break long example lines into
	the next lines.  While at it, update the version in that example to
	4.8.0 (in good faith we'll have it in 2021), because we shouldn't
	have a "*-git" version there.

2021-01-05  Bernhard Voelker  <mail@bernhard-voelker.de>

	pred.c: remove unused code
	* find/pred.c (struct pred_assoc): Remove.
	(pred_table): Remove.

2021-01-05  Bernhard Voelker  <mail@bernhard-voelker.de>

	xargs: mention in --help that -I splits input at newlines
	* xargs/xargs.c (usage): Amend the -I description to mention that
	the input is split at newlines.
	* NEWS: Mention the change.

	Fixes https://savannah.gnu.org/bugs/?58149

2021-01-04  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	Run 'make update-gnulib-to-latest', mainly for these two commits:

	  > free-posix: Work around GCC mis-optimization bug.
	  > getgroups test: Avoid warning with glibc >= 2.32 and gcc >= 10.

	* gnulib: Update to latest.

2021-01-04  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests/find/used.sh: make more robust
	This test was prone to false-positive errors due to sub-second rounding
	issues.  Failures have been seen on openSUSE's build system.

	* tests/find/used.sh: Use larger time intervals for the future access
	times of the test files (compared to the '-used N' search), and adjust
	the expected output accordingly.

2021-01-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	Run 'make update-gnulib-to-latest', mainly to update the copyright
	year numbers with:

	  > maint: run 'make update-copyright'

	* bootstrap: Sync from gnulib/build-aux/bootstrap.
	* gnulib: Update to latest.
	* tests/init.sh: Sync from 'gnulib/tests/init.sh'.

2021-01-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update copyright year number ranges
	Run 'make update-copyright'.

	* lib/regexprops.c (copying): Update the year number manually.
	The format of the copyright year number range in Texinfo files is
	"YEAR1--YEAR2" now, i.e., with 2x '-'.
	* tests/sample-test: Likewise, here to avoid starting a year number range.
	* All other files: Update copyright years via the above make run.

2021-01-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: exempt 'doc/fdl.texi' from 'make update-copyright'
	This file is a copy from gnulib and therefore should not get changed
	by the yearly update.

	* .x-update-copyright: Add pattern for that file.

2020-12-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	NEWS: mention the recent documentation changes
	* NEWS (Documentation Changes): Document the changes of the previous
	couple of man page and Texinfo manual changes.

2020-12-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	find.1: remove vague mentioning of "Finding Files" from BUGS section
	The user probably doesn't know that the reference to "Finding Files"
	means to consult the Texinfo manual.  It seems to be sufficient to
	note that -exec is more insecure than -execdir, so remove the reference,

	* find/find.1 (.SH BUGS): Remove reference as described above.
	While at it, remove the empty .P and the end of the section.

2020-12-30  Andreas Metzler  <ametzler@bebt.de>

	find.1: fix various other issues
	Namely:
	- When referencing C system or library functions, refer to their
	  man pages.
	- Avoid oddly boldfaced ',' after a filename value.
	- Remove superfluous ',' in the description of %h.
	- Avoid extra space before comme after a boldfaced value.

	* find/find.1: Do the above.

	Reported by Helge Kreutzmann in
	https://savannah.gnu.org/bugs/?59745

2020-12-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	find.1: avoid confusing brackets a sentence
	Two side notes in brackets in one sentence are disturbing the
	reading flow.

	* find/find.1 ("-exec command {} +"): Avoid having two bracketed side
	notes in one sentence; borrow the better description from the Texinfo
	manual.

	Reported by Helge Kreutzmann in
	https://savannah.gnu.org/bugs/?59745

2020-12-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: minor grammar change about a change in the past
	In the description of -name patterns matching "hidden" files, i.e.,
	those beginning with a dot, avoid talking in the future.
	The change was back in version 4.2.2.
	Maybe we should drop this hint about historic behavior at all.

	* doc/find.texi (Base Name Patterns): Remove the word "will".
	* find/find.1 (.SH STANDARDS CONFORMANCE): Likewise.
	(.SH HISTORY): Likewise.

2020-12-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	find.1: improve formatting of EXAMPLES section
	The EXAMPLES sesction was hard to read because it was not clear to
	which sentence a sample command belonged.  Use '.SS' and '.IP' markup,
	and also indent the sample commands nicer.
	Furthermore, change the formatting of file names as italice consistently.
	Avoid empty lines, by either explicitly marking as empty via '.', or
	by adding the invisible zero-width character '\&'.

	* find/find.1 (.SH EXAMPLES): Do the above.

2020-12-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	find.1: fix and improve some more markups
	Mark whitespace in commands as non-breakable in more cases to avoid
	unwanted hyphenation in the middle of commands.  For this to work,
	some cases need to have some consecutive lines joined into one '.B'
	or '.BR', the latter may require quoting the first argument within "...".

	* find/find.1: Do the above.
	(.IP -path): Improve indentation using '.in +4m', and set filename
	as italic.
	(.BR "ls -l"): Escape the minus of the option.
	(.BR "\-size\ \-1\|048\|576c"): Add space before dot '.', the 2nd arg.
	(.B \-exec ... \e+): No need to escape '+': remove '\e'.
	(.B \-execdir ... \e+): Likewise.
	(POSIXLY_CORRECT): Set the strings '+zzz' and '/zzz' in the -perm
	description as italic.

2020-12-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	find.1: set filenames in italics
	man-pages(7) says:
	  Filenames [...] are always in italics, except in the SYNOPSIS
	  section, [...]

	Set filenames in italics, respectively change from boldface to italics.
	While at it, mark whitespaces in commands as non-breakable via '\ '
	to avoid unwanted hyphenation in the middle of commands.

	* find/find.1 (-regex): Do the above.
	(-exec,-execdir,-fprint): Likewise.

2020-12-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: avoid starting sentences with an option
	A sentence starting with an option looks odd:
	  "... starting-points.  -maxdepth 0 means only apply ..."

	* doc/find.texi (-maxdepth): Add "Using " to avoid having an option
	at the start of the sentence.
	(-mindepth): Likewise.
	* find/find.1: Likewise.
	While at it, mark the whitespace as non-breakable via '\ '.

	Reported by Helge Kreutzmann in
	https://savannah.gnu.org/bugs/?59745

2020-12-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	locate.1: improve formatting in BUGS section
	* locate/locate.1 (.SH "BUGS"): Set 'locate' in bold, and the -z option
	in italic.

2020-12-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: harmonize the end of the man pages
	The "BUGS" section also documented how to report bugs.  This is better
	done in a separate "REPORTING BUGS" section.  Add this section where
	missing.  In it, redirect the user to the "How to get help" section
	("#get-help") of the GNU findutils online page; also mention where
	to report translation issues.

	Bring the sections "SEE ALSO" and "COPYRIGHT" into the correct order,
	which is: "REPORTING BUGS", "COPYRIGHT" and finally "SEE ALSO".
	See 'man-pages(7)'.

	The "SEE ALSO" section now refers to both the corresponding node in
	the online HTML version of the Texinfo manual and lists the 'info' command.
	Sort the entries referring to other man pages: first by their manual
	section numbers, then alphabetically.

	While at it, add an empty line (directive '.') before all '.SH' section
	headers.

	* find/find.1: Do the above.
	* locate/locate.1: Likewise.
	* locate/locatedb.5: Likewise.
	* locate/updatedb.1: Likewise.
	* xargs/xargs.1: Likewise.

2020-12-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	updatedb.1: avoid Texinfo macro in man page
	* locate/updatedb.1 (DESCRIPTION): Replace @samp{} macro by .B setting,
	introduced in commit v4.6.0-44-g89ec0211.

2020-12-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	xargs.1: remove deprecated .PD macro
	Use of the .PD macro is discouraged, see:
	https://man7.org/linux/man-pages/man7/groff_man_style.7.html

	* xargs/xargs.1 (.SH OPTIONS): Remove all uses of the .PD macro.

2020-12-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	xargs.1: improve indentation of list of exit statuses
	* xargs/xargs.1 (EXIT STATUS): Use .RS + .IP + .RE to get a nicer
	indentation of the list of exit values.

2020-12-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: use gnulib *_safer functions consistently
	Avoid using fopen_safer and opendir_safer directly in favor of
	letting gnulib transparently doing the work via "dirent--.h" and
	"stdio--.h".

	* find/oldfind.c (dirent-safer.h): Replace include ...
	(dirent--.h): ... by this.
	(process_dir): Change opendir_safer to the regular opendir call.
	* find/sharefile.c (stdio-safer.h): Replace include ...
	(stdio--.h): ... by this.
	(sharefile_fopen): Change fopen_safer to regular fopen call.
	* lib/fdleak.c (dirent-safer.h): Replace include ...
	(dirent--.h): ... by this.
	(get_proc_max_fd): Change opendir_safer to regular opendir call.

2020-12-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: use more *-safer gnulib modules
	See section "Handling closed standard file descriptors" in the gnulib
	manual.

	* bootstrip.conf (gnulib_modules): Add fcntl-safer, openat-safer
	and unistd-safer.
	* find/exec.c: Include "fcntl--.h" to use the *-safer variant of open()
	or openat().
	* find/pred.c: Likewise.
	* locate/locate.c: Likewise.
	* xargs/xargs.c: Likewise, and include "unustd--.h" to use the *-safer
	variant of pipe().

2020-11-22  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: relate -anewer, -cnewer, and -newer to their -newerXY equivalents
	* doc/find.texi (Comparing Timestamps): Clarify that the above options
	are equivalent to the options -neweram, -newercm and -newermm.

	Suggested by Reuben Thomas.

2020-10-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: fix bug URL in ChangeLog entry
	* build-aux/git-log-fix (v4.7.0-15-g6e55ad98): Tweak ChangeLog entry
	for this commit during 'make dist' to reference the bug system on
	Savannah instead of that on debbugs.gnu.org.

	Reported by Axel Beckert in
	    https://sv.gnu.org/bugs/?57291

2020-10-25  Andreas Metzler  <ametzler@bebt.de>

	updatedb.1: fix formatting
	* locate/updatedb.1 (--prunepaths): Use apostrophe instead of acute accent.

2020-10-25  Andreas Metzler  <ametzler@bebt.de>

	find.1: fix typo "onthe"
	* find/find.1 (-quit): Change to "on the".

2020-10-21  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	Run 'make update-gnulib-to-latest', mainly for these two commits:
	  > selinux-at, selinux-h: port to SELinux 3.1
	  > parse-datetime: Make the build rule work with parallel 'make'.

	* gnulib: Update to latest.

2020-10-19  Bernhard Voelker  <mail@bernhard-voelker.de>

	build: disable -Wformat-nonliteral
	GCC-10.2.1 complains about format strings it was not able to check:

	  print.c:529:11: warning: format not a string literal, format string not \
	                           checked [-Wformat-nonliteral]
	    529 |           strftime (altbuf, buf_size, timefmt, &altered_time);
	        |           ^~~~~~~~

	* configure.ac (compiler-warnings): Add -Wformat-nonliteral.

2020-10-19  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: avoid deprecation warnings with libselinux 3.1
	Libselinux 3.1 deprecates typedef 'security_context_t', leading to
	several warnings like:

	  defs.h:330:5: warning: ‘security_context_t’ is deprecated [-Wdeprecated-declarations]
	    330 |     security_context_t scontext; /* security context */
	        |     ^~~~~~~~~~~~~~~~~~

	Replace all matches of 'security_context_t' by 'char *'.

	* find/defs.h (struct predicate.args.scontext): Change to 'char *'.
	(x_getfilecon): Adjust type of 3rd parameter.
	* find/parser.c (fallback_getfilecon): Adjust type of 3rd parameter.
	(optionh_getfilecon): Likewise.
	(optionl_getfilecon): Likewise.
	(optionp_getfilecon): Likewise.
	* find/pred.c (pred_context): Adjust type of 'scontext' variable.
	* find/print.c (do_fprintf): Likewise.

2020-10-19  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: add error handling for strdup in the '-print %h' case
	* find/print.c (do_fprintf): Change strdup call to xstrdup to ensure
	proper error handling.  Reported by Infer.

	Fixes https://sv.gnu.org/bugs/?59133

2020-10-07  Kamil Dudka  <kdudka@redhat.com>

	doc: avoid misunderstanding of '-printf %Ak' description
	* find/find.1 (-printf): Make it clear that the list of conversion
	specification characters of '%Ak' is incomplete; refer to the
	strftime() documentation.  While at it, document the F conversion
	character which yields 'yyyy-mm-dd'.
	* doc/find.texi (Time Formats): Likewise.
	* NEWS: Mention the improvement.

	Suggested in https://bugzilla.redhat.com/1882695

2020-09-17  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: improve '-D exec' debug output
	Previously, 'find -D exec' only gave helpful output right before the
	invocation of complete_pending_execdirs, i.e., not for every child
	execution of the -exec, -execdir, -ok and -okdir predicates.
	Make the 'exec' debug output more useful and consistent.

	* find/exec.c (launch): Output DebugExec diagnostics right before spawning
	the child process, and after getting its exit status (unless we already
	have regular error diagnotstic anyway, e.g. if the child has been
	terminated by a signal).
	* find/ftsfind.c (show_outstanding_execdirs): Remove.
	(find): Remove invocation of the above function, and simplify.
	* NEW: Mention the improvement.

	Suggested by Philip Rowlands in https://sv.gnu.org/bugs/?59083

2020-09-17  Bernhard Voelker  <mail@bernhard-voelker.de>

	find.1: use consistent quoting in example
	* find/find.1 (EXAMPLES): Use (aq...(aq consistently around the -exec
	arguments containing the placeholder '{}/...'.

	Suggested in https://sv.gnu.org/bugs/?59012

2020-09-16  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: fix typo in comment
	* find/util.c: s/insure/ensure/

2020-08-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: add examples for -maxdepth, -mindepth
	* doc/find.texi (-maxdepth): Add examples.
	(-mindepth): Reference them.

	Suggested by 積丹尼 Dan Jacobson <jidanni@jidanni.org> in
	https://lists.gnu.org/r/bug-findutils/2020-07/msg00006.html

2020-08-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: clarify that 'find -perm +MODE' is unrelated to umask
	* doc/find.texi (Test -perm pmode): Do the above.
	* NEWS: Mention the change.

	Reported by Mohamed Akram in
	    https://sv.gnu.org/bugs/?58654

2020-08-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: enhance description of tests accepting numeric arguments in find.1
	* find/find.1 (TESTS): Improve the description of tests accepting a
	numeric argument that they match "less than, more than or exactly" the
	given 'n', thus helping the user to remind to use '-n', '+n' or a bare
	'n' (as decribed at the top).
	* doc/find.texi (section find Expressions): Move section from chapter
	"Introduction" to "Finding Files".  The description about the general
	syntax of a find expression fits more naturally there, including the
	already existing part about numeric arguments.
	* NEWS: Mention the change.
	Suggested in https://sv.gnu.org/bugs/?57025 .

2020-08-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	find.1: clarify double dash '--' option
	* find/find.1: Document that the '--' option is not much useful for
	find, because if a path name following that would start with a `-',
	then find would treat it as an expression argument.
	* NEWS: Mention it.

	Reported by Andreas Metzler <ametzler@bebt.de> in
	https://sv.gnu.org/bugs/?58205

2020-08-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: display version of the GNU findutils on the title page
	The first page of the Texinfo documentation should display the package
	version the documentation corresponds to.  Also change the title
	from "Finding Files" to "GNU Findutils ..." to better reflect the
	package name.  These changes align the documentation better with
	that of other GNU packages like e.g. grep.

	* doc/find.texi: Do the above.  Furthermore, display the VERSION also
	in the first sentence after the @direntry list.
	While at it, enclose the FDL licence text in a @quotation block.
	* doc/find-maint.texi: Likewise.

2020-08-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: explicitly copy fdl-1.3 from gnulib
	* Makefile.am (update-gnulib-to-latest): Prompted by a probably
	accidental difference between gnulib's fdl.texi and fdl-1.3.texi
	(to be fixed in GNU standards first), change the command to
	explicitly copy version 1.3 of the FDL.
	* doc/fdl.texi: Update from 'gnulib/doc/fdl-1.3.texi'.

	See https://lists.gnu.org/r/bug-standards/2020-08/msg00000.html
	and https://lists.gnu.org/r/bug-gnulib/2020-07/msg00185.html

2020-08-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: change "allows to <verb>" to "allows <verb>ing"
	* doc/find.texi: Use gerund after "allows".
	As a side effect, this also avoids passive voice in some cases;
	active voice is usually clearer.

2020-08-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: fix typo in comment
	* find/ftsfind.c (inside_dir): s/currentl/currently/

2020-08-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: modernize example list of filesystem types for -fstype
	* doc/find.texi (-fstype): Mention more common types.

2020-07-20  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: remove fts from configuration chapter
	The corresponding configure option was removed with commit 42a28b0dfb.

	* doc/find.texi (node fts): Remove section.

2020-06-22  Bjarni Ingi Gislason  <bjarniig@rhi.hi.is>

	doc: fix warnings from "mandoc -Tlint" in man pages
	mandoc: ./find/find.1:313:2: WARNING: skipping paragraph macro: PP empty
	mandoc: ./find/find.1:607:1: WARNING: skipping paragraph macro: sp after PP
	mandoc: ./find/find.1:606:2: WARNING: skipping paragraph macro: PP empty
	mandoc: ./find/find.1:1678:2: WARNING: skipping paragraph macro: PP after SS
	mandoc: ./find/find.1:2063:2: STYLE: fill mode already enabled, skipping: fi
	mandoc: ./find/find.1:2302:2: WARNING: skipping paragraph macro: PP after SH
	mandoc: ./find/find.1:2400:2: WARNING: skipping paragraph macro: PP empty
	mandoc: ./find/find.1:2455:2: WARNING: skipping paragraph macro: PP after SH
	mandoc: ./locate/locate.1:282:2: WARNING: skipping paragraph macro: PP after SH
	mandoc: ./locate/locatedb.5:153:2: WARNING: skipping paragraph macro: PP after SH
	mandoc: ./locate/updatedb.1:128:2: WARNING: skipping paragraph macro: PP after SH
	mandoc: ./xargs/xargs.1:316:2: STYLE: fill mode already enabled, skipping: fi
	mandoc: ./xargs/xargs.1:327:2: STYLE: fill mode already enabled, skipping: fi

	* find/find.1: Remove superfluous paragraph macros.
	Remove superfluous requests ".fi".
	* locate/locate.1: Likewise.
	* locate/locatedb.5: Likewise.
	* locate/updatedb.1: Likewise.
	* xargs/xargs.1: Likewise.

2020-06-22  Bjarni Ingi Gislason  <bjarniig@rhi.hi.is>

	doc: fix warnings from "test-groff" in man pages
	Output is from: test-groff -b -mandoc -T utf8 -rF0 -t -w w -z

	  [ "test-groff" is a developmental version of "groff" ]
	  Input file is ././find/find.1
	  <./find/find.1>:365 (macro BR): only 1 argument, but more are expected
	  <./find/find.1>:380 (macro BR): only 1 argument, but more are expected
	  <./find/find.1>:1494 (macro BR): only 1 argument, but more are expected
	  <./find/find.1>:1496 (macro BR): only 1 argument, but more are expected
	  <./find/find.1>:1513 (macro BR): only 1 argument, but more are expected
	  [...]
	  Input file is ././locate/locate.1
	  troff: <./locate/locate.1>:167: warning: trailing space

	* find/find.1: Use a one-font (single letter) macro for a single argument.
	* locate/locate.1: Remove a trailing space in a "string".

2020-06-21  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: improve section 'Hard links' and fix 'find -L -samefile' description
	* doc/find.texi (Hard links): Clarify that 'find -L -samefile FILE'
	returns both hard links and symbolic links to FILE, and why.
	Further attempt to improve the wording of the whole section by
	avoiding wording like "you can ...", and instead describing more
	how find works and behaves for the -samefile, -inum and -links
	options.  Especially mention that -inum potentially returns files
	with the given inode number but yet are no hard links per definition:
	this happens if they are on a different file system, i.e., if they
	have a different device number.

	Fixes https://sv.gnu.org/bugs/?58458

2020-05-25  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: copy FDL from gnulib instead of using it as module
	Since the previous gnulib update, bootstrap outputs this warning:

	  Notice from module fdl:
	    Don't use this module! Instead, copy the referenced license file \
	    into your version control repository.

	See gnulib commit:
	  https://git.sv.gnu.org/cgit/gnulib.git/commit/?id=88fc5afbccc9

	* bootstrap.conf (gnulib_modules): Remove 'fdl'.
	* doc/fdl.texi: Add file as a copy of 'gnulib/doc/fdl.texi'.
	* doc/.gitignore (/fdl.texi): Remove to no longer ignore that file.
	* Makefile.am (update-gnulib-to-latest): Add command to sync the file.
	While at it, add the command to show the git status for
	'tests/init.sh' as well.

2020-05-25  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	Run 'make update-gnulib-to-latest', mainly for some performance
	improvement for FTS with -L:

	  > Tune fts for FTS_LOGICAL+FTS_NOSTAT

	* gnulib: Update to latest.

2020-05-23  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: fix typo in comment
	* find/tree.c (do_arm_swaps): s/evauating/evaluating/.

2020-04-22  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: bootstrap gnulib with --symlink
	* bootstrap.conf (gnulib_tool_option_extras): Add --symlink option.

2020-04-22  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: fix -used predicate
	* find/pred.c (pred_used): Reverse the check for the delta between
	the atime and ctime of the file to accomodate to how pred_timewindow
	is working.
	Also return false if atime < ctime.
	Bug introduced in FINDUTILS_4_3_3-1 in commit a4718831e17.
	* tests/find/used.sh: Add test.
	* tests/local.mk (all_tests): Reference the test.
	* NEWS (Bug Fixes): Mention the fix.

	Reported by Martin Schulte in
	<https://lists.gnu.org/r/bug-findutils/2019-11/msg00010.html>

2020-04-19  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest, to avoid FTS crash on XFS
	Run 'make update-gnulib-to-latest', mainly to pull in a fix for FTS
	to avoid a crash when traversing a heavily changed XFS file system:

	> fts: remove NOSTAT_LEAF_OPTIMIZATION

	* NEWS (Bug fixes): Mention the fix.
	* gnulib: Update to latest.
	* bootstrap: Sync from gnulib/build-aux/bootstrap.

	Discussed at:
	<https://lists.gnu.org/r/bug-gnulib/2020-04/msg00068.html>

2020-04-17  Kim Thor  <kim@thor.nu>  (tiny change)

	xargs.1: fix grammar issue
	* xargs/xargs.1 (BUGS): Remove extra "the".
	Fixes https://sv.gnu.org/bugs/?58193

2020-03-20  Bernhard Voelker  <mail@bernhard-voelker.de>

	build: remove 'withfts.m4' from distribution
	* m4/Makefile.am (EXTRA_DIST): Remove 'withfts.m4'; that file was removed
	with commit 42a28b0dfb.

2020-03-15  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: fix clean rule in doc/ directory
	'make clean' removed the file 'doc/find.texi' which is version controlled.

	* doc/Makefile.am (CLEANFILES): Remove 'find.texi' to avoid that the
	'clean' target removes that file.
	Bug introduced in commit v4.6.0-228-g755a22b9.

2020-03-15  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: ensure .deps/ in the project root is ignored by git
	* .gitignore (.deps/): Add entry.
	* find/.gitignore (/.deps/): Remove here.
	* lib/.gitignore: Likewise.
	* locate/.gitignore: Likewise.
	* xargs/.gitignore: Likewise.

2020-03-15  Bernhard Voelker  <mail@bernhard-voelker.de>

	build: remove --without-fts configure option
	Trying to use this option lead to this error since v4.5.17-6-gfc260795:
	  configure: error: Using --without-fts is not longer supported

	* configure.ac (FIND_WITH_FTS): Remove.
	* m4/withfts.m4: Remove file.
	* NEWS: Document this build-related change.

2020-03-15  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: prefer https:// over http:// in more places
	Use HTTPS for GNU, FSF, OpenGroup and Google URLs.

	* build-aux/update-online-manual.sh: Switch to HTTPS.
	* doc/find.texi (node Further Reading on Security): Likewise.
	* lib/buildcmd.c: Likewise in a comment.
	* NEWS: Likewise, and shorten a debbugs URL.

2020-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: fix issue in syntax-check
	* cfg.mk (sc_prohibit_colon_redirection): Don't expect `|` to denote
	the pipe character in git grep.
	Sync fix from:
	https://git.sv.gnu.org/cgit/coreutils.git/commit/?id=0e2d4e1425

2020-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: add sc_prohibit_or_fail syntax-check
	The shell tests should use `cmd ... || fail=1` for detecting errors.
	Add a syntax-check to ensure they don't use `cmd ... || fail` which
	is a noop.

	* cfg.mk (sc_prohibit_or_fail): Add syntax-check, borrowed from coreutils.

2020-02-14  Peter Frost  <peterwarrenfrost@gmail.com>  (tiny change)

	doc: fix typo
	* doc/find.texi (Name Directives): s/eample/example/
	* find/find.1 (EXAMPLES): Likewise.

	Fixes https://sv.gnu.org/bugs/?57807

2020-02-10  Hugo Gabriel Eyherabide  <hugogabriel.eyherabide@gmail.com>  (tiny change)

	find.1: fix grammar issue in the description of -P
	* find/find.1 (-P): Add "about".
	Fixes https://savannah.gnu.org/bugs/?57775

2020-02-10  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: avoid FP when run as root
	Test 'sv-bug-54171' produced a false-positive error as 'find' would
	not fail for an unreadable directory when run as root.
	Migrate the test to the newer shell-based tests, and add the
	'skip_if_root_' guard to avoid a false-positive.

	* find/testsuite/find.posix/sv-bug-54171.exp: Remove.
	* find/testsuite/find.posix/sv-bug-54171.xo: Remove.
	* find/testsuite/Makefile.am (EXTRA_DIST_XO, EXTRA_DIST_EXP): Remove the
	above deleted test.
	* tests/find/depth-unreadable-dir.sh: Add test.
	* tests/local.mk (all_tests): Reference it.

	Test FP introduced in commit v4.6.0-178-gdf4610d0.
	Fixes https://savannah.gnu.org/bugs/?57762
	and https://bugzilla.redhat.com/1799064

2020-01-06  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	Run 'make update-gnulib-to-latest', mainly to avoid a gnulib test failure.

	  > tests: Avoid GCC over-optimization caused by _GL_ARG_NONNULL attributes.

	* gnulib: Update to latest.

	Fixes: https://sv.gnu.org/bugs/index.php?57277

2020-01-01  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: avoid error from sc_prohibit_gnu_make_extensions
	Since last gnulib update, the above syntax-check rule fails:

	  Error: doc/Makefile: $< in a non implicit rule
	  find_mono.html: find.texi
	  ...
	  make: *** [maint.mk:439: sc_prohibit_gnu_make_extensions] Error 1

	* doc/Makefile.am (find_mono.html): Avoid $< in plain rules.
	(findutils.texi_html_node.tar.gz): Likewise.

	See also: <https://lists.gnu.org/r/bison-patches/2019-05/msg00017.html>

2020-01-01  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: adjust to split out xstrtol-error gnulib module
	* bootstrap.conf (gnulib_modules): Add the new module split from xstrtol.
	* locate/locate.c: Include "xstrtol-error.h" for xstrtol_fatal.

2020-01-01  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	Run 'make update-gnulib-to-latest', mainly to update the copyright
	year numbers with:

	  > maint: update copyright notices

	* bootstrap: Sync from gnulib/build-aux/bootstrap.
	* gnulib: Update to latest.
	* tests/init.sh: Sync from 'gnulib/tests/init.sh'.

2020-01-01  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update copyright year number ranges
	Run 'make update-copyright'.

	* lib/regexprops.c (copying): Update the year number manually.
	* tests/sample-test: Likewise, here to avoid starting a year number range.
	* All other files: Update copyright years via the above make run.

2020-01-01  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: add entries to 'doc/.gitignore'
	* doc/.gitignore (/find.html/, /find-maint.html/): Add entries for
	HTML output directories.
	(/find.pdf, /find-maint.pdf): Add entries for PDF files.
	(/find-maint.dvi, /find-maint.ps): Add entries for other formats.

2019-11-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	parser.c: avoid "Condition 'nflags' is always false" in parse_version
	* find/parser.c (parse_version): Remove 'nflags' variable.

	Found by cppcheck.

2019-11-25  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: adjust exemption list for sc_trailing_blanks
	* cfg.mk (exclude_file_name_regexp--sc_trailing_blank): Remove the
	regex part for 'find/testsuite/test_escapechars.golden' as that file
	was removed in commit v4.6.0-214-g3f6b28c4.

2019-11-25  Bernhard Voelker  <mail@bernhard-voelker.de>

	xargs: avoid trailing blank in -t,--verbose output
	'xargs -t' had a trailing blank in the output, e.g.:
	  $ echo a b | xargs -t 2>&1 | cat -e
	  echo a b $
	  a b$
	POSIX mandates that the constructed command line "shall be written
	to standard error, as it will be invoked", so avoid outputting the
	trailing blank.
	FWIW: This change still plays well with -p,--interactive, because
	POSIX says to just output "?..." as a prompt after the -t output.

	* xargs/xargs.c (print_args): Instead of outputting a blank after each
	cmd_argv[i], output a blank before each item unless for the first one.
	* tests/xargs/verbose-quote.sh: Remove trailing blanks from expected
	stderr.
	* xargs/testsuite/xargs.gnu/space-t-0.xe: Likewise.
	* xargs/testsuite/xargs.sysv/empty-t.xe: Likewise.
	* xargs/testsuite/xargs.sysv/empty_def-t.xe: Likewise.
	* xargs/testsuite/xargs.sysv/s25-t.xe: Likewise.
	* xargs/testsuite/xargs.sysv/space-t.xe: Likewise.
	* xargs/testsuite/xargs.sysv/trace.xe: Likewise.
	* NEWS: Mention the change.

	Reported by 積丹尼 Dan Jacobson <jidanni@jidanni.org> in:
	    https://sv.gnu.org/bugs/?57291

2019-11-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: use "symbolic link" instead of "symlink" consistently
	* doc/find.texi (-printf): Change the shorter term "symlink" to
	"symbolic link" for consistency with the rest of the Texinfo manual
	and the man page.
	(%Y): Likewise.
	* find/find.1 (%Y): Likewise.

	Suggested by 積丹尼 Dan Jacobson <jidanni@jidanni.org> in:
	  https://lists.gnu.org/r/bug-findutils/2019-11/msg00003.html

2019-09-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: fix typos in configure.ac
	* configure.ac: Fix 2 typos in comments.

2019-09-06  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: fix the command for pushing the tag in the release instructions
	* doc/find-maint.texi (Making Releases): When pushing the tag, refer to
	the remote name 'origin'.  Also avoid the --tags option because that
	would publish all local tags, i.e., not only the given one.  Use RELTAG
	instead of 'the-tag-name'.

2019-09-03  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: output PATH value in log files
	Adjust the PATH variable for the test setup a bit later, i.e., after
	'tests/init.sh' has turned on 'set -x', so that the PATH value appears
	in the test logfiles.

	* init.cfg (fu_path_prepend_): Wrap immediate path_prepend_ call into
	this new function.
	* tests/find/debug-missing-arg.sh: Use it - right after sourcing in
	'tests/init.sh'.
	* tests/find/exec-plus-last-file.sh: Likewise.
	* tests/find/execdir-fd-leak.sh: Likewise.
	* tests/find/many-dir-entries-vs-OOM.sh: Likewise.
	* tests/find/name-lbracket-literal.sh: Likewise.
	* tests/find/printf_escape_c.sh: Likewise.
	* tests/find/printf_escapechars.sh: Likewise.
	* tests/find/printf_inode.sh: Likewise.
	* tests/find/refuse-noop.sh: Likewise.
	* tests/find/type_list.sh: Likewise.
	* tests/misc/help-version.sh: Likewise.
	* tests/sample-test: Likewise.
	* tests/xargs/verbose-quote.sh: Likewise.

2019-09-01  James Youngman  <jay@gnu.org>

	doc: add missing newline in find.1, making some text non-bold.

2019-09-01  James Youngman  <jay@gnu.org>

	doc: Add instructions on how to access source via git in README.

2019-09-01  James Youngman  <jay@gnu.org>

	find: Clarify description of %f and %h.
	Fix https://savannah.gnu.org/bugs/index.php?35253
	* doc/find.texi (Name Directives): Clarify description of %f and %h.
	* find/find.1 (-printf): Likewise.
	* NEWS: mention this change.

2019-09-01  James Youngman  <jay@gnu.org>

	Fix Savannah bug 54730: additional examples for -quit.
	* doc/find.texi (-quit): add another example.
	* find/find.1 (-quit): add another example.
	(-exec): Point out that -exec my-command {} + -quit
	may not result in my-command being run.
	(EXAMPLES): add an example for -quit.
	* NEWS: mention this change.

2019-09-01  Andreas Metzler  <ametzler@bebt.de>

	Fix testsuite error on hurd and BSD related to ln
	* find/testsuite/find.gnu/samefile-p-brokenlink.exp: Pass "-P" option to
	enforce generation of hard link to symlink. link() behavior is
	"implementation-defined" by POSIX and BSD/hurd chose a different behavior
	than Linux.
	This fixes http://bugs.debian.org/826357, https://savannah.gnu.org/bugs/index.php?48135
	Also fix ln -s invocation to generate a valid symlink.
	* NEWS: Mention that Savannah bug #48135 is fixed.

2019-08-30  James Youngman  <jay@gnu.org>

	gnulib: update to current.

2019-08-30  James Youngman  <jay@gnu.org>

	gnulib: use nstrftime module instead of strftime.
	These modules are actually synonymous, it's just that the module name
	strftime is deprecated in favour of nstrftime.

2019-08-30  James Youngman  <jay@gnu.org>

	doc: updates to release instructions.
	Some additions to the release instructions:
	 - Run bootstrap to update .po files
	 - Enable fatal compiler warnings when performing the final build
	 - Set RUN_EXPENSIVE_TESTS when running tests
	 - Point out that configure.ac no longer contains the version.
	 - Add a new Savannah "Release" value for the new release.

2019-08-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: fix minor memory leak in sharefile handling
	When sharefile_fopen fails to open the given file, e.g. due to the lack
	of permissions, then the name of the file is not freed.

	$ valgrind -v --leak-check=full find/find . -maxdepth 0 -fprint /
	...
	==28139== 2 bytes in 1 blocks are definitely lost in loss record 2 of 11
	==28139==    at 0x483677F: malloc (in /usr/lib64/valgrind/vgpreload_memcheck-amd64-linux.so)
	==28139==    by 0x4923DBA: strdup (strdup.c:42)
	==28139==    by 0x409E80: sharefile_fopen (sharefile.c:150)
	==28139==    by 0x40CCA0: open_output_file (parser.c:3390)
	==28139==    by 0x40CFA8: parse_fprint (parser.c:1010)
	==28139==    by 0x408341: build_expression_tree (tree.c:1295)
	==28139==    by 0x403AF7: main (ftsfind.c:712)

	This memory leak is a trivial issue because find will terminate anyway
	due to the error.

	* find/sharefile.c (sharefile_open): Call entry_free instead of simple
	free to also free the strdup-ed filename.

2019-08-29  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: post-release administrativa
	* NEWS: Add new dummy release header.

2019-08-29  Bernhard Voelker  <mail@bernhard-voelker.de>

	NEWS: update version to 4.7.0

2019-08-29  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: improve warning when global option is specified after other argument
	Global options like -maxdepth should be specified before other arguments
	like tests, operators, etc.  The corresponding warning diagnostic was
	obviously misleading, so that at least the French and the German
	translations - and maybe even the English original - were not well
	understood by users.

	* find/parser.c (found_parser): Improve diagnostic, thus hopefully
	also avoiding translation issues.  Remove extra newline.

	Fixes https://sv.gnu.org/bugs/?56820

2019-08-29  James Youngman  <jay@gnu.org>

	doc: add some previously-missing steps to the release instructions.
	doc/find-maint.texi: point out that the version number in
	configure.ac also needs to be updated.  Point out that if you did the
	release update on a branch it needs to be merged and in any case that
	these changes need to be pushed to origin/master.  Also prompt the
	maintainer to check that the FTP upload actually worked.

2019-08-29  James Youngman  <jay@gnu.org>

	Fix missing word in NEWS.
	NEWS: add missing "the" in description of GNU_FINDUTILS_FD_LEAK_CHECK
	for xargs.

2019-07-29  Bernhard Voelker  <mail@bernhard-voelker.de>

	xargs: in -t,-p output, quote the command to be executed when needed
	To improve readability for the user, xargs(1) shall quote each part
	of the command to be executed when printing it to stderr, i.e. for
	the -t (--verbose) and -p (--interactive) options.  Example:
	  $ echo "some file" | ../xargs -p -I'{}' rm '{}.c' '{}.o'
	  rm 'some file.c' 'some file.o' ?...

	* xargs/xargs.c (print_args): Apply "shell-escape" quoting.
	* xargs/testsuite/xargs.gnu/space-t-0.xe: Adjust test.
	* tests/xargs/verbose-quote.sh: Add test.
	* tests/local.mk: Reference it.
	* README (Improvements): Mention the change.

2019-05-11  Bernhard Voelker  <mail@bernhard-voelker.de>

	gnulib: update to the latest
	Run 'make update-gnulib-to-latest'.

	* gnulib: Update.
	* tests/init.sh: Sync from 'gnulib/tests/init.sh'.

2019-05-11  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: change from gettext to gettext-h gnulib module
	This avoids this bootstrap warning:
	  Notice from module gettext:
	    This module is obsolete. Use the module 'gettext-h' instead to make
	    your program capable of internationalization, when GNU gettext is also
	    used.

	* bootstrap.conf (gnulib_modules): s/gettext/&-h/

2019-05-11  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: bump build prerequisite versions
	* bootstrap.conf (buildreq): Require at least autoconf-2.59,
	automake-1.11.2, and gettext-0.19.2.

2019-05-10  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: add PDF file to the online manual
	* build-aux/update-online-manual.sh: Add the PDF file.
	While at it, properly close the <LI> tags with </LI>.

2019-05-10  Bernhard Voelker  <mail@bernhard-voelker.de>

	find.1: correct description about -prune when -depth is in effect
	The -prune action always returns true, also if -depth is in effect.

	* find/find.1 (-prune): Remove the wrong statement that -prune would
	return false when -depth is given.  Furthermore, move the example down
	from -path.

	Reported by Cristian Zoicas in
	https://lists.gnu.org/r/bug-findutils/2019-04/msg00024.html

2019-05-05  James Youngman  <jay@gnu.org>

	Fixes for 'make syntax-check'.
	* doc/Makefile.am: Remove trailing newlines.

2019-05-05  Pavel Modilaynen  <pavelmn@axis.com>  (tiny change)

	xargs: use GNU_FINDUTILS_FD_LEAK_CHECK as for find
	Utilize GNU_FINDUTILS_FD_LEAK_CHECK environment variable
	to enable/disable fd leak check for xargs the same way as
	for find.

	* find/defs.h: Remove prototype for fd_leak_check_is_enabled().
	* find/util.c: Remove implementation of fd_leak_check_is_enabled().
	* lib/fdleak.c: Add implementation of fd_leak_check_is_enabled().
	* lib/fdleak.h: Add prototype for fd_leak_check_is_enabled().
	* xargs/testsuite/config/unix.exp: Enable GNU_FINDUTILS_FD_LEAK_CHECK
	for all tests.
	* xargs/xargs.c: Execute complain_about_leaky_fds when
	fd_leak_check_is_enabled returns true.
	* NEWS (Improvements): Document support of GNU_FINDUTILS_FD_LEAK_CHECK
	by xargs.

2019-05-05  James Youngman  <jay@gnu.org>

	doc: add a tool for updating the online manual.
	* build-aux/update-online-manual.sh: add a script (originally
	written in 2005 but not previously included in the source
	distribution) which automates the updating of the online manual.
	* doc/Makefile.am: Add some targets useful for update-online-manual.sh.
	* doc/find-maint.texi (Documentation): Explain how to check out
	the web pages and how to update the findutils documentation there.

2019-05-04  James Youngman  <jay@gnu.org>

	doc: fix bug #56142 by specifying which actions inhibit the default -print
	* find/find.1: specify which actions inhibit the default -print
	action.
	* doc/find.texi (find Expressions): Likewise.

2019-04-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: clarify find options -newer, -anewer, -cnewer
	The previous description "File was modified more recently than file."
	was hard to understand without markup, e.g. over the phone.

	Furthermore, the description for symbolic links as reference file was
	wrong in the man page for the -anewer and -cnewer options: in fact,
	find(1) always uses the mtime of the reference file.

	* doc/find.texi (Comparing Timestamps): Improve the wording for the
	-anewer/-cnewer/-newer options.  Use 'reference' as the argument name.
	Add the note from find.1 that the -H/-L options make find(1) use
	the data modification time of the file being referenced.
	* find/find.1 (-anewer,-cnewer,-newer): Improve the wording, and use
	'reference' as argument name.
	Fix the description for -anewer/-cnewer: when -H/-L is used with a
	symbolic link as reference, then find always uses the mtime of that,
	not atime or ctime.

	Reported by Dan Jacobson <jidanni@jidanni.org> in
	https://lists.gnu.org/r/bug-findutils/2019-04/msg00002.html

2019-02-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: make pred_empty safer and avoid fd leaks
	There is a small race condition between the previous stat call
	and openat/fdopendir (which cannot be avoided): if the directory
	got replaced by another file type, then openat would succeed but the
	subsequent fdopendir would fail with ENOTDIR.  Detect this earlier
	by passing the O_DIRECTORY flag.
	Furthermore, the opened file descriptor was leaked in that case
	(bug introduced in FINDUTILS_4_3_2-1-80-gb46b0d89 in 2007).
	Later on, after a readdir error, also the directory stream was leaked
	(bug introduced by myself in commit 7a6e548690b1).

	* find/pred.c (pred_empty): Add more flags to the openat call,
	especially O_DIRECTORY; inspired by gnulib's opendirat module.
	Close the file descriptor when fdopendir failed.
	Close the directory stream when readdir failed.

2019-01-22  Bernhard Voelker  <mail@bernhard-voelker.de>

	build: ensure no VLA is used
	Cause developer builds to fail for any use of a VLA.
	VLAs (variable length arrays) limit portability.

	* configure.ac (findutils_gnulib_noise_warnings): Remove as the only
	suppressed warning for gnulib was -Wvla, thus enabling the warning
	when configured with --enable-compiler-warnings.
	(compiler-warnings-are-errors): Likewise.
	(GNULIB_NO_VLA) Define, disabling use of VLAs in gnulib.  This commit
	is functionally equivalent to coreutils' v8.30-44-gd26dece5d

	Discussed for other GNU packages in:
	https://lists.gnu.org/r/coreutils/2019-01/msg00058.html

2019-01-22  Bernhard Voelker  <mail@bernhard-voelker.de>

	gnulib: update to the latest
	Run 'make update-gnulib-to-latest'.

	* gnulib: Update to a version supporting GNULIB_NO_VLA.

2019-01-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: remove last traces of old shell tests
	* find/testsuite/Makefile.am (test_shell_progs): Remove.
	(EXTRA_DIST): Remove $(test_shell_progs) and 'binary_locations.sh'.
	(TESTS): Remove.
	* find/testsuite/binary_locations.sh: Remove utility script.

2019-01-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: migrate 'type_list' to the new testsuite
	Make this test a "check-root" test to increase test coverage.
	This test runs for non-privileged users as well, but skips the tests
	for block and character devices as mknod(1) will fail with EPERM.

	* find/testsuite/test_type-list.sh: Move to ...
	* tests/find/type_list.sh: ... this, and apply the above.
	Simplify, and make more robust.
	* find/testsuite/Makefile.am (tests_shell_progs): Remove the reference
	to this test ...
	* tests/local.mk (all_root_tests): ... and add it here.

2019-01-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: migrate 'debug-missing-arg' to the new testsuite
	* find/testsuite/sv-52220.sh: Move to ...
	* tests/find/debug-missing-arg.sh: ... this, and apply the above.
	Simplify, and make more robust.
	* find/testsuite/Makefile.am (tests_shell_progs): Remove the reference
	to this test ...
	* tests/local.mk (all_tests): .. and add it here.

2019-01-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: migrate 'refuse-noop' to the new testsuite
	* find/testsuite/sv-48180-refuse-noop.sh: Move to ...
	* tests/find/refuse-noop.sh: ... this, and apply the above.
	Simplify, and make more robust.
	* find/testsuite/Makefile.am (tests_shell_progs): Remove the reference
	to this test ...
	* tests/local.mk (all_tests): .. and add it here.

2019-01-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: migrate 'exec-plus-last-file' to the new testsuite
	* find/testsuite/sv-48030-exec-plus-bug.sh: Move to ...
	* tests/find/exec-plus-last-file.sh: ... this, and apply the above.
	Simplify, and make more robust.
	* find/testsuite/Makefile.am (tests_shell_progs): Remove the reference
	to this test ...
	* tests/local.mk (all_tests): .. and add it here.

2019-01-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: migrate 'execdir-fd-leak' to the new testsuite
	* find/testsuite/sv-34976-execdir-fd-leak.sh: Move to ...
	* tests/find/execdir-fd-leak.sh: ... this, and apply the above.
	Simplify, and make more robust.
	* find/testsuite/Makefile.am (tests_shell_progs): Remove the reference
	to this test ...
	* tests/local.mk (all_tests): .. and add it here.

2019-01-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: migrate 'printf_inode' to the new testsuite
	* find/testsuite/test_inode.sh: Move to ...
	* tests/find/printf_inode.sh: ... this, and apply the above.  Simplify.
	* find/testsuite/Makefile.am (tests_shell_progs): Remove the reference
	to this test ...
	* tests/local.mk (all_tests): .. and add it here.

2019-01-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: migrate 'printf_escape_c' to the new testsuite
	* find/testsuite/test_escape_c.sh: Move to ...
	* tests/find/printf_escape_c.sh: ... this, and apply the above.  Simplify.
	* find/testsuite/Makefile.am (tests_shell_progs): Remove the reference
	to this test ...
	* tests/local.mk (all_tests): .. and add it here.

2019-01-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: migrate test 'printf_escapechars' to the new testsuite
	For migrating, merge with the basic structure from 'tests/sample-test',
	i.e., source in 'tests/init.sh', call 'print_ver_', "Exit $fail",  etc.
	Also remove now-common functions like die() and framework_failure_().

	* find/testsuite/test_escapechars.golden: Remove, as the axpected output
	is created on the fly by the new test.
	* find/testsuite/test_escapechars.sh: Move to ...
	* tests/find/printf_escapechars.sh: ... this, and apply the above.
	Create the expected output on the fly, and also check for the expected
	error diagnostic on stderr.
	* find/testsuite/Makefile.am (EXTRA_DIST_GOLDEN): Remove.
	(EXTRA_DIST): Remove $(EXTRA_DIST_GOLDEN).
	(tests_shell_progs): Remove the reference to this test ...
	* tests/local.mk (all_tests): .. and add it here.

2019-01-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: migrate 'name-lbracket-literal' to the new testsuite
	For migrating, merge with the basic structure from 'tests/sample-test',
	i.e., source in 'tests/init.sh', call 'print_ver_', "Exit $fail",  etc.
	Also remove now-common functions like die() and framework_failure_().

	* find/testsuite/sv-bug-32043.sh: Move to ...
	* tests/find/name-lbracket-literal.sh: ... this, and apply the above.
	Simplify.
	* find/testsuite/Makefile.am (tests_shell_progs): Remove the reference
	to this test ...
	* tests/local.mk (all_tests): .. and add it here.

2019-01-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: migrate 'many-dir-entries-vs-OOM' to the new testsuite
	For migrating, merge with the basic structure from 'tests/sample-test',
	i.e., source in 'tests/init.sh', call 'print_ver_', "Exit $fail",  etc.
	Also remove now-common functions like die() and framework_failure_().

	* find/testsuite/sv-34079.sh: Move to ...
	* tests/find/many-dir-entries-vs-OOM.sh: ... this, and apply the above.
	While at it, loosely pull in changes from the related test in the
	GNU coreutils [1]:
	Create only 200,000 files, rather than 4 million.  The latter was overkill,
	and was too likely to fail due to inode exhaustion.  Now that this test
	doesn't take so long, label it as merely "expensive", rather than
	"very expensive".
	Furthermore, simplify the test data creation, and use the ulimit specifically
	for each program under test (find, oldfind).
	* find/testsuite/Makefile.am (tests_shell_progs): Remove the reference
	to this test ...
	* tests/local.mk (all_tests): .. and add it here.

	[1]
	https://git.sv.gnu.org/cgit/coreutils.git/tree/tests/rm/many-dir-entries-vs-OOM.sh?id=4711c49312d5

2019-01-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: add shell-style test framework
	Borrow the 'tests' framework from GNU coreutils.  This allows better
	shell-style tests with more control over stdin, stdout, stderr, signals,
	preparatory steps, cleanup, return code verification, root-only tests,
	etc.

	* .gitignore: Add entries for per-test *.log and *.trs files, and the
	'test-suite.log'.
	* .x-update-copyright: Exempt 'tests/init.sh' as this comes from gnulib.
	* Makefile.am: Include 'tests/local.mk'.
	(EXTRA_DIST): Add 'tests/GNUmakefile'.
	(SUBDIRS): Move 'gnulib-tests' to the end, i.e., run our own tests first.
	(ALL_RECURSIVE_TARGETS): Initialize.
	(update-gnulib-to-latest): Copy 'tests/init.sh' from gnulib.
	* cfg.mk: Add some syntax-check rules.
	* init.cfg: Add file.
	* tests/GNUmakefile: Likewise.
	* tests/envvar-check: Likewise.
	* tests/init.sh: Likewise.
	* tests/lang-default: Likewise.
	* tests/local.mk: Likewise.
	* tests/misc/help-version.sh: Likewise.
	* tests/other-fs-tmpdir: Likewise.
	* tests/sample-test: Likewise.
	* tests/.gitignore: Likewise.
	* NEWS (Changes to the build process): Mention the new test framework.

2019-01-08  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: add NEWS entry for bug #55272
	* NEWS (Bug Fixes): Add news entry for the change in commit 66174c10c6.

2019-01-05  Bernhard Voelker  <mail@bernhard-voelker.de>

	build: work around dependency issue of 'make' on the BSDs
	'make' on all of FreeBSD, NetBSD and OpenBSD fails to understand that
	'./libfindtools.a' and 'libfindtools.a' are the same, and - unless one
	builds that target manually - fails with:

	  make[3]: don't know how to make ./libfindtools.a. Stop

	* find/Makefile.am (LDADD): Change './libfindtools.a' to 'libfindtools.a'.

2019-01-05  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: improve warning diagnostic for the -name/-iname with '/' in pattern
	* find/parser.c (check_name_arg): Add parameter ALT for the alternative
	option to suggest.  Avoid confusing quoting in the warning by making
	the message more terse.
	(parse_iname): Pass "-iwholename" as alternative parameter.
	(parse_name): Pass "-wholename" as alternative parameter.

	Reported by Andreas Metzler in
	    https://sv.gnu.org/bugs/?55272

2019-01-05  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: fix typo in comment
	* find/parser.c (found_parser): s/fid/find/ in a comment.

2019-01-04  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update copyright year number ranges
	Run 'make update-copyright'.

	* lib/regexprops.c (copying): Update the year number manually.
	* All other files: Update copyright years via the above make run.

2019-01-04  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	Run 'make update-gnulib-to-latest', mainly to update the copyright
	year numbers with:

	> maint: Run 'make update-copyright'

	* bootstrap: Sync from gnulib/build-aux/bootstrap.
	* gnulib: Update to latest.

2018-12-12  Bernhard Voelker  <mail@bernhard-voelker.de>

	gnulib: use https URL scheme instead of git
	This is apparently more secure (against MITM attacks).

	* .gitmodules (gnulib): Change url scheme from "git://" to "https://".

	Discussed at:
	https://lists.gnu.org/r/bug-gnulib/2018-12/msg00051.html

2018-12-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: avoid non-portable C99 printf size specifiers %z and %j
	* cfg.mk (sc_prohibit-c99-printf-format): Add SC rule.
	* find/parser.c (parse_time): Change %ju to PRIuMAX.
	(insert_num): Likewise.
	* xargs/xargs.c (xargs_do_exec): Change %zu to PRIuMAX.

2018-12-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: avoid continued strings
	* lib/bugreports.c (explain_how_to_report_bugs): Avoid continued strings
	by using multi-part strings, one per line.
	* cfg.mk (sc_prohibit_continued_string_alpha_in_column_1): Add SC rule.

2018-12-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: adjust preprocessor indentation via cppi
	Run 'cppi -a' for all *.[ch] files, and add a syntax-check rule for it.

	* cfg.mk (sc_preprocessor_indentation): Add rule.
	* find/defs.h: Run 'cppi -a' on this file.
	* find/fstype.c: Likewise.
	* find/oldfind.c: Likewise.
	* find/parser.c: Likewise.
	* find/pred.c: Likewise.
	* find/print.h: Likewise.
	* find/sharefile.h: Likewise.
	* gnulib-local/lib/gcc-function-attributes.h: Likewise.
	* lib/bugreports.h: Likewise.
	* lib/buildcmd.c: Likewise.
	* lib/buildcmd.h: Likewise.
	* lib/extendbuf.h: Likewise.
	* lib/fdleak.h: Likewise.
	* lib/findutils-version.h: Likewise.
	* lib/listfile.c: Likewise.
	* lib/printquoted.h: Likewise.
	* lib/regextype.h: Likewise.
	* lib/safe-atoi.h: Likewise.
	* lib/splitstring.h: Likewise.
	* lib/system.h: Likewise.
	* locate/locatedb.h: Likewise.
	* xargs/xargs.c: Likewise.

2018-12-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: remove configure option --enable-id-cache from README
	* README (--enable-id-cache): Remove here, as the option has already
	been removed in commit v4.6.0-11-gbcd85897.

2018-11-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: fix grammar issue in texinfo manual
	* doc/find.texi (Systems without O_NOFOLLOW): Remove superfluous 'the'.

	Reported by Martin Castillo in https://sv.gnu.org/bugs/?55022

2018-11-10  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: fix typo in comment in safe-atoi.c
	* lib/safe-atoi.c (safe_atoi): s/chack/check/

2018-11-10  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: remove already retired configure --enable-debug from README
	That configure option has been removed with commit 995151807658,
	so also remove it from README.

	* README (Special configure options): Do the above.

2018-11-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	Run 'make update-gnulib-to-latest'.

	* bootstrap: Sync from gnulib/build-aux/bootstrap.
	* gnulib: Update to latest.
	* configure.ac (AC_PREREQ): Change from very old 2.59 to current 2.69
	to avoid gnulib-tool complaining about "minimum supported autoconf
	version is 2.63".

2018-11-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: provide make target to update gnulib to latest
	* Makefile.am (gnulib-sync, update-gnulib-to-latest): Add targets to
	pull the latest commit of the gnulib submodule, and also to copy over
	the files we keep in sync.
	* doc/find-maint.texi (How to update Gnulib to latest): Add section.

2018-11-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: add '-D all' to enable all debug flags
	* find/defs.h (DebugOption): Add DebugAll, which includes all other
	debug options but DebugHelp.
	* find/util.c (debugassoc): Add an entry for DebugAll, and move DebugHelp
	to the end.
	* doc/find.texi (node Debug Options): Document the new option.
	* find/find.1: Likewise.
	* NEWS (Improvements): Likewise.

2018-11-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: use portable 'tail' call in texinfo example
	* doc/find.texi (node Updating A Timestamp File): Use more portable
	'tail -n1' instead of the deprecated form 'tail -1'.

2018-10-18  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: fix typo in 'xargs -l' examples in texinfo manual
	* doc/find.texi (node Controlling Parallelism): Change from 'xargs -1'
	(minus one) to 'xargs -l' (minus El) in three places.

	Reported by Ahmad ElKomey in
	https://sv.gnu.org/bugs/index.php?54859

2018-10-15  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: fix the examples of the -perm option in the texinfo documentation
	* doc/find.texi (Mode Bits): Move the misplaced '-perm -g+w,o+w' example
	up to the '-perm -022' example to where it belongs.  The former got
	accidentally separated from the latter in commit 7ade936bc2c4: the patch
	proposed in https://sv.gnu.org/bugs/?14619 was applied in the wrong place.
	* NEWS (Bug fixes): Mention the fix.

	Reported by Ahmad ElKomey in https://sv.gnu.org/bugs/?54838

2018-09-23  James Youngman  <jay@gnu.org>

	doc: don't mention indirect blocks.  Clarify how -size is measured.
	This fixes Savannah bug 36763.

2018-09-23  James Youngman  <jay@gnu.org>

	README: refer user to README-hacking when there is no INSTALL file.

2018-08-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: clarify again exit status handling of -exec command {} +
	A non-zero exit status of a command launched via the -exec predicate
	family only leads to a non-zero exit status of 'find' itself when
	the '+' form of the punctuation for the command is used.  This is
	also what POSIX requires [1].
	To put it the other way round: when the ';' form is used, the exit
	status of 'find' is not affected.

	[1] http://pubs.opengroup.org/onlinepubs/9699919799/utilities/find.html

	* find/find.1 (-exec ... +): Explicitly mention that the exit status of
	the launched command affects find's exit status when the '+' form is used.
	To allow a future change, deliberately leave the behavior for failing
	commands with the ';' form undocumented.
	(-execdir): Likewise.
	Previously, in the form committed with v4.6.0-63-gae424b95, that sentence
	did not explicitly limit the behavior to the '+' form, and therefore
	might have confused the user.

	Fixes https://sv.gnu.org/bugs/?54509

2018-08-08  Aron Barath  <baratharon@caesar.elte.hu>  (tiny change)

	fdleak.c: avoid compiler error on platforms lacking getrlimit
	* lib/fdleak.c (get_max_fd): Move definition of the fd_limit variable
	into the HAVE_GETRLIMIT block giving it a better scope: platforms
	lacking getrlimit probably also lack struct rlimit, too.

2018-07-26  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	* COPYING: Merge fom gnulib/doc/COPYINGv3.
	* bootstrap: Merge from gnulib/build-aux/bootstrap.
	* gnulib: Update, mainly to avoid the following warnings from GCC-8.1.1:
	  cc1: warning: -Wabi won't warn about anything [-Wabi]
	  cc1: note: -Wabi warns about differences from the most up-to-date ABI,\
	       which is also used by default
	  cc1: note: use e.g. -Wabi=11 to warn about changes from GCC 7

2018-07-24  Bernhard Voelker  <mail@bernhard-voelker.de>

	find -printf %Y: handle ENOTDIR also as broken symlink
	The above command should output 'N' (for broken symlinks) not only in
	the ENOENT case, but also when an intermediate part of the symlink target
	file name is a file (ENOTDIR):

	  $ touch file
	  $ ln -s file/ENOTDIR link
	  $ find link -printf '%Y %p\n'
	  N link

	Previously, find output 'l' as for a resolvable symlink.

	* find/print.c (do_fprintf): Treat ENOTDIR the same as ENOENT to detect
	broken symlinks.
	* find/testsuite/find.gnu/printf-symlink.exp: Extend the test, and ...
	* find/testsuite/find.gnu/printf-symlink.xo: ... the expected output.
	* NEWS (Bug fixes, #54262): Explicitly mention that both ENOENT and ENOTDIR
	are used to detect broken symlinks.

	Suggested by Tavian Barnes.

2018-07-24  Bernhard Voelker  <mail@bernhard-voelker.de>

	print.c: move 'else' into #ifdef S_ISLNK
	* find/print.c (do_fprintf): Move the 'else' statment into the #ifdef'ed
	block to avoid compilation failure on systems without S_ISLNK (although
	it seems nobody tried to build on such a platform since 2005).

	Bug introduced in commit 'FINDUTILS_4_2_23-1-63-g238d9547'.

2018-07-24  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: document -printf %Y output consistently
	* doc/find.texi (node Location Directives): Mention 'L' and '?' as well.
	* find/find.1 (%Y): Mention '?'.
	* NEWS (Documentation Changes): Mention the fix.

2018-07-24  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: fix -printf %Y output to 'N' for broken links
	The format %Y shall output 'N' for broken links (ENOENT), 'L' for ELOOP,
	and '?' for any other error when stat()ing the symlink target.

	The %Y implementation implicitly fell back to lstat(); therefore it
	output 'l' for dangling symlinks.

	  $ ln -s ENOENT DANGLE
	  $ find -D stat DANGLE -printf '%y %Y %p\n'
	  fallback_stat(): stat(DANGLE) failed; falling back on lstat()
	  l l DANGLE

	* find/print.c (do_fprintf): For %Y, always follow links to determine
	the type of the symlink target.
	* find/testsuite/find.gnu/printf-symlink.exp: Add a test case for broken
	links and the ELOOP case ...
	* find/testsuite/find.gnu/printf-symlink.xo: ... with the expected output.
	* NEWS (Bug fixes): Mention the fix.

	Bug introduced in version v4.5.8 with commit '25e7c5fbf9'.

2018-07-16  Christopher Leonard  <christopherthomasleonard@yahoo.com>  (tiny change)

	doc: improve readability of find-maint.texi
	* doc/find-maint.texi: s/fuly/fully/, and re-phrase some sentences,
	e.g. use active voice.

2018-07-11  Jim Meyering  <jim@meyering.net>

	maint: use gnulib's intprops module to avoid magic numbers
	* bootstrap.conf (gnulib_modules): Add intprops.
	* find/ftsfind.c (get_fts_info_name): Use the INT_BUFSIZE_BOUND macro
	to calculate the size of BUF.

2018-07-08  Bernhard Voelker  <mail@bernhard-voelker.de>

	ftsfind.c: avoid buffer overflow in -D code
	Reported by GCC 8.1.1:

	ftsfind.c: In function ‘get_fts_info_name’:
	ftsfind.c:164:23: warning: ‘%d’ directive writing between 1 and 11 bytes into a region of size 9 [-Wformat-overflow=]
	       sprintf (buf, "[%d]", info);
	                       ^~
	ftsfind.c:164:7: note: ‘sprintf’ output between 4 and 14 bytes into a destination of size 10
	       sprintf (buf, "[%d]", info);
	       ^~~~~~~~~~~~~~~~~~~~~~~~~~~

	* find/ftsfind.c (get_fts_info_name): Increase buffer from 10 to 14
	to be able to hold the 11-char string representation of the %d format,
	the surrounding '[' and ']', plus the terminating NULL character.

2018-07-08  Andreas Metzler  <ametzler@bebt.de>

	tests: test find -depth with unreadable directory
	* find/testsuite/find.posix/sv-bug-54171.exp: Add testcase ...
	* find/testsuite/find.posix/sv-bug-54171.xo: .. and expected output.
	* find/testsuite/Makefile.am: Include newly added tests in
	distribution.

2018-07-08  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: process unreadable directories with -depth
	* find/ftsfind.c (consider_visiting): Split the FTS_ERR and FTS_DNR
	cases to be able to continue processing that entry in the latter case
	(unreadable directory) when the -depth option is given.
	* NEWS (Bug Fixes): Mention the fix.

	Reported by Tavian Barnes in https://savannah.gnu.org/bugs/?54171.

2018-07-06  James Youngman  <jay@gnu.org>

	Shorten output of qmark_chars after replacing a multibyte characer.
	When qmark_chars() replaces a multibyte character with a single
	character, this reduces the length of the string.  When this happens,
	terminate the now-shorter string at the new length.

	This is simple workaround for bug http://savannah.gnu.org/bugs/?54236.

2018-06-23  Bernhard Voelker  <mail@bernhard-voelker.de>

	oldfind.c: port to GCC 8
	oldfind.c:277:1: error: function might be candidate for attribute 'malloc' if it is known to return normally [-Werror=suggest-attribute=malloc]
	 specific_dirname (const char *dir)
	 ^~~~~~~~~~~~~~~~

	* find/oldfind.c (specific_dirname): Mark with _GL_ATTRIBUTE_MALLOC.

2018-06-23  Bernhard Voelker  <mail@bernhard-voelker.de>

	xargs.c: port to GCC 8
	GCC 8 issues the following warning diagnostic:

	  xargs.c:1134:29: warning: '%u' directive output may be truncated writing \
	  between 1 and 10 bytes into a region of size 2 [-Wformat-truncation=]
	     static const char *fmt = "%u";
	                               ^~
	  xargs.c:1161:7: note: 'snprintf' output between 2 and 11 bytes into a \
	  destination of size 2
	         snprintf (buf, size+1, fmt, n);
	         ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	* xargs/xargs.c (set_slot_var): Simplify BUF handling to pacify GCC 8
	about safe use of snprintf wrt truncated writing.

2018-06-23  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	* gnulib: Do the above, mainly for:
	  > fts: treat CIFS like NFS
	  > fts: fix bug in find across filesystems
	* bootstrap: Update from gnulib/build-aux/bootstrap.

	This fixes a bug reported for Fedora which had already newer gnulib
	than what was upstream - here - in 4.6.0:
	  https://bugzilla.redhat.com/show_bug.cgi?id=1558249
	Reported by Kamil Dudka for gnulib in:
	  https://lists.gnu.org/r/bug-gnulib/2018-04/msg00015.html

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	* gnulib: Do the above.
	* bootstrap: Update from gnulib/build-aux/bootstrap.

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: port sv-48030-exec-plus-bug.sh to Alpine Linux
	On Alpine Linux v3.6, the test failed because the created 'tstcmd'
	script lacks a shebang - see shortened log:

	  + echo printf "%s\n" "$@"
	  + chmod +x bin/tstcmd
	  + PATH=/tmp/tmp.10fq3tSrnx/bin:...
	  + .../find/find bin -maxdepth 0 -exec tstcmd {} +
	  find: ‘tstcmd’: Exec format error
	  + [ = bin ]
	  sh: bin: unknown operand
	  + return 1

	* find/testsuite/sv-48030-exec-plus-bug.sh: Add a shebang to the
	generated 'tstcmd' script, and add quotes around the find call to
	avoid the "unknown operand" error.

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: skip sv-34079.sh properly if setting up the test fails
	The test exited as a test failure (exit 1) also when set-up failed,
	e.g. when running the test with TMPDIR on a file system with too
	few free inodes.  Instead, the test should exit with 77 to skip the
	test.  In other cases, exit properly with 99 to signal a test
	framework failure.

	* find/testsuite/sv-34079.sh (very_expensive_): Move the check for
	RUN_VERY_EXPENSIVE_TESTS to the beginning, thus decreasing the
	indentation level of the test code.  This is also a preparation
	step for moving this check to a central place.
	(skip_,framework_failure_): Define utility functions to skip the test
	or terminate it as a test framework failure.
	(get_ifree_): Define function to determine the number of free inodes.
	(make_test_data): Use it, and skip early if we know that there are too
	few free inodes on the current file system.
	Use "seq -f" to build the file names, and directly feed them via xargs
	to touch.  This avoids slower shell code.
	Skip the test if touch fails; previously, the test exited as FAIL.
	Move the creation of test files up, i.e., outside the if-condition,
	and use trap to remove the temporary directory at exit.

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: skip some tests unless seq(1) is available
	seq(1) is not required by POSIX and also not available on some
	systems, e.g. the *BSDs.  Skip tests requiring it.

	* find/testsuite/sv-34079.sh: Add a check whether seq(1) is available,
	and exit 77 (SKIP) otherwise.
	* find/testsuite/sv-48030-exec-plus-bug.sh: Likewise.

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	build: remove obsolete ALL_LINGUAS list
	The list of languages is in po/LINGUAS since gettext-0.11.
	Removing ALL_LINGUAS avoids the following warning:
	  config.status: setting ALL_LINGUAS in configure.in is obsolete

	* configure.ac (ALL_LINGUAS): Remove.
	* Makefile.am (findutils-check-pofiles): Remove check.
	(dist-hook): Remove dependency to findutils-check-pofiles.

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	build: remove PO files from version control
	Let bootstrap auto-update the PO files from "translationproject.org".

	* bootstrap.conf (SKIP_PO): Remove, thus letting bootstrap download
	the PO files now.
	* po/.gitignore: Add entries now created during the build.
	* doc/find-maint.texi (Internationalisation): Mention the change.
	* NEWS (Changes to the build process): Likewise.
	(Translations): Remove section.

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	build: port generating updatedb to the BSDs
	sed(1) on FreeBSD-11.1 and OpenBSD 6.2 requires the last command inside
	'{...}' groups to be terminated with a semicolon, otherwise it fails with:

	  sed: 1: "/^# Copyright /{s/^..// ...: extra characters at the end \
	  of q command

	* locate/Makefile.am (updatedb): Add a ';' after the last command in the
	'{...}' group - introduced in commit v4.6.0-133-g6d186665.

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: add missing va_end
	'va_start' must have a corresponding 'va_end'.  Depending on the
	implementation, the consequence of a missing 'va_end' may be a
	corrupted stack.

	* find/print.c (checked_fprintf): Add va_end.

	Spotted by coverity analysis.

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	parser.c: avoid -Wreturn-type warning on GCC-4.8.5 on NetBSD 7.1
	parser.c: In function 'collect_arg_stat_info':
	parser.c:755:1: warning: control reaches end of non-void function [-Wreturn-type]

	* find/parser.c (collect_arg_stat_info): Invert condition to work
	around the above warning for compilers failing to detect that
	fatal_target_file_error does never return.

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: prevent multiple inclusion of header files
	* find/print.h: Add #ifndef / #define / #endif guard to prevent
	multiple inclusion of this header file.
	* lib/fdleak.h: Likewise.
	* lib/findutils-version.h: Likewise.
	* lib/regextype.h: Likewise.
	* lib/splitstring.h: Likewise.

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	build: avoid use of $(RM)
	Some make implementations, e.g. on NetBSD 7.1, lack it; therefore
	avoid it in order to prevent error messages during 'make clean'.

	* Makefile.am (coverage-clean): Replace $(RM) by 'rm -f'.
	* find/Makefile.am: Likewise.
	* lib/Makefile.am: Likewise.
	* locate/Makefile.am: Likewise.
	* xargs/Makefile.am: Likewise.

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: move NLS-related macros to a central place
	Add definition like in coreutils, thus also silencing GCC on NetBSD 7.1:
	  warning: "textdomain" redefined

	* lib/system.h: Include <locale.h> and gnulib's "gettext.h" here,
	and define the macros textdomain, bindtextdomain, _ and N_.
	* find/exe.c: Use it.
	* find/fstype.c: Likewise.
	* find/ftsfind.c: Likewise.
	* find/oldfind.c: Likewise.
	* find/parser.c: Likewise.
	* find/pred.c: Likewise.
	* find/print.c: Likewise.
	* find/tree.c: Likewise.
	* find/util.c: Likewise.
	* lib/bugreports.c: Likewise.
	* lib/buildcmd.c: Likewise.
	* lib/dircallback.c: Likewise.
	* lib/fdleak.c: Likewise.
	* lib/findutils-version.c: Likewise.
	* lib/listfile.c: Likewise.
	* lib/regextype.c: Likewise.
	* lib/safe-atoi.c: Likewise.
	* locate/frcode.c: Likewise.
	* locate/locate.c: Likewise.
	* locate/word_io.c: Likewise.
	* xargs/xargs.c: Likewise.
	* cfg.mk (exclude_file_name_regexp--sc_bindtextdomain): Add exemption
	for some non-main sources to pass the syntax-check.

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: make -delete honour the -ignore_readdir_race option
	* find/pred.c (pred_delete): Return true when the -ignore_readdir_race
	option is active and unlinkat() came back with ENOENT.
	* doc/find.texi (Option -ignore_readdir_race): Document the change.
	(Action -delete): Likewise.
	* find/find.1: Likewise.
	* NEWS (Bug Fixes): Mention the fix.

	For now, it seems a bit hard to add a proper test for this,
	so the following shell snippet demonstrates the race:

	  $ seq 10 | xargs touch
	  $ env time -f 'find exit status: %x\nfind time: %e' \
	      find -ignore_readdir_race -type f \
	        -delete \
	        -exec sh -c 'sleep $(basename {})' \; \
	        -printf 'find deleted: %p\n' \
	        & \
	    sleep 20; \
	    seq 10 | xargs rm -fv; \
	    wait $!

	Reported by Alexander Golubev in
	https://savannah.gnu.org/bugs/?52981

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	build: add gnupload
	This may be used by 'make emit_upload_commands' and 'make stable' /
	'make alpha' later on.

	* bootstrap.conf (gnulib_modules): Add entry for 'gnupload'.
	* build-aux/.gitignore (/gnupload): Add entry.

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: give gnulib's test directory a better name
	Rename from 'tests' to 'gnulib-tests' to make clearer that these
	are the tests of gnulib, and not those of findutils.

	* .gitignore (tests): Remove.
	(/gnulib-tests/): Add entry.
	* Makefile.am (SUBDIRS): s/tests/gnulib-tests/
	(findutils-check-smells): Likewise.
	(coverage-clean): Likewise.
	* bootstrap.conf (gnulib_tool_option_extras): Add option
	"--tests-base=gnulib-tests".
	* configure.ac (AC_CONFIG_FILES): s/tests/gnulib-tests/ here, too.

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: make inter-release --version output more useful
	Now, each snapshot has a version "number" like 4.6-131-219-gda920ee,
	which indicates that it is built using the 131st change set
	(in _some_ repository) following the "v4.6" tag, and that da920ee
	is a prefix of the commit SHA1.

	* bootstrap.conf (gnulib_modules): Add git-version-gen.
	* build-aux/.gitigore (/git-version-gen): Add entry.
	* configure.ac: Run it to set the version from .tarball-version.
	* Makefile.am (EXTRA_DIST): Add git-version-gen.
	(dist-hook): Create .tarball-version in distribution tarballs,
	never in a checked-out repository.
	(AUTOMAKE_OPTIONS): Change from 'gnits' to 'gnu std-options readme-alpha'.
	* .gitignore (.tarball-version): Add entry.
	* doc/find-maint.texi (Making Releases): Adjust: tag before the build,
	changed handling in NEWS, etc.
	* NEWS (Changes to the build process): Document the change.

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	build: colorize test output on capable terminals
	* configure.ac (AM_INIT_AUTOMAKE): Add 'color-tests' option.

2018-03-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	build: make --enable-silent-rules the default
	* configure.ac (AM_SILENT_RULES): Use this, with it's undocumented
	[yes] argument.  Those who want verbose build output may configure
	with --disable-silent-rules or use "make V=1".

2018-03-13  Bjarni Ingi Gislason  <bjarniig@rhi.hi.is>  (tiny change)

	doc: fix various syntax issues in find.1
	Changes:
	- Avoid warning "(macro BR): only 1 argument, but more are expected".
	- Change misused SI (metric) numeric prefixes to the binary ones, like
	a bare "1K blocks" to "1 KB blocks".
	- Protect a full stop (.) with "\&", if it has a blank (white-space)
	in front of or (ignoring transparent characters to the full stop) after
	it, and it does not mean an end of a sentence.
	- Change the name of a macro for two fonts (e.g., BR and IR) to one
	letter, if there is only one argument.
	- Use a macro to change to the italic font, instead of \fI [1], if
	possible.
	- Remove space in the first column, if not intented.
	- Move a full stop (period) and a comma outside of a quoted text, if
	it is at the end of the quote and does not end a quoted sentence.
	- Change a HYPHEN-MINUS (code 0x55, 2D) to a minus (\-), if in front
	of a name for an option.
	- Split lines longer than 80 characters into two or more lines.
	- Separate the sentences and subordinate clauses; each begins on a new
	line. Or: Adjust space between sentences (two spaces).
	- Fix the spelling of "kibi", "mebi", and "gibi".

	* find/find.1: Do the above.

	Patch contributed via https://sv.gnu.org/patch/?9585

2018-01-01  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: add remove-potcdate.sed to po/.gitignore
	* po/.gitignore: Add the above entry which may remains after
	running 'make distcheck'.

2018-01-01  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: run 'make -C po update-po'
	Mainly for changed line numbers, but also for one white-space change
	in 'tree.c'.

	* po/be.po: Update via the above 'update-po' target.
	* po/bg.po: Likewise.
	* po/ca.po: Likewise.
	* po/cs.po: Likewise.
	* po/da.po: Likewise.
	* po/de.po: Likewise.
	* po/el.po: Likewise.
	* po/eo.po: Likewise.
	* po/es.po: Likewise.
	* po/et.po: Likewise.
	* po/fi.po: Likewise.
	* po/findutils.pot: Likewise.
	* po/fr.po: Likewise.
	* po/ga.po: Likewise.
	* po/gl.po: Likewise.
	* po/hr.po: Likewise.
	* po/hu.po: Likewise.
	* po/id.po: Likewise.
	* po/it.po: Likewise.
	* po/ja.po: Likewise.
	* po/ko.po: Likewise.
	* po/lg.po: Likewise.
	* po/lt.po: Likewise.
	* po/ms.po: Likewise.
	* po/nb.po: Likewise.
	* po/nl.po: Likewise.
	* po/pl.po: Likewise.
	* po/pt.po: Likewise.
	* po/pt_BR.po: Likewise.
	* po/ro.po: Likewise.
	* po/ru.po: Likewise.
	* po/sk.po: Likewise.
	* po/sl.po: Likewise.
	* po/sr.po: Likewise.
	* po/sv.po: Likewise.
	* po/tr.po: Likewise.
	* po/uk.po: Likewise.
	* po/vi.po: Likewise.
	* po/zh_CN.po: Likewise.
	* po/zh_TW.po: Likewise.

2018-01-01  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update copyright year number ranges
	Run 'make update-copyright'.

	* lib/regexprops.c (copying): Update the year number manually.
	* All other files: Update copyright years via the above make run.

2018-01-01  Bernhard Voelker  <mail@bernhard-voelker.de>

	build: add -Wno-unused-parameter
	The following new warning sneaked in with the gnulib update in the
	previous commit:
	  In file included from parser.c:49:0:
	  ../gl/lib/stat-time.h: In function 'stat_time_normalize':
	  ../gl/lib/stat-time.h:215:47: error: unused parameter 'st' \
	  [-Werror=unused-parameter]
	   stat_time_normalize (int result, struct stat *st)
	                                                 ^~

	* configure.ac: Add the -Wno-unused-parameter option explicitly as it
	is implied - and thus overridden - by the more general -Wunused option.

2018-01-01  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	* bootstrap: Merge from gnulib/build-aux/bootstrap.

2018-01-01  Bernhard Voelker  <mail@bernhard-voelker.de>

	find.1: document that access()-based options apply to the current user
	* find/find.1 (-executable): Mention to whom the matching files are
	accessible: to the current user.
	(-readable): Likewise.
	(-writable): Likewise.

	Reported by 積丹尼 Dan Jacobson <jidanni@jidanni.org> in
	https://lists.gnu.org/r/bug-findutils/2017-12/msg00017.html

2017-11-17  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: remove bootstrap from distribution
	* Makefile.am (EXTRA_DIST): Remove bootstrap.

2017-11-14  James Youngman  <jay@gnu.org>

	regexprops: don't mention regex dialects we're not going to document.
	* lib/regextype.c (get_regex_type_synonym): don't return regex
	dialect Y as a synonym of dialect X, if we're not in fact going to
	include X.  Accept a CONTEXT parameter in order to identify this
	situation.  This ensures that the bug fixed in commit
	e2c673cbcdc325a3a2e9dd02169bb4a42c61bc48 stays fixed for any
	permutation of regex_map.
	* lib/regextype.h: update prototype of get_regex_type_synonym.
	* lib/regexprops.c (describe_all): Pass the new context parameter.
	* doc/regexprops.texi: regenerate this file.

2017-11-14  James Youngman  <jay@gnu.org>

	regexprops: fix dangling reference to the `ed' regular expression dialect.
	* lib/regextype.c (regex_map): Permute the entries to list POSIX
	dialects before other ones, so that we don't end up with a
	dangling reference to `ed' regular expressions when
	context=findutils.  Remove trailing white space from the output.
	* doc/regexprops.texi: Regenerate this file, so that we no longer
	have a dangling reference to the `ed' dialect.
	* doc/find.texi (Regular Expressions): Point out the difference
	between Emacs regular expressions and findutils regular
	expressions: in findutils "." will match newline.
	* find/find.1: Likewise.
	* locate/locate.1: Likewise.  Also document the --regextype option.

2017-11-14  James Youngman  <jay@gnu.org>

	po: delete po/remove-potcdate.sed so that "make distcheck" works.
	* po/remove-potcdate.sed: the presence of this generated file
	causes "make distcheck" to fail on VPATH builds.  Deleting it
	fixes this.

2017-11-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: shorten https://lists.gnu.org/archive/html/... links
	Each /archive/html/ part can be replace with /r/.
	Run this to induce the change:
	git grep -l archive/html|xargs perl -pi -e 's,/archive/html/,/r/,g'
	* README: Perform that substitution.
	* find/testsuite/find.posix/depth1.exp: Likewise.
	* gnulib-local/lib/gcc-function-attributes.h

2017-11-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: include the module year2038 from gnulib
	* bootstrap.conf (gnulib_modules): Add 'year2038' to ensure that time_t
	is 64-bit (and thus works after 2038).

	Suggested by Bruno Haible in
	https://lists.gnu.org/r/bug-gnulib/2017-11/msg00022.html

2017-11-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update gnulib to latest
	* gnulib: Update - mainly for the recent year2038 changes.
	* bootstrap: Update from gnulib/build-aux/bootstrap.

2017-11-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: document the https change in NEWS
	* NEWS (Documentation Changes): Mention the switch from http to https
	done in commit 2cb10332.

2017-11-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	all: use die() rather than error(EXIT_FAILURE)
	die() has the advantage of being apparent to the compiler
	that it doesn't return, which will avoid warnings in some cases,
	and possibly generate better code.

	While at it, wrap some of the overly long error messages into a new line.

	* cfg.mk (sc_die_EXIT_FAILURE): A new syntax check rule to
	catch any new uses of error (CONSTANT, ...);
	* find/exec.c: Include "die.h" and use die rather than exit (EXIT_FAILURE).
	* find/fstype.c: Likewise.
	* find/ftsfind.c: Likewise.
	* find/oldfind.c: Likewise.
	* find/parser.c: Likewise.
	* find/pred.c: Likewise.
	* find/print.c: Likewise.
	* find/tree.c: Likewise.
	* find/util.c: Likewise.
	* lib/buildcmd.c: Likewise.
	* lib/listfile.c: Likewise.
	* lib/regextype.c: Likewise.
	* lib/safe-atoi.c: Likewise.
	* locate/frcode.c: Likewise.
	* locate/locate.c: Likewise.
	* locate/word_io.c: Likewise.
	* xargs/xargs.c: Likewise.

2017-11-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: avoid unused-but-set-variable, unused-parameter warnings from GCC 7
	GCC-7.2.1 complained about this occur during 'make check'.

	* lib/regexprops.c (menu): Remove set-but-unused-variable 'options'.
	* lib/test_splitstring.c (main): Avoid unused-parameter warnings
	for 'argc' and 'argv'.

2017-11-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: add die.h; avoid missing-fallthrough warnings after error w/ GCC 7
	* lib/die.h (die): New file/function from grep/coreutils.
	Note: this file will probably be migrated to gnulib.
	* lib/Makefile.am (libfind_a_SOURCES): Reference it.
	* xargs/xargs.c: Include die.h.
	(xargs_do_exec): Use die in place of error-nonzero, thus allowing
	the compiler to know that we do not fall through into the 0 (child)
	case.

2017-11-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: avoid implicit-fallthrough warnings from GCC 7
	Avoid the new warnings GCC 7 gives with the
	"-Werror=implicit-fallthrough=" compiler option.
	Since version 7, GCC requires fallthrough switch/cases to be
	marked by the appropriate attribute.

	* lib/system.h: Add new header file defining the FALLTHROUGH macro.
	* lib/Makefile.am (libfind_a_SOURCES): Reference it.
	* find/print.c (do_fprintf): Use the new macro.
	* xargs/xargs.c (read_line): Likewise.
	(xargs_do_exec): For error(3), GCC 7 doesn't know that the function
	does not return, and would complain about falling through into the
	following case.  Temporarily add an abort call - this will be fixed
	with another commit.

2017-11-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: avoid implicit-fallthrough warnings from GCC 7
	Avoid the new warnings GCC 7 gives with the
	"-Werror=implicit-fallthrough=" compiler option.
	Since version 7, GCC requires fallthrough switch/cases to be
	marked by the appropriate attribute.

	* lib/system.h: Add new header file defining the FALLTHROUGH macro.
	* lib/Makefile.am (libfind_a_SOURCES): Reference it.
	* find/print.c (do_fprintf): Use the new macro.
	* xargs/xargs.c (read_line): Likewise.
	(xargs_do_exec): For error(3), GCC 7 doesn't know that the function
	does not return, and would complain about falling through into the
	following case.  Temporarily add an abort call - this will be fixed
	with another commit.

2017-11-08  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: avoid unused-macros warning from GCC 7
	GCC-7.2.1 on openSUSE-Tumbleweed complains:
	  listfile.c:56:0: error: macro "HAVE_MAJOR" is not used \
	  [-Werror=unused-macros]
	  #define HAVE_MAJOR

	* listfile.c (major,minor): Avoid the temporary #define HAVE_MAJOR
	by using #else's.

2017-10-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	updatedb: use Copyright header of updatedb.sh
	Previously, the Copyright header output by 'updatedb --version' was
	not updated by 'make update-copyright', so it still showed 2010 as
	the Copyright year.

	* locate/updatedb.sh (version): Replace the Copyright header by
	the placeholder "@COPYRIGHT@" ...
	* locate/Makefile.am (updatedb): ... set here from the Copyright line
	extracted from 'updatedb.sh'.

2017-10-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: cleanup files left behind by sv-52220.sh
	'make distcheck' failed with:
	  ...
	  ERROR: files left in build directory after distclean:
	  ./find/testsuite/find.err
	  ./find/testsuite/oldfind.err
	  Makefile:2064: recipe for target 'distcleancheck' failed

	* find/testsuite/sv-52220.sh: Add command to remove the temporary
	files used for stderr output.

	Bug introduced in commit v4.6.0-123-gef1581e.

2017-10-28  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: use an optimal-for-findutils xz compression setting
	* cfg.mk: Set XZ_OPT = -7e (determined empirically).
	The compressed tarball size is identical to the default settings (-9e),
	but using -9e would force every decompression process to use 48 MiB
	more memory.

2017-10-23  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: run 'make -C po update-po'
	Mainly for changed line numbers, but also for a couple of new
	translation strings, and the switch to https.

	* po/be.po: Update via the above 'update-po' target.
	* po/bg.po: Likewise.
	* po/ca.po: Likewise.
	* po/cs.po: Likewise.
	* po/da.po: Likewise.
	* po/de.po: Likewise.
	* po/el.po: Likewise.
	* po/eo.po: Likewise.
	* po/es.po: Likewise.
	* po/et.po: Likewise.
	* po/fi.po: Likewise.
	* po/findutils.pot: Likewise.
	* po/fr.po: Likewise.
	* po/ga.po: Likewise.
	* po/gl.po: Likewise.
	* po/hr.po: Likewise.
	* po/hu.po: Likewise.
	* po/id.po: Likewise.
	* po/it.po: Likewise.
	* po/ja.po: Likewise.
	* po/ko.po: Likewise.
	* po/lg.po: Likewise.
	* po/lt.po: Likewise.
	* po/ms.po: Likewise.
	* po/nb.po: Likewise.
	* po/nl.po: Likewise.
	* po/pl.po: Likewise.
	* po/pt.po: Likewise.
	* po/pt_BR.po: Likewise.
	* po/ro.po: Likewise.
	* po/ru.po: Likewise.
	* po/sk.po: Likewise.
	* po/sl.po: Likewise.
	* po/sr.po: Likewise.
	* po/sv.po: Likewise.
	* po/tr.po: Likewise.
	* po/uk.po: Likewise.
	* po/vi.po: Likewise.
	* po/zh_CN.po: Likewise.
	* po/zh_TW.po: Likewise.

2017-10-23  Bernhard Voelker  <mail@bernhard-voelker.de>

	all: prefer https:// URLs where possible
	Change from http:// to https:// URLs for the following:
	www.gnu.org, gnu.org, savannah.gnu.org, git.sv.gnu.org, lists.gnu.org,
	translationproject.org, cve.mitre.org, cwe.mitre.org, xkcd.com,
	standards.ieee.org, and gcc.gnu.org.

	* COPYING: Do the above replacement.
	* ChangeLog-2013: Likewise.
	* NEWS: Likewise.
	* README: Likewise.
	* README-hacking: Likewise.
	* build-aux/Makefile.am: Likewise.
	* build-aux/check-testfiles.sh: Likewise.
	* build-aux/gen-changelog.sh: Likewise.
	* build-aux/man-lint.sh: Likewise.
	* build-aux/src-sniff.py: Likewise.
	* cfg.mk: Likewise.
	* configure.ac: Likewise.
	* doc/Makefile.am: Likewise.
	* doc/find-maint.texi: Likewise.
	* doc/find.texi: Likewise.
	* find/defs.h: Likewise.
	* find/exec.c: Likewise.
	* find/find.1: Likewise.
	* find/finddata.c: Likewise.
	* find/fstype.c: Likewise.
	* find/ftsfind.c: Likewise.
	* find/oldfind.c: Likewise.
	* find/parser.c: Likewise.
	* find/pred.c: Likewise.
	* find/print.c: Likewise.
	* find/print.h: Likewise.
	* find/sharefile.c: Likewise.
	* find/sharefile.h: Likewise.
	* find/testsuite/Makefile.am: Likewise.
	* find/testsuite/binary_locations.sh: Likewise.
	* find/testsuite/checklists.py: Likewise.
	* find/testsuite/config/unix.exp: Likewise.
	* find/testsuite/find.gnu/name-period.exp: Likewise.
	* find/testsuite/find.posix/depth1.exp: Likewise.
	* find/testsuite/sv-34079.sh: Likewise.
	* find/testsuite/sv-34976-execdir-fd-leak.sh: Likewise.
	* find/testsuite/sv-48030-exec-plus-bug.sh: Likewise.
	* find/testsuite/sv-48180-refuse-noop.sh: Likewise.
	* find/testsuite/sv-52220.sh: Likewise.
	* find/testsuite/sv-bug-32043.sh: Likewise.
	* find/testsuite/test_escape_c.sh: Likewise.
	* find/testsuite/test_escapechars.sh: Likewise.
	* find/testsuite/test_inode.sh: Likewise.
	* find/testsuite/test_type-list.sh: Likewise.
	* find/tree.c: Likewise.
	* find/util.c: Likewise.
	* gnulib-local/lib/gcc-function-attributes.h: Likewise.
	* lib/bugreports.c: Likewise.
	* lib/bugreports.h: Likewise.
	* lib/buildcmd.c: Likewise.
	* lib/buildcmd.h: Likewise.
	* lib/check-regexprops.sh: Likewise.
	* lib/dircallback.c: Likewise.
	* lib/dircallback.h: Likewise.
	* lib/extendbuf.c: Likewise.
	* lib/extendbuf.h: Likewise.
	* lib/fdleak.c: Likewise.
	* lib/fdleak.h: Likewise.
	* lib/findutils-version.c: Likewise.
	* lib/findutils-version.h: Likewise.
	* lib/listfile.c: Likewise.
	* lib/listfile.h: Likewise.
	* lib/printquoted.c: Likewise.
	* lib/printquoted.h: Likewise.
	* lib/qmark.c: Likewise.
	* lib/regexprops.c: Likewise.
	* lib/regextype.c: Likewise.
	* lib/regextype.h: Likewise.
	* lib/safe-atoi.c: Likewise.
	* lib/safe-atoi.h: Likewise.
	* lib/splitstring.c: Likewise.
	* lib/splitstring.h: Likewise.
	* lib/test_splitstring.c: Likewise.
	* lib/unused-result.h: Likewise.
	* locate/frcode.c: Likewise.
	* locate/locate.1: Likewise.
	* locate/locate.c: Likewise.
	* locate/locatedb.5: Likewise.
	* locate/locatedb.h: Likewise.
	* locate/testsuite/Makefile.am: Likewise.
	* locate/testsuite/config/unix.exp: Likewise.
	* locate/updatedb.1: Likewise.
	* locate/updatedb.sh: Likewise.
	* locate/word_io.c: Likewise.
	* po/fetch-po-files: Likewise.
	* xargs/testsuite/Makefile.am: Likewise.
	* xargs/testsuite/config/unix.exp: Likewise.
	* xargs/xargs.1: Likewise.
	* xargs/xargs.c: Likewise.

2017-10-23  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: add copyright section to man pages
	* find/find.1: Add copyright section, deriving first copyright year from
	the corresponding *.c file.
	* locate/locate.1: Likewise.
	* locate/locatedb.5: Likewise.
	* locate/updatedb.1: Likewise.
	* xargs/xargs.1: Likewise.

2017-10-23  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: add copyright header to more files
	* Makefile.am: Add copyright header.
	* README: Likewise.
	* TODO: Likewise.
	* doc/perm.texi: Likewise; use 1994-2017 as Kevin brought it into
	findutils from coreutils.
	* find/Makefile.am: Add copyright header.
	* lib/Makefile.am: Likewise.
	* locate/Makefile.am: Likewise.
	* xargs/Makefile.am: Likewise.

2017-10-23  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: align copyright header line
	* lib/extendbuf.c: s/Copyright/Copyright (C)/
	* lib/printquoted.h: Likewise.
	* lib/regextype.c: Likewise.
	* lib/regextype.h: Likewise.

2017-10-23  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update copyright year number ranges
	Better late than never: run 'make update-copyright'.

	* cfg.mk (update-copyright-env): Change UPDATE_COPYRIGHT_USE_INTERVALS
	from 1 to 2 to get a minimal containing range of years; also set
	UPDATE_COPYRIGHT_MAX_LINE_LENGTH to 79 characters.
	* .x-update-copyright: Add an entry for bootstrap which comes from
	gnulib.
	* lib/qmark.c: While at it, fix a typo: s/courutils/coreutils/.
	* lib/regexprops.c (copying): Update the text so that the
	copyright years match the result of "make update-copyright".
	* po/fi.po: Change copyright header so that "make update-copyright"
	can pick it up: s/©/(C)/
	* po/it.po: Likewise.
	* po/vi.po: Likewise.
	* All other files: Update copyright years via the above make run.

2017-10-22  Bernhard Voelker  <mail@bernhard-voelker.de>

	gnulib: update to latest
	* bootstrap: Merge from gnulib/build-aux/.
	* bootstrap.conf: Likewise.

2017-10-22  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: avoid segfault with -D without argument
	On some platforms, 'find -D' without any further argument crashed.

	* find/util.c (process_leading_options): Output an error diagnostic
	when the -D option is the last argument.  Previously, 'find -D'
	without any further arguments crashed on some platforms where the
	following strtok_r does not expect a NULL pointer argument in the
	first call.
	* NEWS (Bug Fixes): Mention the fix.
	* find/testsuite/sv-52220.sh: Add a test.
	* find/testsuite/Makefile.am (test_shell_progs): Reference the test.

	Fixes https://savannah.gnu.org/bugs/?52220

2017-10-10  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: fix typos in commments
	* find/fstype.c: s/unneccessary/unnecessary/
	* xargs/xargs.c: s/utliity/utility/

2017-09-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	find.1: improve explanation in the NON-BUGS section
	* find/find.1 (NON-BUGS): Update the sample error diagnostic to match
	the latest code of the unquoted pattern example for the -name predicate.
	Also improve the explanation about what is happening in that case.

2017-09-08  Andreas Metzler  <ametzler@bebt.de>

	tests: test more printf format specifiers
	* find/testsuite/find.gnu/printf.exp: Add coverage for %T* (limited to
	strftime sequences mandated by POSIX), %M, %t, %y, and %Y. Run this test
	with TZ=UTC. (Latter fix by Bernhard Voelker.)
	* find/testsuite/find.gnu/printf.xo: Likewise.

2017-09-03  James Youngman  <jay@gnu.org>

	intl: update Brazilian Portuguese, Slovak, Dutch translations.
	* po/pt_BR.po: Update Brazilian Portuguese translation.
	* po/sk.po: Update Slovak translation.
	* po/nl.po: Update Dutch translation.

2017-08-28  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: avoid buffer-overflow with -printf '%T+'
	* find/print.c (format_date): Increase size of local variable
	FMT to match the longest possible content.

	Fixes https://bugs.debian.org/873032 reported upstream by
	Andreas Metzler in https://savannah.gnu.org/bugs/?51841;
	fix proposed by Kamil Dudka.

	Bug introduced in commit v4.6.0-111-g95816b2, so no released version
	ever saw this; therefore not adding a NEWS entry.

2017-08-28  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: fix typo in comment
	* locate/locate.c (dolocate): Change a double comma to a
	single one: s/,,/,/

	Reported by Reuben Thomas in
	http://lists.gnu.org/archive/html/bug-findutils/2017-08/msg00023.html

2017-08-18  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: add a NEWS entry for the previous commit
	* NEWS (Improvements): Add an entry for v4.6.0-115-g9530e31.

2017-08-17  Assaf Gordon  <assafgordon@gmail.com>

	find: give helpful hint for unquoted patterns errors
	Try to detect cases where the user provided an unquoted shell-glob
	pattern (which was expanded by the shell before calling find(1),
	resulting in an invalid usage).

	  $ touch a.txt b.txt c.txt
	  $ find -name *.txt
	  find: paths must precede expression: `b.txt'
	  find: possible unquoted pattern after predicate `-name'?

	Continuation of
	   https://savannah.gnu.org/bugs/?51711
	   https://lists.gnu.org/archive/html/bug-findutils/2017-08/msg00000.html
	   https://git.sv.gnu.org/cgit/findutils.git/commit/?id=50a7c5d1f572

	* find/tree.c (build_expression_tree): If the offending argument is an
	existing file, print a hint with the last (valid) predicate.

2017-08-10  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: avoid usage() in more error cases
	When the user passes a bad command line, then find(1) outputs the
	error message followed by a short usage() text, e.g. (wrapped):

	  $ find . -name a* b*
	  find: paths must precede expression: bfile
	  Usage: find [-H] [-L] [-P] [-Olevel] \
	  [-D help|tree|search|stat|rates|opt|exec] [path...] [expression]

	Omit the usage() text in more cases like this in order to make the
	error diagnostic more eye-catching.

	* find/tree.c (build_expression_tree): Exit with EXIT_FAILURE
	immediately in more cases, i.e., without outputting also a short
	usage() text.  While at it, add quotes around the offending argument
	in one another place.
	* NEWS (Improvements): Mention the fix.

	Reported in https://savannah.gnu.org/bugs/?51711

2017-07-29  James Youngman  <jay@gnu.org>

	po/*.po: update line numbers.

2017-07-29  James Youngman  <jay@gnu.org>

	gnulib: update to f42d5af5ba76970309c5704db1c229143043bcc0.
	* build-aux/.gitignore: arg-nonnull.h, ar-lib, c++defs.h.

2017-07-23  James Youngman  <jay@gnu.org>

	find: avoid strftime's non-portable %F specifier.
	* find/print.c (format_date): Avoid passing %F to strftime since
	some implementation lack it.  Pass the synonymous %Y-%m-%d
	instead.  This fixes a bug manifesting on HP Tru64 UNIX V5.1B.
	Reported by Steven M. Schweda <sms@antinode.info>.

2017-07-23  James Youngman  <jay@gnu.org>

	ChangeLog: fix some incorrectly-formatted messages.
	* build-aux/git-log-fix: Ignore a recent incorrectly-formatted
	change-log message (5e56fe96bc5cf5c0b616dc0251dddebb7e480074)
	which is replaced by another
	(f146a243400c211a19c9b76e5f598b6d7c57b1b0).  Also don't copy the
	resulting merge commit message into the ChangeLog.

2017-07-23  James Youngman  <jay@gnu.org>

	locate: don't warn about slocate databases any more.
	* locate/locate.c (search_one_database): Remove warning about
	support for slocate databases being new.

2017-06-29  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: update the "STANDARDS CONFORMANCE" section in find.1
	* find/find.1 (STANDARDS CONFORMANCE): Change the reference to the
	POSIX standard from the 2003 Edition to the 2016 Edition.
	In the list of supported primaries, add the missing ones:
	-exec, -ok and -path.  Remove the stray duplicates from the list.

2017-06-29  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: clarify 'find -size' values prefixed with '+' and '-'
	* doc/find.texi (node Size): Add a sentence to make even clearer that
	values prefixed with '+' or '-' do not find files with an exact match
	of N in file size.
	* find/find.1 (-size): Likewise.

2017-06-29  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: fix explanation of 'find -size' example
	'find -size -1048576c' also matches empty files.

	* doc/find.texi (node Size): Change "1 to 1,048,575 bytes" to
	"0 to 1,048,575 bytes".
	* find/find.1 (-size): Likewise.

2017-06-29  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: use correct IEC unit prefixes in the documentation of 'find -size'
	find(1) uses binary-based units for the suffixes 'k', 'M', and 'G' of
	the argument of the '-size' option: 1024, 1024*1024 and 1024^3.
	Therefore, the documentation should use the correct IEC prefixes
	kibibyte, mebibyte and gibibyte respectively (or their abbreviations
	'KiB', 'MiB' and 'GiB').

	* doc/find.texi (node Overview): Change 'Kilobytes' to the shorter
	but correct 'KiB'.
	(node Size): Use the above mentioned, correct IEC prefixes.
	While at it, move the 'w' suffix up to match the man page.
	* find/find.1 (-size): Likewise.
	* find/parser.c (parse_size): Also change to IEX prefixes in some
	comments for consistency.
	* NEWS (Bug fixes): Mention the fix.

	See also:
	  https://en.wikipedia.org/wiki/Binary_prefix

	Reported by Andreas Metzler in
	  https://savannah.gnu.org/bugs/?51304

2017-06-09  Andreas Metzler  <ametzler@bebt.de>

	doc: drop workarounds for missing xargs -o option
	* doc/find.texi (Multiple Files): Mention the new --open-tty option
	to be used as an alternative.
	(Safe File Name Handling): Likewise.
	* xargs/xargs.1 (EXAMPLES): Remove the tty redirection example.

2017-06-09  Bernhard Voelker  <mail@bernhard-voelker.de>

	xargs: add -o, --open-tty option
	This option is available in the xargs implementation of FreeBSD, NetBSD,
	OpenBSD and in the Apple variant.  Add it for compatibility.

	* xargs/xargs.c (open_tty): Add static flag for the new option.
	(longopts): Add member.
	(main): Handle the 'o' case in the getopt_long() loop.
	(prep_child_for_exec): Redirect stdin of the child to /dev/tty when
	the -o option is given.  Furthermore, move the just-opened file
	descriptor to STDIN_FILENO.
	(usage): Document the new option.
	* bootstrap.conf (gnulib_modules): Add dup2.
	* xargs/xargs.1 (SYNOPSIS): Replace the too-long list of options by
	"[options]" - they are listed later anyway.
	(OPTIONS): Document the new option.
	(STANDARDS CONFORMANCE): Mention that the -o option is an extension.
	* doc/find.texi (xargs options): Document the new option.
	(Invoking the shell from xargs): Amend the explanation of the
	redirection example with a note about the -o option.
	(Viewing And Editing): Likewise.
	(Error Messages From xargs): Add the message when dup2() fails.
	(NEWS): Mention the new option.

	Fixes http://savannah.gnu.org/bugs/?51151

2017-04-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: fix some -perm examples in find.info
	* doc/find.texi (Mode Bits): Fix the description of the -perm examples
	which search for the "022" mode bits: the match is for the file's group
	and 'other' mode bits instead of for user and group.
	While at it, remove a superfluous ';' in the adjacent example.
	Bug introduced when adding the -perm examples in FINDUTILS-4.2.11.
	* NEWS: Mention the fix.

	Reported by Jacob Nevins <0jacobnk.gnu@chiark.greenend.org.uk> in
	http://savannah.gnu.org/bugs/?50758

2017-03-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: clarify that -links counts hard links in find.1
	* find/find.1 (TESTS): Mention that -links tests the number of
	"hard links", not just "links".

	Reported by Dan Jacobson <jidanni@jidanni.org>.

2017-02-20  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: fix -printf '%h' for arguments with one or more trailing slashes
	Previously, find would output the pathname name for the '%h' format
	when that was passed with a trailing slash:

	  $ mkdir foo
	  $ find foo/ -printf '%h/%f\n'
	  foo/foo/

	* find/print.c (do_fprintf -> 'h'): Strip trailing slashes, i.e. any
	number of directory separators, unless this is the root "/" directory.
	* find/testsuite/find.gnu/printf-h.exp: Enhance test with various
	combinations of "/", "./", "foo/", "./foo", "./foolink/", etc.
	* find/testsuite/find.gnu/printf-h.xo: Add the expected output for the
	above new test cases.
	* NEWS: Mention the fix.

	Bug introduced in commit FINDUTILS_4_2_18-1-6-g0fd15a4.

	Reported by	Tavian Barnes <tavianator@gmail.com> in
	  https://savannah.gnu.org/bugs/?50259

2017-02-16  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: add the bug number #50326 to NEWS
	* NEWS (Bug Fixes): Add the above bug number to the NEWS entry
	of commit v4.6.0-90-gc155689, now as this issue is also reported
	as a bug.

2017-02-16  Bernhard Voelker  <mail@bernhard-voelker.de>

	gnulib: update to latest
	* gnulib: Do the above.

2017-02-08  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: improve readability of fstype.c
	* find/fstype.c (fstype_known): Move variable from global context ...
	(filesystem_type): ... here, and pass it on explicitly by reference
	to file_system_type_uncached().
	(file_system_type_uncached): Add fstype_known as parameter.

2017-02-06  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: avoid unneccessary reading of the mount list
	Add a static cache for mount list to fstype.c.

	* find/fstype.c (get_file_system_list): Add wrapper around GNULIB's
	read_file_system_list function with a static cache to avoid multiple
	invocations of that GNULIB function.  Still re-read the list if the
	first invocation didn't include the ME_TYPE members.
	(is_used_fs_type): Use the above new wrapper.
	(file_system_type_uncached): Likewise, and do not free the list here
	anymore because this is now done in get_file_system_list() as needed.

2017-02-06  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: move is_used_fs_type to fstype.c
	* find/parser.c (is_used_fs_type): Move to ...
	* find/fstype.c: ... here.
	* find/defs.h (is_used_fs_type): Add declaration.

2017-02-06  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: inline now last use of must_read_fs_list
	* find/fstype.c (must_read_fs_list): Remove function and inline body ...
	(file_system_type_uncached): ... here where its last use was.
	(get_mounted_devices): Remove it from a comment.

2017-02-06  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: remove unused get_mounted_filesystems
	* find/fstype.c (get_mounted_filesystems): Remove unused function ...
	* find/defs.h (get_mounted_filesystems): ... and its declaration.

2017-02-06  Goffredo Baroncelli  <kreijack@inwind.it>

	find: fix memory leak in mount list handling
	The following gnulib commit added the structure member me_mntroot
	which our free_file_system_list function didn't consider, thus leading
	to a memory leak:
	http://git.sv.gnu.org/cgit/gnulib.git/commit/?id=c6148bca89e9

	* find/fstype.c (free_file_system_list): Use gnulib's free_mount_entry
	function to free the mount list instead of free()ing all members here
	manually.
	* NEWS (Bug Fixes): Mention the fix.

	Reported in
	http://lists.gnu.org/archive/html/findutils-patches/2016-12/msg00000.html

2017-02-06  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: avoid -Werror=missing-prototypes warning in oldfind
	oldfind.c:169:1: error: no previous prototype for ‘get_current_dirfd’ [-Werror=missing-prototypes]
	 get_current_dirfd (void)
	 ^~~~~~~~~~~~~~~~~

	* find/oldfind.c (get_current_dirfd): Remove unused function.

2017-02-06  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: avoid -Werror=unused-macros warning in oldfind
	oldfind.c: At top level:
	oldfind.c:88:0: error: macro "N_" is not used [-Werror=unused-macros]
	 # define N_(String) gettext_noop (String)

	cc1: all warnings being treated as errors

	* find/oldfind.c (N_): Remove unused macro.

2017-02-06  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: avoid -Werror=unsafe-loop-optimizations warning in oldfind
	oldfind.c: In function ‘process_path’:
	oldfind.c:1445:14: error: cannot optimize loop, the loop counter may overflow [-Werror=unsafe-loop-optimizations]
	        while (cur_path_size < file_len)
	              ^
	cc1: all warnings being treated as errors

	* find/oldfind.c (process_path): Replace loop by calculation, avoiding
	the offending loop at all.

2017-02-06  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: avoid warnings from GCC 6.2.1
	buildcmd.c: In function 'bc_push_arg':
	buildcmd.c:362:11: error: this 'if' clause does not guard... [-Werror=misleading-indentation]
	           if (ctl->replace_pat
	           ^~
	buildcmd.c:366:13: note: ...this statement, but the latter is misleadingly indented as if it is guarded by the 'if'
	             bc_do_exec (ctl, state);
	             ^~~~~~~~~~
	pred.c: In function 'print_optlist':
	pred.c:1328:46: error: format '%ld' expects argument of type 'long int', but argument 3 has type 'long unsigned int' [-Werror=format=]
	           fprintf (fp, "[real success rate %ld/%ld", p->perf.successes, p->perf.visits);
	                                              ^
	pred.c:1328:50: error: format '%ld' expects argument of type 'long int', but argument 4 has type 'long unsigned int' [-Werror=format=]
	           fprintf (fp, "[real success rate %ld/%ld", p->perf.successes, p->perf.visits);
	                                                  ^
	print.c: In function 'scan_for_digit_differences':
	print.c:449:46: error: logical 'or' of equal expressions [-Werror=logical-op]
	           if (!isdigit ((unsigned char)q[i]) || !isdigit ((unsigned char)q[i]))
	                                              ^~
	In file included from ../gl/lib/gettext.h:25:0,
	                 from locate.c:86:
	locate.c: In function 'dolocate':
	locate.c:1873:28: error: format '%d' expects argument of type 'int', but argument 5 has type 'unsigned int' [-Werror=format=]
	                          _("warning: database %s is more than %d %s old (actual age is %.1f %s)"),
	                            ^
	locate.c:1873:26: note: in expansion of macro '_'
	                          _("warning: database %s is more than %d %s old (actual age is %.1f %s)"),
	                          ^
	locate.c:1927:18: error: format '%ld' expects argument of type 'long int', but argument 2 has type 'long unsigned int' [-Werror=format=]
	       printf ("%ld\n", found);
	                  ^
	cc1: all warnings being treated as errors

	* find/pred.c (print_optlist): Use %lu for unsigned long int.
	* find/print.c (scan_for_digit_differences): Check p[i] too rather than
	q[i] two times.
	* lib/buildcmd.c (bc_push_arg): Fix indentation.
	* locate/locate.c (dolocate): Use %u format for unsigned int.
	Use %lu format for unsigned long int.

2017-02-06  Bernhard Voelker  <mail@bernhard-voelker.de>

	gnulib: update to latest
	* gnulib: Do the above.
	* bootstrap: Update from gnulib.
	* doc/find.texi: s/time stamp/timestamp/ to adhere to new syntax-check
	rule from gnulib.

2016-11-06  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: fix typos in find.1
	* find/find.1 (Positional options): s/optiona/options/; s/regulat/regular/

	Reported by Yaroslav Chagovets in http://savannah.gnu.org/bugs/?49541

2016-11-03  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: mention previous translation updates in NEWS
	* NEWS (Translations): Add the languages updated with the previous
	commit in alphabetical order.

2016-11-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update po/*.po, po/findutils.pot with "make dist"
	po/*.po: Update with "make dist".
	po/findutils.pot: Likewise.

2016-11-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: clarify that -path is part of POSIX in find.1
	http://pubs.opengroup.org/onlinepubs/9699919799/utilities/find.html

	* find/find.1: Change the description of the -path option mentioning
	that it is now part of POSIX 2008.
	* find/parser.c (parse_table): Change comment: -path is POSIX.
	(insert_path_check): Likewise, plus remove the superfluous comment
	about HP-UX.

	Reported by Isabella Parakiss in
	http://lists.gnu.org/archive/html/bug-findutils/2016-10/msg00001.html

2016-11-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: handle more readdir(3) errors
	Similar to the FTS readdir fix in v4.6.0-72-g155c9d1, handle the last
	two unhandled readdir(3) errors.

	* find/pred.c (pred_empty): Do the above.
	* lib/fdleak.c (get_proc_max_fd): Likewise.  While at it, fix the
	condition to only skip "." and ".."; previously, also other files
	beginning with ".." would have been skipped - that was theoretically,
	as we only expect the FD files in "/proc/self/fd".

2016-11-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	oldfind: fix compiler warnings
	Avoid the following 2 warnings:

	oldfind.c: In function ‘main’:
	oldfind.c:228:5: warning: passing argument 1 of ‘ctime’ from incompatible pointer type [enabled by default]
	     fprintf (stderr, "cur_day_start = %s", ctime (&options.cur_day_start/*.tv_sec*/));
	     ^
	In file included from ../gl/lib/time.h:41:0,
	                 from ../gl/lib/sys/stat.h:44,
	                 from oldfind.c:35:
	/usr/include/time.h:264:14: note: expected ‘const time_t *’ but argument is of type ‘struct timespec *’
	oldfind.c: In function ‘at_top’:
	oldfind.c:1003:12: warning: assignment discards ‘const’ qualifier from pointer target type [enabled by default]
	       base = pathname;
	            ^

	* find/oldfind.c (main): Correct the call to ctime; it takes time_t*,
	so don't pass struct timeval*; instead, pass the address of the tv_sec
	member.
	(at_top): Declare base as const char*.

2016-11-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: remove ChangeLog-2013 from distribution tarball
	* Makefile.am (EXTRA_DIST): Remove ChangeLog-2013, as its content is
	shipped in the generated ChangeLog file.

	Reported by Steve in
	http://lists.gnu.org/archive/html/bug-findutils/2016-10/msg00000.html

2016-11-02  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: merge README-alpha into README
	As of findutils-4.6, this package is stable.

	* README-alpha: Remove file, moving the useful content of it to ...
	* README: ... here.
	* doc/find-maint.texi: Remove README-alpha here, too.

	Reported by Steve in
	http://lists.gnu.org/archive/html/bug-findutils/2016-10/msg00000.html

2016-07-17  James Youngman  <jay@gnu.org>

	Updated the Bulgarian translation.
	* po/bg.po: Updated the Bulgarian translation.
	* NEWS: Mention this.

2016-07-17  James Youngman  <jay@gnu.org>

	README-hacking: "./configure", not "configure".
	* README-hacking: "./configure", not "configure".  Also fix a
	grammatical error (missing "to") and point out that the "trivial
	change" criterion is cumulative.

2016-07-16  James Youngman  <jay@gnu.org>

	find: manpage quoting fixes, including fixing missing quotes on "*~"
	* find/find.1: quoting fixes; be consistent about quoting "!"
	(it's likely not necessary in most places, but the previous
	inconsistent approach was no more correct).  Use \(dq instead of
	just ", where we specifically need a double quote.  This fixes a
	quoting bug in which troff rendered "*~" as *~, presumably because
	the "" was being eaten by macro argument processing.  We use \(aq
	to ensure that quotes qre rendered correctly where double quotes
	is needed, and `these quotes' where they are not.

2016-07-16  James Youngman  <jay@gnu.org>

	gnulib: update to current master

2016-07-03  Bernhard Voelker  <mail@bernhard-voelker.de>

	Update gnulib submodule to latest
	Fixes an FTS bug ignoring readdir() errors which also affected find(1).
	See http://git.sv.gnu.org/cgit/gnulib.git/commit/?id=6835fc458f

	* gnulib: Update to latest.
	* bootstrap: Likewise.
	* NEWS: Specifically mention the fts readdir() fix.

2016-07-03  Andreas Metzler  <ametzler@bebt.de>

	tests: avoid checking for features in installed find
	* find/testsuite/test_type-list.sh: Run "${ftsfind}" (i.e. newly built
	executable) instead of find (version installed on build-system).  The
	latter may have prevented some tests to run.
	Bug introduced in commit v4.6.0-61-g6c37ce4.

2016-07-03  Andreas Metzler  <ametzler@bebt.de>

	tests: add basic -type checks to detect the previous regression
	The regression (bug #48314) fixed in the previous commit was not
	detected by the existing tests.

	* find/testsuite/test_type-list.sh: Add checks for "-type f" and "-type l".

2016-07-03  Maximiliano Curia  <maxy@debian.org>  (tiny change)
	    Bernhard Voelker  <mail@bernhard-voelker.de>

	Fix bug #48314: find: fix -type option regression on some platforms
	Since commit v4.6.0-61-g6c37ce4, the option -type and -ltype is broken
	on armel, armhf and mipsel at least.  The reason is that the union member
	args of the struct predicate was not completely initialized as its new
	bool types[] member may be implemented larger than the union member
	initialized: str.

	* find/tree.c (set_new_parent): Replace xmalloc() by xzalloc() to
	initialize the complete new predicate structure.  Therefore, remove all
	individual NULL and false initializations.
	(get_new_pred): Likewise, plus move the xzmalloc() invocations before
	the if-condition to have only one place left for the allocation, thus
	improving readability.

	Reported by Andreas Metzler <ametzler@bebt.de> in
	https://savannah.gnu.org/bugs/?48314

2016-07-03  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: make distcheck pass again
	Since commit v4.6.0-67-g595060f, 'make distcheck' failed:

	  ERROR: files left in build directory after distclean:
	  ./find/oldfindnoop.out
	  ./find/findnoop.out
	  ./find/find--noop.err
	  ./find/oldfind--noop.out
	  ./find/find--noop.out
	  ./find/oldfind--noop.err
	  ./find/findnoop.err
	  ./find/oldfindnoop.err
	  Makefile:1985: recipe for target 'distcleancheck' failed

	* find/testsuite/sv-48180-refuse-noop.sh: Change the names of the *out
	and *err files to be located in the temporary directory.

2016-06-14  Bernhard Voelker  <mail@bernhard-voelker.de>

	Fix bug #48180: find: avoid segfault for internal '-noop' option
	The pseudo-option '-noop' was never meant to be exposed to the user
	interface.  If specified by the user, find(1) segfaulted.
	Bug introduced in commit FINDUTILS_4_3_0-1-12-g6b8a4db.

	* find/parser.c (struct parser_table): Rename the parser_name element of
	the ARG_NOOP entry from 'noop' to '--noop', thus indicating its pure
	internal character.
	(found_parser): Return NULL when the user has passed the '---noop' option;
	the caller does the error handling.
	* find/testsuite/sv-48180-refuse-noop.sh: Add test.
	* find/testsuite/Makefile.am (test_shell_progs): Reference the test.
	* NEWS (Bug fixes): Document the fix.

	Reported by Tavian Barnes <tavianator@tavianator.com> in
	    https://savannah.gnu.org/bugs/?48180

2016-05-31  Bernhard Voelker  <mail@bernhard-voelker.de>

	Fix bug #48030: find: -exec + does not pass all arguments in certain cases
	When the -exec arguments buffer (usually 128k) is full and the given
	command has been executed with all that arguments, find(1) missed to
	execute the command yet another time if only 1 another file would have
	to be processed.
	Both find(1), i.e., nowadays FTS-version, and oldfind are affected.
	This bug was present since the implementation of '-exec +' in 2005,
	see commit FINDUTILS_4_2_11-1-25-gf0a6ac6.

	* lib/buildcmd.c (bc_push_arg): Move the assignment to set 'state->todo'
	to 1 down after the immediate execution which resets that flag.
	* find/testsuite/sv-48030-exec-plus-bug.sh: Add a test.
	* find/testsuite/Makefile.am (test_shell_progs): Reference the test.
	* NEWS (Bug Fixes): Mention the fix.

	Reported by Joe Philip Ninan <indiajoe@gmail.com> in
	https://savannah.gnu.org/bugs/?48030

2016-05-30  Andreas Metzler  <ametzler@bebt.de>

	maint: avoid implicit declaration of function warning
	* find/parser.c: Remove unused #include "bugreports.h".
	* find/util.c: Add #include "bugreports.h".

2016-05-18  Steve Dougherty  <sdougherty@barracuda.com>  (tiny change)

	doc: fix spelling of "output"
	* doc/find.texi (node Controlling Parallelism): s/ouptut/output/
	* xargs/xargs.1: Likewise.
	* find/util.c (cleanup): While at it, fix the same typo here
	in a comment, too.

2016-04-18  Kamil Dudka  <kdudka@redhat.com>

	doc: clarify exit status handling of -exec command {} +
	* find/find.1 (-exec): Explain how exit status is propagated if the
	-exec command {} + syntax is used.
	(-execdir): Likewise.

	Reported at https://bugzilla.redhat.com/1325049

2016-04-10  Young Mo Kang  <kym327@gmail.com>

	maint: correct some misspelled words in README-hacking
	* README-hacking: Do the above.

2016-04-10  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: support list of file types for -type and -xtype
	* find/defs.h (enum file_type): Add enumeration for all (supported)
	file types.
	(struct predicate): Replace 'type' by 'types' as an array of bool
	for the above enum file_type.
	* find/parser.c (insert_type): Treat the argument to -type and -xtype
	as a comma-separated list of type letters: instead of storing the
	single type of the predicate, save the searched type letters in the
	above 'types' array.
	* find/pred.c (pred_type): Change the comparison against the saved file
	type predicate: now check if the type of the actual file is in the array
	of searched 'types'.
	* find/testsuite/test_type-list.sh: Add test.
	* find/testsuite/Makefile.am: Reference the test.
	* find/find.1: Document the new feature.
	* doc/find.texi: Likewise.
	* NEWS: Likewise.
	RFE originally initiated by Young Mo Kang in
	http://lists.gnu.org/archive/html/bug-findutils/2016-02/msg00025.html

2016-03-25  James Youngman  <jay@gnu.org>

	fix bug #46784: frcode drops last char if no final newline
	* locate/testsuite/config/unix.exp (locate_textonly): Don't append
	a newline to the input file.  Instead use exactly the data
	specified by the caller.  This means that in some cases the input
	now lacks a final newline.  Ignore any warning message produced by
	frcode.
	* locate/frcode.c (main): If the final character of the line
	returned by getdelim is not the delimiter, don't overwrite it with
	a NUL character.  Instead, issue a warning message.
	* NEWS: Mention this bugfix.

2016-03-24  Stephane Chazelas  <stephane.chazelas@gmail.com>  (tiny change)

	Complete the fix for Savannah bug #26092.
	* doc/find.texi (Warning Messages): A warning is no longer
	produced when the -iname predicate is used.

2016-03-24  James Youngman  <jay@gnu.org>

	Update gnulib to the current head.
	* gnulib: Update submodule to current git head.

2016-03-24  James Youngman  <jay@gnu.org>

	Update Greek translation from the Translation Project.
	* po/el.po: Update Greek translation from the Translation Project.
	* NEWS: Mention this change.

2016-03-24  James Youngman  <jay@gnu.org>

	Adopt the use of the gnulib module "gendocs".
	* doc/.gitignore: Ignore gendocs_template and gendocs_template_min,
	since these are copied from gnulib/doc/.
	* cfg.mk (manual_title): Set $manual_title, since this is needed
	for maint.mk's nvocation of gendocs.sh.  Also set
	$gendocs_options_ so that the Texinfo tools can find
	dblocation.texi.
	* build-aux/.gitignore: Ignore gendocs.sh since it is copied into
	this directory by gnulib-tool (the file is part of the gendocs
	module).
	* bootstrap.conf (maintainer_modules): Add gendocs, so that we can
	automate the generation of HTML and other documentation for
	http://www.gnu.org/software/findutils.

2016-03-22  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: fix example in find.1
	* find/find.1 (EXAMPLES): In the example to skip SCM administrative
	directories, parenthesize "\( ... \)" the ORed tests.  Otherwise, only
	the SCM roots matching the last test, "CVS", are printed.

	Reported in http://savannah.gnu.org/bugs/?47482

2016-02-16  Bernhard Voelker  <mail@bernhard-voelker.de>

	build: stop distributing gzip'd releases;  xz is enough
	* configure.ac (AM_INIT_AUTOMAKE): Add no-dist-gzip and dist-xz.
	* NEWS (Build-related): Mention that we're dropping .tar.gz.

2016-02-16  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: improve description of the -D option in find.1
	* find/find.1 (-D): Change argument name from "debugoptions" to
	"debugopts" to match the synopsis, thus making searching in the man
	page easier.  While at it, sort possible arguments alphabetically.

2016-02-16  Bernhard Voelker  <mail@bernhard-voelker.de>

	all: output full usage only when requested via the --help option
	When there are invalid options or arguments, all utilities printed the
	full usage in addition to the original error diagnostic.  The quite
	large text distracted the user's attention from the error message.

	* find/defs.h (usage): Mark as _GL_ATTRIBUTE_NORETURN, and remove the
	arguments FP and MSG.
	* find/parser.c (parse_help): Factor out the usage text from here ...
	* find/util.c (usage): ... to here.  Unless called with EXIT_SUCCESS,
	just emit a short hint to try again with the --help option rather than
	emitting the full usage.  Afterward, exit the program with the given
	status.
	(debugassoc): Sort array, as it is used in that order when outputting
	the usage text.
	(process_debug_options): Also output an error diagnostic when no
	argument to -D is passed.
	(show_valid_options): Always output to stdout, always output the header
	line.  Update all callers.
	* find/tree.c (build_expression): Update invocation of usage().
	Also call it for syntax errors like unknown or invalid predicates
	or invalid or missing arguments.
	* locate/frcode.c (usage): Similar to the change in util.c (usage).
	(main): Update invocation of usage().  Also output an error diagnostic
	when an unexpected argument is passed.
	* locate/locate.c (usage):  Similar to the change in util.c (usage).
	(dolocate): Update invocation of usage().  Also output an error
	diagnostic when an unexpected argument is passed.
	* locate/updatedb.sh: Output "Try ... --help ..." when an invalid option
	is passed.
	* xargs/xargs.c (usage): Similar to the change in util.c (usage).
	(parse_num, main): Update all callers, removing the now-obsolete
	return or exit().
	* NEWS (Improvements): Mention the change.

2016-02-16  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: adjust .gitignore files
	* lib/.gitignore: Use pattern for prominent suffixes like *.o, *.log
	and *.a; an entry for the new intermediate file bugreports.o was missing
	here.  Sort file.
	* locate/.gitignore (bigram,code,bigram.o,code.o): Remove, as these
	programs have been removed with commit v4.6.0-44-g89ec021.
	* find/.gitignore: Use pattern for *.o, and sort the file.
	* xargs/.gitignore: Likewise.

2016-02-16  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: add new bugreports.c to POTFILES.in
	* po/POTFILES.in (lib/bugreports.c): Add entry.

2016-02-16  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: avoid syntax-check failures
	'make syntax-check' failed with:

	  locate/word_io.h:
	  maint.mk: the above files include assert.h but don't use it
	  maint.mk:479: recipe for target 'sc_prohibit_assert_without_use' failed
	  ...
	  lib/bugreports.h:
	  maint.mk: empty line(s) or no newline at EOF
	  maint.mk:929: recipe for target 'sc_prohibit_empty_lines_at_EOF' failed

	* locate/word_io.h (#include <assert.h>): Remove superfluous inclusion
	of <assert.h>.
	* lib/bugreports.h: Remove stray empty line at EOF.

2016-01-26  James Youngman  <jay@gnu.org>

	Update Danish translation.
	* po/da.po: Update Danish translation from the Translation Project.
	* NEWS: Mention this change.

2016-01-26  James Youngman  <jay@gnu.org>

	updatedb: use the common definitions of the bug-report URL etc.
	* locate/Makefile.am (updatedb): Substitute PACKAGE_BUGREPORT,
	PACKAGE_BUGREPORT_URL and PACKAGE_URL.  We do this in the Makefile
	directly since updatedb.sh is not an output file generated
	directly by configure (instead, it's generated by the Makefile
	itself).
	* configure.ac (PACKAGE_BUGREPORT_URL): AC_DEFINE defines only a
	preprocessor macro.  In order to get a similar effect for
	substituted output files, we need to use AC_SUBST.  Hence
	introduce a shell variable $bugreport_url which we pass to both
	AC_SUBST and AC_DEFINE_UNQUOTED (replacing the previous call to
	AC_DEFINE).
	* locate/updatedb.sh (usage): Use PACKAGE_URL and PACKAGE_BUGREPORT_URL.

2016-01-26  James Youngman  <jay@gnu.org>

	Better and more consistent guidance on how to report bugs.
	* configure.ac (PACKAGE_BUGREPORT_URL): Define this macro to point
	to the findutils bug-reporting web page.
	* lib/bugreports.c: New file, defining the function
	explain_how_to_report_bugs which explains how to report bugs.  Use
	the new PACKAGE_BUGREPORT_URL macro.
	* lib/bugreports.h: New file, providing a declaration of
	explain_how_to_report_bugs.
	* lib/Makefile.am (libfind_a_SOURCES): Add bugreports.c and
	bugreports.h.
	* find/parser.c (parse_help): Call explain_how_to_report_bugs
	instead of printing an explanation here.
	* xargs/xargs.c (usage): Likewise.
	* locate/locate.c (usage): Likewise.
	* locate/code.c (usage): Likewise.
	* locate/frcode.c (usage): Likewise.
	* locate/updatedb.sh (usage): Produce a similar message
	by including it in the usage text itself.

2016-01-25  James Youngman  <jay@gnu.org>

	xargs: better error message for xargs -s notanumber.
	* xargs/xargs.c (parse_num): Specify the value passed for the
	invalid argument to make it easier to debug things when bug
	reports don't specify the actual command line.

2016-01-10  James Youngman  <jay@gnu.org>

	updatedb: Remove support for the old pre-4.0 database format.
	* locate/testsuite/Makefile.am (EXTRA_DIST_EXP): Remove
	locate.gnu/old_prefix.exp and locate.gnu/oldformat.exp.
	(EXTRA_DIST_XO): Remove locate.gnu/old_prefix.xo and
	locate.gnu/oldformat.xo.
	* doc/find.texi (Database Formats): Remove the warning about old
	versions of locate failing to read the LOCATE02 database format.
	Mention that the slocate database format is also supported.
	(Old Database Format): Point out that updatedb will no longer
	produce the old format.
	(Invoking updatedb): Remove mention of the --old-format option.
	Remove mention of --dbformat=old.
	(Long File Name Bugs with Old-Format Databases): Remove this
	section.
	* locate/updatedb.sh: remove support for --dbformat=old and
	--old-format.
	(checkbinary): Don't look for the bigram and code binaries.
	* locate/updatedb.1: Explain that support for the old database
	format has been removed from updatedb and will shortly be removed
	from locate also.  Remove the documentation for the removed
	option --old-format and mention of --dbformat-old.
	* locate/code.c: remove since this program was only used to
	generate old-format databases.
	* locate/bigram.c: remove since this program was only used to
	generate old-format databases.
	* po/POTFILES.in: Remove bigram.c and code.c.
	* locate/word_io.c (putword): Remove this function, since it was
	only needed for making old-format databases.
	* find/find.1 (NON-BUGS): Don't mention bigram.c and code.c in the
	example.
	* locate/locatedb.h: Remove declaration of putword, which has been
	deleted.
	* locate/Makefile.am (libexec_PROGRAMS): Remove bigram and code
	(since they were only used to generate old-format databases).
	(updatedb): Don't substitute @bigram@ and @code@.
	(code_SOURCES): Delete.
	* locate/testsuite/locate.gnu/old_prefix.exp: delete test case for
	the old database format.
	* locate/testsuite/locate.gnu/old_prefix.xo: Likewise.
	* locate/testsuite/locate.gnu/oldformat.exp: Likewise.
	* locate/testsuite/locate.gnu/oldformat.xo: Likewise.
	* TODO: manpages for bigram and code are no longer needed.
	* NEWS: Mention these changes.

2016-01-10  James Youngman  <jay@gnu.org>

	updatedb: the order of file name is changed, but still unspecified.
	* locate/updatedb.sh: fix typo in comment pointed out by Bernhard
	Voelker.
	* NEWS: point out that the order of file names in the locate
	database is now different, but still unspecified.

2016-01-09  James Youngman  <jay@gnu.org>

	updatedb: run in the C locale, don't do case-folding.
	* locate/updatedb.sh: Set LC_ALL to C to avoid unexpected character
	encodings in path names causing sort to fail (idea from Clarence
	Risher).  Don't do case-folding, since the character set in now C,
	which is likely inconsistent with the user's expectations anyway.
	Honour $TMPDIR. Correct the error message you get if you specify
	both --old-format and --dbformat.
	* NEWS: Explain these changes.

2016-01-06  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: make copyright statements more consistent
	Avoid growing lists of copyright year numbers by collapsing consecutive
	years like "1996, 1997-2015, 2016" into a single range like "1996-2016".
	This change may take effect the next time 'make update-copyright' is run.

	* cfg.mk (update-copyright-env): Add with UPDATE_COPYRIGHT_USE_INTERVALS=1
	as described above.  Also add UPDATE_COPYRIGHT_FORCE=1 to rejoin some
	split lines if necessary.

2016-01-06  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: add copyright header to configure.ac
	* configure.ac: Do the above.

2016-01-06  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: clarify that .x-update-copyright entries are EREs
	The entries in the exemption list are processed by
	"grep -vEf ./.x-update-copyright" and therefore evaluated as an
	extended regular expression (ERE).  Thus, e,g, a "bootstrap" entry
	would also match for "bootstrap.conf" which we may want to be updated.
	The current entries are unambiguous so far, but to avoid confusion when
	adding further entries in the future, turn them into proper EREs.

	* .x-update-copyright: Change all entries to EREs, i.e. including
	the caret ^ and dollar sign $ meta-characters matching the beginning
	and the end of a line.

2016-01-05  James Youngman  <jay@gnu.org>

	find: point out more clearly that -a has a higher precendence than -o.
	* find/find.1 (OPERATORS): Point out that -o has lower precendence
	than -a, even when the -a is implicit.
	(NON-BUGS): Explain the same thing here.

2016-01-04  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: don't use obsolete gnulib modules
	Avoid bootstrap warnings:

	  Notice from module malloc:
	    This module is deprecated. Use the module 'malloc-gnu' instead.
	  Notice from module realloc:
	    This module is deprecated. Use the module 'realloc-gnu' instead.

	* bootstrap.conf (gnulib_modules): Use malloc-gnu and realloc-gnu
	modules, rather than malloc and realloc.  The shorter-named modules
	are deprecated.

2016-01-04  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: fix typo in find.1
	* find/find.1 (GLOBAL OPTIONS): s/occurr/occur/

2016-01-04  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: fix file name in message of findutils-check-pofiles
	* Makefile.am (findutils-check-pofiles): s/configure\.in/configure.ac/,
	as that file has been renamed long ago (FINDUTILS_4_3_8-1-50-gc4ef190).
	While at it, re-indent the lines to shorten the lines for readability.
	(coverage-clean): Re-indent likewise.
	(gen-ChangeLog): While at it, replace leading blanks by a tab here for
	a proper make syntax; introduced in previous commit (v4.6.0-17-g48bf0d0).

2016-01-04  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: update .gitignore files, remove obsolete .cvsignore files
	* .gitignore (tool-versions.txt): Add entry.
	(ABOUT-NLS): Change to ...
	(/ABOUT-NLS): ... this to avoid ./bootstrap adding it again.
	* build-aux/.gitignore (/ar-lib, /snippet/, /test-driver): Add entries.
	While at it, use the git-specific '/' prefix on other entries, and sort
	the file.
	* doc/.gitignore (/dblocation.texi): Add entry.  Prefix other entries
	with '/' and sort the file.
	* find/.gitignore (/exec.o, /print.o): Likewise.
	* find/testsuite/.gitignore (/configured-testfiles.txt, /*.log, /*.trs):
	Likewise.
	* lib/.gitignore (check-regexprops, /check-regexprops.log,
	/check-regexprops.trs, /regexprops.texi.new, /splitstring.o,
	/test_splitstring, /test_splitstring.log, /test_splitstring.o
	/test_splitstring.trs, /test-suite.log): Likewise.
	* po/.gitignore (/Makevars): Add entry.  While at it, prefix all
	other entries with '/', too, to avoid bootstrap adding entries for
	e.g. "/Makefile.in.in" again.
	* .cvsignore: Remove file.
	* build-aux/.cvsignore: Likewise.
	* doc/.cvsignore: Likewise.
	* find/.cvsignore: Likewise.
	* find/testsuite/.cvsignore: Likewise.
	* lib/.cvsignore: Likewise.
	* locate/.cvsignore: Likewise.
	* locate/testsuite/.cvsignore: Likewise.
	* m4/.cvsignore: Likewise.
	* po/.cvsignore: Likewise.
	* xargs/.cvsignore: Likewise.
	* xargs/testsuite/.cvsignore: Likewise.

2016-01-04  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: remove po/Makevars as it is created during bootstrap
	* po/Makevars: Remove.  This also avoids an sc_trailing_blank failure
	due to a blank character after the empty EXTRA_LOCALE_CATEGORIES.

2016-01-04  Bernhard Voelker  <mail@bernhard-voelker.de>

	build: avoid bootstrap error on clean tree
	Avoid the following error when running ./bootstrap on a clean tree:

	  autoreconf: running: aclocal -I gl/m4 --force -I gl/m4 -I m4
	  configure.ac:129: error: AC_PROG_CC cannot be called after AM_PROG_CC_C_O
	  ../../lib/m4sugar/m4sh.m4:639: AS_IF is expanded from...
	  ../../lib/autoconf/general.m4:1462: AC_ARG_ENABLE is expanded from...
	  configure.ac:129: the top level
	  autom4te: /usr/bin/m4 failed with exit status: 1
	  aclocal: error: echo failed with exit status: 1
	  autoreconf: aclocal failed with exit status: 1
	  ./bootstrap: autoreconf failed

	* configure.ac (compiler-warnings-are-errors): Remove AC_PROG_CC, as this
	has already run before and is not allowed at this point anyway.

2016-01-04  James Youngman  <jay@gnu.org>

	maint: update copyright years.
	* lib/regexprops.c (copying): Update the text so that the
	copyright years (and the line breaks) match the
	result of "make update-copyright".
	* doc/regexprops.texi: Tweak copyright years to match the
	result of "make update-copyright".
	* All other files: update copyright years if the file has
	a copyright statement.
	* .x-update-copyright: new file, a list of files to exclude
	from automated copyright updates.

2016-01-04  James Youngman  <jay@gnu.org>

	regexprops: Fix compiler warnings and update copyright years.
	* lib/regexprops.c (newpara): Function parameter list should be
	declared as void in the function definition, instead of leaving it
	blank (C++ style).  This fixes a GCC warning controlled by
	-Wstrict-prototypes.
	(beginenum): Likewise.
	(endenum): Likewise.
	(endtable): Likewise.
	(copying): Update copyright years.
	* doc/regexprops.texi: Update copyright years to match the output
	of regexprops.c.

2016-01-03  James Youngman  <jay@gnu.org>

	configure: Add option --enable-compiler-warnings-are-errors, limit --enable-compiler-warnings.
	* configure.ac: For --enable-compiler-warnings, don't enable
	warnings that flag usage common in gnulib (such as variable-length
	arrays) or which provide no value (such as switch statements
	lacking a default case that would never be used).  Also don't
	enable some useful warnings (such as missed opportunitied to mark
	a function as pure) which we don't yet have a portable way of
	avoiding.
	Also add a new option --enable-compiler-warnings-are-errors,
	turning GCC compiler warnings into errors.  This is off by
	default.

2016-01-03  James Youngman  <jay@gnu.org>

	find: Avoid dynamic format strings.
	* find/print.c (do_fprintf): Don't use a dynamic format string,
	even when we know it contains no formatting directives, because
	this confuses whatever produces the GCC warning
	-Wformat-security.

2016-01-03  James Youngman  <jay@gnu.org>

	find: fix some compiler warnings.
	* find/util.c (check_nofollow): Avoid compiler warnings about
	comparison between the float variable release and some double
	constants by changing the constants to be floats, too.
	* find/parser.c (estimate_file_age_success_rate): Avoid warnings
	of comparison of float against other types by consistently using
	float constants.
	(insert_type): move the definition of type_cell and set it in the
	switch cases handling S_IFLINK and other types of file which may
	not be defined on the platform we're building for.  We do this in
	order to silence a compiler warning about use of an uninitialised
	value.  It's not really used uninitialised, it's just that the
	compiler doesn't know that the way we're calling error() will
	cause that function not to return.
	(parse_time): Avoid a compiler warning about signed/unsigned
	comparison by using a cast.
	* find/ftsfind.c: Don't #define USE_SAFE_CHDIR, it's unused.
	Likewise STRINGIFY.
	(show_outstanding_execdirs): Avoid overflowing int variable seen
	by making a bool and setting it to true, instead of incrementing
	it.
	(main): Correct the call to ctime; it takes time_t*, so don't pass
	struct timeval* (instead, pass the address of the tv_sec member).
	* find/exec.c (launch): Avoid warnign of unused parameter ctl.  We
	really don't use it, but this function takes the parameter as
	it's a callback.
	* find/pred.c (struct pred_assoc): make the pred_name member const.
	* find/defs.h: Declare pred_quit as _GL_ATTRIBUTE_NORETURN.

2016-01-03  James Youngman  <jay@gnu.org>

	locate: Fix compiler warnings.
	* locate/word_io.c (decode_value): Fix typo in comment.
	(getword): Remove unused parameter minvalue.
	* locate/locatedb.h: Adjust declaration of decode_value to remove
	minvalue parameter.
	* locate/locate.c: Declare dolocate().  Make that function static.
	(visit_old_format): Don't pass a minvalue parameter to getword()
	since it no longer wants it.

2016-01-03  James Youngman  <jay@gnu.org>

	lib: Update the width of the st_nlink field and fix some compiler warnings.
	* lib/listfile.h (list_file): Make the relname parameter const.
	* lib/listfile.c (list_file): Make the relname parameter const.
	Remove the unused local variable inode_field_width.  Update
	nlink_width with the greatest width of the st_nlink field, and
	print the field using the maximum width (as we do for other
	fields).

2016-01-03  James Youngman  <jay@gnu.org>

	xargs: Avoid unused-macro warnings.
	* xargs/xargs.c (main): Use __STDC_LIMIT_MACROS to avoid a
	compiler warning about an unused macro.  Don't define N_() at all, since
	we don't use it.

2016-01-03  James Youngman  <jay@gnu.org>

	find: Fix a number of compiler warnings (mostly const-correctness).
	* find/find.c (get_current_dirfd): remove unused function.
	(process_dir): make parameters const: parent, pathname, name.
	(process_path): make parameters const: parent, pathname, name.
	(at_top): Modify the function pointer parameter accordingly.
	* find/ftsfind.c (get_fts_info_name): Now returns const char*, not
	char*.
	(show_outstanding_execdirs): Fix type of loop variable to avoid
	possible overflow.
	(process_all_startpoints): Avoid compiler warning about overflow
	of int loop variable.
	* find/defs.h (struct predicate): Make p_name const.
	(struct state): make rel_pathname const.
	* find/exec.c (impl_pred_exec): Make prefix const.
	(launch): Silence compiler warning about unused parameter argc.
	* find/pred.c (blank_rtrim): Make str parameter const, since we do
	not modify it.
	* find/util.c (debug_option_assoc): name and docstring are now
	const qualified.
	(show_valid_debug_options): Avoid signed/unsigned comparison by
	using a size_t array index.
	(set_stat_placeholders): Avoid a compiler warning on systems
	lacking birth time fields (and on which this function therefore
	does nothing).

2016-01-03  James Youngman  <jay@gnu.org>

	maint: Don't define the gettext-related macro N_ where it is not needed.
	* lib/buildcmd.c: Don't define the macro N_(), since we don't use
	it.
	* lib/fdleak.c: Likewise.
	* lib/safe-atoi.c: Likewise.
	* lib/regextype.c: Likewise.
	* lib/listfile.c: Likewise.
	* locate/bigram.c: Likewise.
	* locate/code.c: Likewise.
	* locate/frcode.c: Likewise.
	* locate/word_io.c: Likewise.
	* find/fstype.c: Likewise.
	* find/parser.c: Likewise.
	* find/pred.c: Likewise.
	* find/exec.c: Likewise.
	* find/tree.c: Likewise.
	* find/util.c: Likewise.
	* find/print.c: Likewise.
	* find/ftsfind.c: Likewise.

2016-01-03  James Youngman  <jay@gnu.org>

	maint: Remove --I../intl from AM_CPPFLAGS; the directory is gone.
	* find/Makefile.am (AM_CPPFLAGS): Remove -I../intl, since that
	directory does not exist; it was removed in 2006 by Paul Eggert
	(commit 9499a434f9da547373fa9d236cb397717ebb0c50).
	* locate/Makefile.am (AM_CPPFLAGS): Likewise.
	* xargs/Makefile.am (AM_CPPFLAGS): Likewise.

2016-01-03  James Youngman  <jay@gnu.org>

	Make use of suggested GCC function attributes.
	* gnulib-local/lib/gcc-function-attributes.h: New header file,
	providing macros to allow portable use of GCC function attributes.
	* gnulib-local/modules/gcc-attributes: New (local) module.
	* bootstrap.conf (local_gl_dir): Set local_gl_dir so that we can
	use our new module.  Use the gcc-attributes module.
	* find/defs.h:
	Include gcc-function-attributes.h.  Delete our local macro
	ATTRIBUTE_NORETURN and use the one from the header file.
	* find/parser.c: Include gcc-function-attributes.h.  Add
	_GL_ATTRIBUTE_NORETURN to parse_help, parse_version and
	pred_quit.
	* find/print.c (checked_fprintf): add attribute
	_GL_ATTRIBUTE_FORMAT_PRINTF to the function declaration.

2016-01-03  James Youngman  <jay@gnu.org>

	lib: FINDLIB_REPLACE_FUNCS has become obsolete, so delete findlib.
	* configure.ac: gnulib supplies waitpid and C89 supplies strspn.
	Hence there is no need for any call to FINDLIB_REPLACE_FUNCS.
	That being the case we don't need to test it with forcefindlib.
	* m4/findlib.m4: remove since FINDLIB_REPLACE_FUNCS is unused.
	* m4/Makefile.am (EXTRA_DIST): findlib.m4 has been deleted, so
	don't distribute it.
	* lib/waitpid.c: remove, since gnulib provides this.
	* lib/forcefindlib.c: remove, since there is no longer any need to
	test FINDLIB_REPLACE_FUNCS.
	* lib/Makefile.am (libfind_a_SOURCES): Specify this variable all
	in one go, instead of in several parts.  Move some header files
	into here instead of just having them in EXTRA_DIST.  Because
	FINDLIBOBJS is empty now, there is no need to copy that to
	libfind_a_LIBADD.

2016-01-03  James Youngman  <jay@gnu.org>

	gnulib: update to current head.

2016-01-02  James Youngman  <jay@gnu.org>

	Add a shell script to generate ChangeLog; strip cherrypick comments.
	* build-aux/gen-changelog.sh: Shell script for generating the
	ChangeLog.  The effect is much the same as the previous version of
	the gen-ChangeLog rule, but it is easier to run this script to
	discover what the ChangeLog resulting from a recent commit is.
	The only change is that we now also use --strip-cherry-pick.
	* build-aux/Makefile.am (EXTRA_DIST): Distribute gen-changelog.sh.
	* Makefile.am (gen-ChangeLog): Simplify the gen-ChangeLog rule by
	calling gen-changelog.sh.

2016-01-02  James Youngman  <jay@gnu.org>

	Update the German and Dutch translations.
	* po/de.po: Update from the Translation Project.
	* po/nl.po: Likewise.
	* NEWS: Mention this change.

2016-01-02  James Youngman  <jay@gnu.org>

	Update estimated success rates from a survey of a real file system.
	* find/pred.c (print_optlist): output now distinguishes more
	clearly between estimated and actual success rates.
	* find/parser.c (insert_type): Use estimated success rates
	computed by surveying a real file system.  Use 4 digits of
	precision for est_success_rate.
	* find/tree.c (print_tree): Consistently use 4 digits of precision
	for est_success_rate.

2016-01-01  James Youngman  <jay@gnu.org>

	Avoid a test's unnecessary dependence on xargs.
	Problem report from Ludovic Courtès (though this fix is unlike the one he
	suggested).
	* find/testsuite/sv-34976-execdir-fd-leak.sh (make_test_data):
	Don't assume that there is an xargs binary already on the path.

2016-01-01  James Youngman  <jay@gnu.org>

	Retire configure --enable-debug in favour of find -D ...
	* find/defs.h (enum DebugOption): add DebugTime.
	* find/util.c (debugassoc): -D time sets the DebugTime debug flag.
	* find/oldfind.c (main): print the value of options.cur_day_start
	when "-D time" is in effect (instead of when DEBUG is #defined).
	* find/ftsfind.c (main): Likewise.
	* find/pred.c (pred_table): Instantiate pred_table even if DEBUG
	is not #defined.
	* find/parser.c (parse_version): DEBUG is no longer a (distinct)
	feature.
	* configure.ac: Remove the --enable-debug option (all debugging is
	now controlled via find's -D option).  Don't #define the
	preprocessor macro DEBUG.
	* NEWS: Mention this change.

2016-01-01  James Youngman  <jay@gnu.org>

	Eliminate the need for the DEBUG_STAT preprocessor macro.
	* configure.ac: We no longer need to #define DEBUG_STAT with
	--enable-debug, since the relevant debug messages are controlled
	instead with find's command-line option -D stat.
	* find/defs.h (enum DebugOption): bitmask values are now expressed
	as 1 << N instead of decimal values, simply to make it clearer
	when we need to start worrying about which integer type is used to
	hold the bitmask.
	* find/parser.c (fallback_getfilecon): Print a debug message when
	the -D stat option is in effect, whether or not find was
	configured with --enable-debug.
	(parse_version): DEBUG_STAT is no longer a (distinct) feature.

2016-01-01  James Youngman  <jay@gnu.org>

	Remove the --enable-id-cache configure option.
	* configure.ac: Remove the --enable-id-cache option.  This option
	became a no-op in findutils-4.5.15.  Before that it did something
	but the code was buggy.  See https://savannah.gnu.org/bugs/?45062
	for details.
	* NEWS: State that this configure option is removed.

2016-01-01  James Youngman  <jay@gnu.org>

	Update the Hungarian translation

2016-01-01  Andreas Metzler  <ametzler@bebt.de>

	Add/elaborate on warning about find -size -1M.
	* find/find.1: Elaborate on warning about find -size -1M.
	* find.texi: Copy warning about find -size -1M from manpage.

2016-01-01  Andreas Metzler  <ametzler@bebt.de>

	Document that %AT/%AX prints nanoseconds.
	* doc/find.texi: Both %AT and %AX printf format specifiers print
	nanoseconds since 4.3.3. - Document this.
	* find/find.1: Likewise.

2015-12-31  James Youngman  <jay@gnu.org>

	Remove unused spell-checker LocalWords from TODO.
	* TODO (LocalWords): Remove words which aren't actually used in
	the document.

2015-12-31  James Youngman  <jay@gnu.org>

	Update the Slovak translation.
	* po/sk.po: Update from the Translation Project.
	* NEWS: mention this.

2015-12-30  James Youngman  <jay@gnu.org>

	Retire the Kinyarwanda translation.
	For some time now, this translation has had 0 out of the possible 283
	messages actually translated, so the po file has no current value.  If
	any findutils are once again translated this translation can be
	reinstated.
	* configure.ac: Remove rw from ALL_LINGUAS.
	* po/rw.po: Delete.

2015-12-30  James Youngman  <jay@gnu.org>

	Update release number to indicate that the Git tree no longer matches 4.6.0.
	* configure.ac: Update version number to indicate that the Git
	repository has moved on from 4.6.0 (the trunk will be 4.7.x release
	series).
	* NEWS: Likewise.

2015-12-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: mention 'make syntax-check' in README-hacking
	* README-hacking (Submitting patches): Add the above.

2015-12-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: mention copyright assignment check prior to 'git push'
	* README-hacking (Required format for check-in messages): Add a paragraph
	aiming at maintainers to check that the author of the commit has proper
	copyright assignment in place, or otherwise how to document that this
	is not needed.

2015-12-30  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: fix typos in README-hacking
	* README-hacking (Required format for check-in messages): s/maded/made/;
	s/modifies/modified/

2015-12-28  James Youngman  <jay@gnu.org>

	Release findutils version 4.6.0.  This is a stable release.
	* configure.ac: Update the version number to 4.6.0.
	* NEWS: Update the version number to 4.6.0.  Add a release date.
	Summarize the changes since the previous stable release.  Explain
	that all bugs fixed in 4.4.x are also fixed in this release.

2015-12-28  James Youngman  <jay@gnu.org>

	Update the Danish translation.
	* po/da.po: Update the Danish translation.
	* NEWS: Mention this update.

2015-12-28  James Youngman  <jay@gnu.org>

	Fix a typo in bootstrap.conf.
	* bootstrap.conf (maintainer_modules): Fix typo 'consder'.

2015-12-28  Dmitry V. Levin  <ldv@altlinux.org>

	Fix compilation warning.
	xargs.c: In function 'fopen_cloexec_for_read_only':
	xargs.c:387:1: warning: control reaches end of non-void function [-Wreturn-type]
	* xargs/xargs.c (fopen_cloexec_for_read_only): Return result.

2015-12-28  James Youngman  <jay@gnu.org>

	Move on from release 4.5.19.
	* configure.ac: Advance the version to 4.5.20-git, signifying that
	the code in the repository is no longer identical to that of the
	4.5.19 release.
	* NEWS: Likewise.

2015-12-28  James Youngman  <jay@gnu.org>

	Release findutils version 4.5.19.
	* configure.ac: Update version number to 4.5.19.
	* NEWS: Likewise, and also specify the release date.

2015-12-28  James Youngman  <jay@gnu.org>

	Previous spelling fix was from a Savannah-managed patch, not a bug report.
	* NEWS: Correct the description of the previous change.
	* build-aux/git-log-fix: Correct previous ChangeLog entry.

2015-12-28  Ville Skyttä  <ville.skytta@iki.fi>  (tiny change)

	Spelling fixes (applying Savannah patch #8688).
	* locate/locate.c: typo fix: whcih
	* doc/find.texi: typo fix: futher
	* bootstrap.conf: spelling fix: consistant
	* NEWS: Mention this change.

2015-12-28  Bjarni Ingi Gislason  <bjarniig@rhi.hi.is>  (tiny change)

	Improved formatting.
	Patch contributed via http://bugs.debian.org/726870
	* find/find.1: A full stop (.) that starts or ends a string and is a
	part of it, is now protected with \& and the space between some
	sentences has been reduced or increased.

2015-12-28  Bjarni Ingi Gislason  <bjarniig@rhi.hi.is>  (tiny change)

	Typo and grammar fixes.
	Issue and patch via http://bugs.debian.org/726870
	* find/find.1: correct typos: filsystem, signifiy, immeidately
	* find/find.1: correct grammar: which would -> which you would

2015-12-28  James Youngman  <jay@gnu.org>

	Apply some improvements suggested by Mike Frysinger.
	These improvements were suggested at https://savannah.gnu.org/bugs/?46714.
	* find/Makefile.am (check_PROGRAMS): Put oldfind in check_PROGRAMS
	instead of noinst_PROGRAMS, so that we don't build it when it is
	not needed.
	* m4/withfts.m4 (FIND_WITH_FTS): Fix whitespace alignment.
	(FIND_WITH_FTS): The WITH_FTS C preprocessor macro and the
	accompanying Automake conditional are no longer needed.
	* THANKS: Add Mike Frysinger.

2015-12-28  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: avoid sc_prohibit_always_true_header_tests failure.
	* configure.ac: Check for getrlimit function directly rather than the
	"sys/resource.h" header file.
	* lib/fdleak.c: Include "sys/resource.h" when HAVE_GETRLIMIT is set.
	(get_max_fd): s/HAVE_GETRUSAGE/HAVE_GETRLIMIT/.

2015-12-28  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: avoid syntax-check failures
	* Makefile.am (gen-ChangeLog): Replace 8 spaces by a tab to avoid
	sc_makefile_TAB_only_indentation failure.
	* po/POTFILES.in: Remove some entries to let sc_po_check pass.
	While at it, sort the entries.
	* find/print.c (do_fprintf): Remove stray semicolon to let
	sc_prohibit_double_semicolon pass.
	* find/util.c (digest_mode): Likewise.
	* bootstrap.conf: Change comment to let sc_prohibit_doubled_word pass.
	* build-aux/git-log-fix: Remove empty lines at EOF to let
	sc_prohibit_empty_lines_at_EOF pass.
	* find/testsuite/Makefile.am: Likewise.
	* find/testsuite/sv-34079.sh: Likewise.
	* find/testsuite/test_inode.sh: Likewise.
	* locate/testsuite/locate.gnu/slocate.exp: Likewise.
	* lib/buildcmd.c: Remove unused include of openat header to let
	sc_prohibit_openat_without_use pass.
	* lib/listfile.c: Likewise.
	* find/util.c: Remove unused include of 'verify.h' to let
	sc_prohibit_verify_without_use pass.
	* xargs/xargs.c: Likewise.
	* find/parser.c (insert_regex): Mark error diagnostic for translation;
	found by 'make sc_unmarked_diagnostics'.
	* cfg.mk (exclude_file_name_regexp--sc_prohibit_strncpy): Exempt the
	2 remaining sources using the possibly dangerous strncpy function
	from the syntax-check.

2015-12-28  James Youngman  <jay@gnu.org>

	Move on from the previous release.
	* configure.ac: Update version number to 4.5.19-git, signifying
	that the source tree in Git is not the same as the 4.5.18 release.
	* NEWS: Likewise.

2015-12-27  James Youngman  <jay@gnu.org>

	Release findutils-4.5.18.
	* configure.ac: Update version number to 4.5.18.
	* NEWS: Likewise, and set the release date to 2015-12-27.

2015-12-27  James Youngman  <jay@gnu.org>

	Updated po files as a side effect of "make dist".
	* po/*.po: updated by "make dist".
	* po/findutils.pot: updated by "make dist".

2015-12-27  James Youngman  <jay@gnu.org>

	Rename find/find.c to find/oldfind.c.
	* find/Makefile.am (oldfind_SOURCES): rename find.c to oldfind.c.
	* find/.gitignore: Likewise.
	* po/POTFILES.in: rename find/find.c to find/oldfind.c
	* find/defs.h: Change references to find.c to oldfind.c.
	* doc/find-maint.texi (Factor Out Repeated Code): Likewise.
	* find/ftsfind.c: Point out that this file is derived from
	oldfind.c (instead of leaving a reference to the old name of the
	renamed file).
	* find/testsuite/config/unix.exp: Look for ftsfind.o instead of find.o
	when checking that we're really looking at the build directory.

2015-12-27  James Youngman  <jay@gnu.org>

	Remove support for installing oldfind.
	This fulfills a reqeust made as Savannah bug #46714.
	* NEWS: Mention this change.
	* m4/withfts.m4 (FIND_WITH_FTS): --with-fts is the only supported
	choice.  The configure script now fails if run using --without-fts
	or --with-fts=no.
	* find/Makefile.am (noinst_PROGRAMS): Never install oldfind.
	Delete the oldfind.1 and ftsfind.1 manpages, leaving only find.1.
	Fix a typo and remove some commented-out lines.
	* find/find.c (main): add a comment pointing out that this is not
	the main() function of th binary that actually gets installed.
	* find/ftsfind.1: delete.
	* find/oldfind.1: delete.
	* find/find.1: Remove the section "BINARIES" since there are no
	longer two binaries.
	* find/testsuite/config/unix.exp: Assume --with-fts; hence the binaries
	are always called oldfind and find (and there is no ftsfind binary).

2015-12-27  James Youngman  <jay@gnu.org>

	Updated the Slovenian translation

2015-12-27  Andreas Metzler  <gnu@bebt.de>

	Use the official FDL license wording in license text.
	* README-hacking (footer): use the official FDL license wording as
	listed in FDL's "ADDENDUM: How to use this License for your
	documents". Update copyright year.
	* NEWS (footer): Likewise.
	* doc/find-maint.texi: Likewise.
	* doc/find.texi: Likewise.
	* doc/regexprops.texi: Likewise.
	* lib/regexprops.c (copying): Amend the code to emit the updated
	wording.  Update the copyright year.

2015-12-24  Andreas Metzler  <ametzler@bebt.de>

	Fix bashism ([[ ... ]] instead of [ ... ]).
	* find/testsuite/test_escape_c.sh: Use [...] instead of [[...]].

2015-12-24  James Youngman  <jay@gnu.org>

	Fix typo in NEWS file entry for 4.5.17.
	* NEWS: Fix typo.

2015-12-24  James Youngman  <jay@gnu.org>

	Update version number indicating the code post-dates findutils-4.5.17.
	* NEWS: Update version number.
	* configure.ac (AC_INIT): Update version.

2015-12-24  James Youngman  <jay@gnu.org>

	Update version number in preparation for release of findutils-4.5.17.
	* NEWS: Update version number.
	* configure.ac (AC_INIT): Update version.

2015-12-24  James Youngman  <jay@gnu.org>

	Mention upcoming changes to release signing keys.
	* NEWS: Mention upcoming changes to release signing keys.

2015-12-24  James Youngman  <jay@gnu.org>

	Documentation fix for bug #36960 and greater effect of POSIXLY_CORRECT.
	* find/parser.c (parse_table): -warn is now parsed as a positional
	option instead of a global one. This does not affect the effect of
	-warn.  (found_parser): Warnings are no longer issued for global
	options specified in confusing positions when the POSIXLY_CORRECT
	environment variable is set.  POSIXLY_CORRECT also suppresses warnings
	about -d and the use of '/' in the argument to -name.  * find/find.1:
	Eliminate the duplicate section name OPTIONS, using the OPTIONS
	section just for -L, -P and so on.  Other options are now documented
	in the subsection POSITIONAL OPTIONS (if they take effect only on
	items on the command line which appear later) or GLOBAL OPTIONS (if
	they take effect even on tests/actions appearing before them).  The
	-regextype option in particular is now correctly documented as being
	positional.  We rename the EXPRESSIONS section to EXPRESSION in order
	to match the usage summary.  The OPERATORS heading is demoted to a
	subheading so that it fits within EXPRESSION.  (POSITIONAL OPTIONS):
	be more explicit about how warnings are controlled by -warn, -nowarn
	and POSIXLY_CORRECT.  * NEWS: Describe the changes to the find manual
	page and warnings.

2015-12-24  James Youngman  <jay@gnu.org>

	Update some control files in po/ for new version of gettext.
	* po/Rules-quot: Updated as a result of updating gettext.
	* po/Makevars.template: Likewise.
	* po/Makevars: Likewise.

2015-12-24  James Youngman  <jay@gnu.org>

	Avoid an fd leak in fopen_cloexec_for_read_only.
	* xargs/xargs.c (fopen_cloexec_for_read_only): when fdopen fails,
	close the file descriptor instead of leaking it.  Also, use GNU-style
	brace positioning. Both problems were noticed by Paul Eggert.

2015-12-24  James Youngman  <jay@gnu.org>

	Tweak 2015-12-23 ChangeLog entry to remove a spurious newline.
	* build-aux/git-log-fix: Remove a spurious extra newline in the
	change log entry for the 2015-12-23 change by Dmitry V. Levin.

2015-12-24  James Youngman  <jay@gnu.org>

	Fix wording in the NEWS for 4.5.16.
	* NEWS: fix wording: add missing "to" in the changes for 4.5.16.

2015-12-23  James Youngman  <jay@gnu.org>

	xargs: Don't leak file descriptors over an exec boundary.
	This fixes a bug reported by Kyle Sallee (by email, so there is no
	Savannah bug number for it).
	* xargs/xargs.c (fopen_cloexec_for_read_only): New function; like
	fopen (..., "r") but sets the resulting file to be closed on exec.
	(main): Remember any non-O_CLOEXEC file desciptors that were open
	on startup so that we don't get false positives later.
	(prep_child_for_exec): Call complain_about_leaky_fds.
	(main): Any file opened to support the -a option is marked
	close-on-exec.  If we open /dev/tty to support the -p option, mark
	that file close-on-exec, too.
	* NEWS: mention this bugfix.

2015-12-23  James Youngman  <jay@gnu.org>

	Update the Serbian translation.
	* po/sr.po: Update the Serbian translation.
	* NEWS: mention this.

2015-12-23  James Youngman  <jay@gnu.org>

	Update the Brazilian Portuguese translation.
	* po/pt_BR.po: Updated Brazilian Portuguese translation.
	* NEWS: mention this.

2015-12-23  Dmitry V. Levin  <ldv@altlinux.org>

	Fix save_cwd/restore_cwd error diagnostics.
	Before this change, a pointer to struct saved_cwd was used in place
	of char*, leading to incorrect error diagnostics, e.g.:
	$ chmod a-x . && find / -maxdepth 0 -exec true \;
	find: Failed to change directory: ÿÿÿÿ: Permission denied
	find: failed to restore initial working directory: ÿÿÿÿ: Permission denied
	* find/exec.c (prep_child_for_exec): Fix error diagnostics.
	* find/util.c (record_initial_cwd, cleanup_initial_cwd): Likewise.

2015-12-23  James Youngman  <jay@gnu.org>

	Fix menu item ordering in chapter "Coding Conventions".
	* doc/find-maint.texi (Coding Conventions): Re-order menu items to
	match the section ordering.

2015-12-23  James Youngman  <jay@gnu.org>

	Document the functions declared in regextype.h.
	* lib/regextype.h: Document the semantics of the functions
	declared in this header.

2015-12-23  James Youngman  <jay@gnu.org>

	Update version number to make clear the current code is newer than 4.5.16.
	* configure.ac: Update the version number to 4.5.17-git.
	* NEWS: Likewise, begin a new section for 4.5.17.

2015-12-23  James Youngman  <jay@gnu.org>

	Release findutils 4.5.16.
	* NEWS: Update version number to 4.5.16.
	* configure.ac: Likewise.

2015-12-23  James Youngman  <jay@gnu.org>

	Point out that the gnulib update also fixes bug #40146.
	* NEWS: mention that this bug is fixed.

2015-12-23  James Youngman  <jay@gnu.org>

	gnulib: bring up-to-date with current git head of gnulib.
	This fixes Savannah bug #46715 ("testsuite error with perl 5.22,
	gnulib outdated").
	* doc/regexprops.texi: Regenerate this file from gnulib's changed
	regular expression dialect definitions regex.h.  The effect is for
	regex types egrep and posix-egrep to become synonyms.
	* NEWS: Mention this change.

2015-12-22  James Youngman  <jay@gnu.org>

	Upgrade from gettext version 0.18 to version 0.19.
	* configure.ac: Update AM_GNU_GETTEXT_VERSION to 0.19.3.

2015-12-20  Stephane Chazelas  <stephane.chazelas@gmail.com>  (tiny change)

	Add a missing space in an -execdir example in find.texi.
	* doc/find.texi (Problems with -exec and filenames): Add a missing space.

2015-12-20  James Youngman  <jay@gnu.org>

	Updated ten translations.
	* po/et.po: Updated Estonian translation.
	* po/sv.po: Updated Swedish translation.
	* po/pl.po: Updated Polish translation.
	* po/vi.po: Updated Vietnamese translation.
	* po/uk.po: Updated Ukranian translation.
	* po/nb.po: Updated Norwegian Bokmaal translation
	* po/cs.po: Updated Czech translation
	* po/ru.po: Updated Russian translation
	* po/fr.po: Updated French translation
	* po/hu.po: Updated Hungarian translation

2015-12-18  James Youngman  <jay@gnu.org>

	Re-format some ChangeLog messages and remove revent boring ones.
	* build-aux/git-log-fix: Re-format the log messages from the last
	few commits in order to end up with nicely-formatted ChangeLog
	entries, and remove the ChangeLog entries which would otherwise
	have reflected the git changes needed to make the corrections.

2015-12-18  James Youngman  <jay@gnu.org>

2015-12-18  James Youngman  <jay@gnu.org>

2015-12-18  James Youngman  <jay@gnu.org>

	Explain how child exit status affects find's exit status.
	* doc/find.texi (Run Commands): Add a new subsection and menu
	item, Child Exit Status.
	(Child Exit Status): New subsection, describing how the exit
	status of find is affected (or not) by the exit status of the
	commands run by  -exec and similar actions.
	* find/find.1 (-exec): Explain how the exit status of the child
	affects (or not) the exit status of find.
	(-execdir): Likewise.
	(EXIT STATUS): Likewise.
	* NEWS: mention these changes.

2015-12-18  James Youngman  <jay@gnu.org>

2015-12-18  James Youngman  <jay@gnu.org>

	Update version number to make clear the current code is newer than 4.5.15.
	* configure.ac: Update the version number to 4.5.16-git.
	* NEWS: Likewise, begin a new section for 4.5.16.

2015-12-18  James Youngman  <jay@gnu.org>

	Release findutils 4.5.15.
	* configure.ac: Update the version number to 4.5.15.
	* NEWS: Likewise, and set the release date.
	* po/*: Update with 'make dist'.

2015-12-18  James Youngman  <jay@gnu.org>

	Mention the bugfix for bug #42903.
	* NEWS: mention the bugfix for bug #42903.

2015-11-01  James Youngman  <jay@gnu.org>

	Use troff symbols (fixes Savannah bug 40805).
	* locate/locatedb.5: Use troff symbols where appropriate,
	including \(+- and \(en.  Also use - instead of \- when we're not
	describing an option.
	* NEWS: Mention this change.

2015-11-01  James Youngman  <jay@gnu.org>

	Remove spurious backslash.
	* find/find.1: Remove spurious backslash before ";".

2015-11-01  James Youngman  <jay@gnu.org>

	Document the behaviour reported in Savannah bug 46305.
	* doc/find.texi (Symbolic Links): Explain that -L can give
	surprising behaviour when symbolic links can become broken during
	the execution of find.
	* find/find.1 (-L): Likewise.

2015-11-01  James Youngman  <jay@gnu.org>

	Add copyright headers to some files which lack them.
	* find/testsuite/excuses.txt: remove spurious character (a typo).
	* find/testsuite/test_escape_c.sh: Add copyright header.
	* find/testsuite/binary_locations.sh: Likewise.
	* find/testsuite/checklists.py: Likewise.
	* find/testsuite/Makefile.am: Likewise.
	* find/testsuite/sv-bug-32043.sh: Likewise.
	* find/testsuite/test_escapechars.sh: Likewise.
	* find/testsuite/test_inode.sh: Likewise.
	* xargs/testsuite/Makefile.am: Likewise.
	* locate/testsuite/Makefile.am: Likewise.
	* build-aux/Makefile.am: Likewise.
	* doc/Makefile.am: Likewise.
	* find/print.h: Likewise.
	* lib/check-regexprops.sh: Likewise.

2015-11-01  James Youngman  <jay@gnu.org>

	Update po/*.po, po/findutils.pot with "make dist".
	po/*.po: update with "make dist".
	po/findutils.pot: likewise.

2015-11-01  James Youngman  <jay@gnu.org>

	find: adaptive column alignment (resolves Savannah bug #45780)
	* lib/listfile.c (list_file): For aligned fields, use the number
	of characters output to deduce whether our current idea of the
	maximum width of each field is too small.  When this happens,
	increase the field width.  Keep track of the field width in a
	static variable for each field.  Do this for the inode number,
	number of blocks, owner, group, major and minor device numbers,
	and the file size.  Use mbswidth in some places to count
	characters.
	* find/print.c (do_fprintf): Mention the potential portability
	problems in casting ino_t to uintmax_t.
	* bootstrap.conf (gnulib_modules): Add mbswidth.
	* po/Makevars (XGETTEXT_OPTIONS): updated by running bootstrap.
	*NEWS: Mention this bugfix.

2015-10-26  Jason Vas Dias  <jason.vas.dias@gmail.com>  (tiny change)

	Fix bug #45505: improve error message given for invalid regular expression.
	* find/parser.c (insert_regex): improve error message given for invalid
	regular expression.
	* NEWS: mention this bugfix.

2015-10-25  James Youngman  <jay@gnu.org>

	Fix warning from makeinfo: add missing comman in @xref
	docs/find.texi: add missing comma in @xref.

2015-10-25  James Youngman  <jay@gnu.org>

	Fix bug #45585: unclear description of -newerXY in manual page.
	* find/find.1 (-newerXY): Use the clearer wording from the Texinfo
	documentation.
	* NEWS: Mention this bugfix.

2015-10-25  James Youngman  <jay@gnu.org>

	Mention that the German translation was updated.
	NEWS: mention the update to po/de.po.

2015-10-25  James Youngman  <jay@gnu.org>

	Update the German translation from the Translation Project.
	* po/de.po: Update from the Translation Project.

2015-05-13  James Youngman  <jay@gnu.org>

	Mention the bugfix for bug #45090.
	* NEWS: mention that we fixed bug #45090.

2015-05-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: add test for the previously fixed regression
	* find/testsuite/find.posix/dotdotfiles.exp: Add test to verify
	oldfind(1) does not skip directory entries starting with "..".
	* find/testsuite/find.posix/dotdotfiles.xo: Add expected output
	for the above test.
	* find/testsuite/Makefile.am (EXTRA_DIST_XO, EXTRA_DIST_EXP):
	Mention the above new test files.

2015-05-13  Phil Miller  <mille121@illinois.edu>  (tiny change)

	Fix Savannah bug #45090: oldfind incorrectly omits test/..test
	* find/find.c (process_dir): When skipping a directory's self and
	parent entries, don't also skip other entries that happen to begin
	with "..".

2015-05-10  James Youngman  <jay@gnu.org>

	Formatting fix for ChangeLog entry for 2015-02-22.
	* build-aux/git-log-fix: Fix incorrect formatting of the ChangeLog
	entry for 2015-02-22.

2015-05-10  James Youngman  <jay@gnu.org>

	Don't try to distribute nonexistent import-gnulib.sh
	* Makefile.am (EXTRA_DIST): Don't try to distribute
	import-gnulib.sh or import-gnulib.config since they have been
	deleted.

2015-05-10  James Youngman  <jay@gnu.org>

	Stop ignoring the now-nonexistent gnulib-version.c.
	* lib/.gitignore: remove gnulib-version.c since we no longer
	create it.

2015-05-10  James Youngman  <jay@gnu.org>

	Remove import-gnulib.sh and its configuration file.
	* import-gnulib.sh: remove.
	* import-gnulib.config: remove.

2015-05-10  James Youngman  <jay@gnu.org>

	Tell people to use bootstrap instead of import-gnulib.config
	* Makefile.am (EXTRA_DIST): Distribute "bootstrap".
	* README-hacking: Tell the reader to run ./bootstrap, not
	import-gnulib.sh.
	* doc/find-maint.texi (Using the GNU Portability Library): Remove
	references to import-gnulib.sh.  There is no need to replace them
	with references to ./bootstrap, because that content was outdated
	by the switch to the use of the git submodule feature to manage
	gnunlib.

2015-05-10  Assaf Gordon  <assafgordon@gmail.com>

	build: use gnulib's 'bootstrap' script
	* bootstrap: import gnulib's bootstrap script as-is
	* bootstrap.conf: mimick as close as possible the settings from
	'import-gnulib.{sh,config}'

2015-05-10  James Youngman  <jay@gnu.org>

	Fix bug #45065: find prints leading 0 in ctime ns fields
	* find/print.c (ctime_format): Don't print a leading zero before
	the nanoseconds value.

2015-05-10  James Youngman  <jay@gnu.org>

	Print the modification time of the database for --statistics.
	* locate/locate.c: Include stat-time.h.
	(print_stats): Add an argument database_mtime, indicating the
	modification time of the database.  Print that with the rest of
	the statistics.
	(search_one_database): Accept an additional argument,
	database_mtime, and pass it to print_stats.
	(dolocate): Extract the mtime of the database file and pass it to
	search_one_database.

2015-05-10  Mike Frysinger  <vapier@gentoo.org>  (tiny change)

	Fix Savannah bug #45064: Use of [[ in /bin/sh script is incorrect
	* find/testsuite/binary_locations.sh: Change [[...]] to [...].
	* find/testsuite/sv-34079.sh: Likewise.
	* NEWS: mention this bugfix.

2015-05-10  James Youngman  <jay@gnu.org>

	Fix Savannah bug #45062: Enabling CACHE_IDS causes segfaults
	* configure.ac: Modify the --enable-id-cache option such that it
	no longer has any effect, since that code causes segfaults.
	* NEWS: Mention this bugfix.
	* find/parser.c (parse_nogroup): Remove CACHE_IDS code.
	(parse_nouser): Likewise.
	(parse_version): Indicate that CACHE_IDS is ignored.
	* find/pred.c (pred_nogroup): Remove CACHE_IDS code.
	(pred_nouser): Likewise.

2015-05-09  James Youngman  <jay@gnu.org>

	Fix typo in error message; reported by Benno Schulenberg.
	* ftsfind.c (main): Fix typo in error message (reported by Benno
	Schulenberg).

2015-05-09  James Youngman  <jay@gnu.org>

	Don't include dblocation.texi from original spot, symlink it.
	* doc/Makefile.am (dblocation.texi): Create this as a symbolic
	link.  We do this because Automake now invokes texi2dvi in "tidy"
	mode and hence changes the working directory.  That means that
	relative path includes no longer works in Texinfo files, so we
	need to avoid doing that.  Avoid distributing dblocation.texi
	(since tar would dereference the symbolic link when making the
	source archive, since the -h option is passed).
	* doc/find.texi: Include dblocation.texi instead of
	../locate/dblocation.texi.
	* configure.ac: use AC_PROG_LN_S.
	* locate/Makefile.am (EXTRA_DIST): Don't distribute dblocation.texi.

2015-05-09  James Youngman  <jay@gnu.org>

	Don't attempt to copy a symbolic link over its target.
	* import-gnulib.sh (copyhack): don't attempt to cp a source file
	to a destination file if one is a symbolic link to the other,
	because cp fails when you do that.

2015-05-09  James Youngman  <jay@gnu.org>

	Updated Danish translation from the Translation Project.

2015-02-22  James Youngman  <jay@gnu.org>

	Update some translations; add Norwegian Bokmaal.
	* ja.po, sl.po, el.po: Updated translations from the Translation
	Project: Japanese, Slovenian, Greek.
	* nb.po: Added a Norwegian Bokmaal translation from the
	Translation Project.
	* configure.ac: Added nb.po to ALL_LINGUAS.

2014-10-27  James Youngman  <jay@gnu.org>

	Updated some translations from the Translation Project.
	Updated the Estonian, Spanish, Finnish, Dutch, Polish, Brazilian
	Portuguese, Russian, Serbian, Swedish, French, Vietnamese, Czech,
	Ukranian and German translations.

2014-10-27  Dale R. Worley  <worley@alum.mit.edu>  (tiny change)

	Correct how to activate .git/hooks/pre-commit.sample
	* README-hacking (Making commits locally): Update the command that activates
	pre-commit.sample because it is now being distributed differently.

2014-08-25  James Youngman  <jay@gnu.org>

	doc: Document how check-in messages should be formatted.
	* README-hacking (Required format for check-in messages): explain
	how check-in messages should be formatted.
	* doc/find-maint.texi (Documentation): Describe the format of git
	check-in messages.  Refer to README-hacking.

2014-08-25  James Youngman  <jay@gnu.org>

	maint: Don't configure the changelog driver, we don't need it.
	* import-gnulib.sh (usage): Remove check_merge_driver. Update
	copyright date.
	* import-gnulib.config: Don't set DO_NOT_WANT_CHANGELOG_DRIVER
	since import-gnulib.sh no longer refers to it.

2014-08-25  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: generate ChangeLog from git commit messages
	* ChangeLog: Remove, as it is not maintained manually any longer.
	* Makefile.am (gen-ChangeLog): Add phony target to create the ChangeLog
	file in the distribution tarball from the git commit messages - starting
	from 2014 - and concatenating the file 'ChangeLog-2013'.
	(dist-hook): Add the above new target as dependency.
	* ChangeLog-2013: Add a newline at the top for nicer separation in
	the concatenated ChangeLog file in the distribution tarball.
	Bump Copyright year.
	* import-gnulib.config (maintainer_modules): Add 'gitlog-to-changelog'
	module.  Furthermore create an empty ChangeLog file to silence automake,
	and set DO_NOT_WANT_CHANGELOG_DRIVER environment variable as we do not
	want the import to fail if the changelog driver is not installed.
	* build-aux/git-log-fix: Add rules to fix some git commit messages
	during ChangeLog generation.
	* build-aux/.gitignore: Add entry for 'gitlog-to-changelog'.
	* build-aux/.cvsignore: Likewise.
	* .gitignore: Likewise.
	* README-hacking: Remove item to add a ChangeLog entry, and instead
	mention to give a decent commit message.  In the command sequence for
	a complete session, remove ChangeLog editing, too.
	* doc/find-maint.texi (Release Information): Remove ChangeLog editing.
	*

2014-08-24  James Youngman  <jay@gnu.org>

	Stop using the obsolete modules strtol and strtoul.
	* import-gnulib.config (modules): remove strtol and strtoul.

2014-08-23  James Youngman  <jay@gnu.org>

	Revert the previous ChangeLog split and split at 2013 instead.
	* ChangeLog-2013: Split the ChangeLog at 2013 rather than 2008;
	hence, delete ChangeLog-2008.
	* Makefile.am (EXTRA_DIST): Distribute ChangeLog-2013.
	* .gitattributes: Use the ChangeLog merge driver for ChangeLog-2013.

	This reverts commit c3e93017c2850cee2d2c15e03f66dedc1a2f445d.

2014-08-23  James Youngman  <jay@gnu.org>

	Remove obsolete TODO entries.
	* TODO: remove BeOS multibyte entry (we fixed this by using the
	gnulib wcwidth module; see https://savannah.gnu.org/bugs/?19979).
	Remove comment about problems with gcc-2.95.2 on
	sparc-sun-sunos4.1.3_U1; we'll look at the problem if anyone ever
	complains that something doesn't work (though gnulib may in fact
	no longer work on such an old platform in any case).
	Remove some TODOs around locate performance; nobody's reported
	performance issues, and we can examine any specific issues when
	the arise.
	Remove TODO about the largeness of depcomp; at 22KiB, it's much
	smaller than this ChangeLog file, for example.

2014-08-23  James Youngman  <jay@gnu.org>

	Remove obsolete TOLOWER/TOUPPER macros.
	* locate/locate.c: The TOLOWER and TOUPPER macros are no longer
	used.   Do not define them.
	* TODO: Remove obsolete entry for TOLOWER/TOUPPER.

2014-08-23  James Youngman  <jay@gnu.org>

	Don't overflow sig_atomic_t for --max-procs.
	* xargs/xargs.c (__STDC_LIMIT_MACROS): Define __STDC_LIMIT_MACROS
	in order to ensure that <stdint.h> defines the SIG_ATOMIC_MAX
	macro, which we need.
	(MAX_PROC_MAX): Define this as the maximum allowed value of
	proc_max.
	(main): Show the value of MAX_PROC_MAX for --show-limits.
	(increment_proc_max): Don't increment proc_max beyond
	MAX_PROC_MAX.
	(parse_num): Fix small error in the error message; if the limit on
	the value of a command-line argument is N, explain that the user
	should specify a value <= N, not < N.
	* xargs/xargs.1: Document the upper limit on --max-procs.
	* doc/find.texi (Controlling Parallelism): Document the upper
	limit on the amount of parallelism.
	(xargs options): Document the limit on the value you can specify
	for --max-procs.

2014-08-23  James Youngman  <jay@gnu.org>

	Prepare for later generating the ChangeLog file from the git log.
	* ChangeLog-2008: Split this file out from the main ChangeLog file.
	* Makefile.am (EXTRA_DIST): Distribute ChangeLog-2008.
	* .gitattributes: Use the changelog merge driver for
	ChangeLog-2008.

2014-08-21  Sami Kerola  <kerolasa@iki.fi>

	When reporting failure to change/save directory, mention its name.
	* find/exec.c (prep_child_for_exec): When issuing an error message
	about a failure to change directory, mention the directory.
	* find/util.c (record_initial_cwd): Do the same when saving the
	initial working directory.
	(cleanup_initial_cwd): Also when restoring the initial working
	directory.

2014-08-20  James Youngman  <jay@gnu.org>

	Fix bug #42903: the print statement doesn't exist in Python 3.
	* find/testsuite/checklists.py (main): Avoid using the print
	statement as it is not compatible with Python 3.  We use
	sys.stdout.write, since our needs here are simple.

2014-08-19  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: remove repeated paragraph in locate's texinfo manual
	* doc/find.texi (Invoking locate): Remove repeated sentence,
	introduced by commit FINDUTILS_4_2_23-1-28-g1e08148 in 2005.
	Reported by Dan Jacobsen <jidanni@jidanni.org> in
	http://lists.gnu.org/archive/html/bug-findutils/2014-08/msg00003.html
	This patch was edited by James Youngman to include a ChangeLog
	update, hence the changed date.

2014-08-19  James Youngman  <jay@gnu.org>

	Update version to distinguish development tree from 4.5.14.
	* configure.ac: Update version number.
	* NEWS: Add header for new version , matching the version number
	now in configure.ac.

2014-07-19  James Youngman  <jay@gnu.org>

	Release findutils-4.5.14.
	* configure.ac: Update version number to 4.5.14.
	* NEWS: Likewise, and add today's date.
	* po/*: Update with 'make dist'.

2014-07-19  James Youngman  <jay@gnu.org>

	Standardize on "initialize".
	* find/exec.c (initialise_wd_for_exec): rename to
	initialize_wd_for_exec, since "initialize" is the preferred form
	even in UK spelling (the OED says "initialise" is a variant).
	Update callers (it's a static function).  Update spelling in
	comments.
	* find/find.c (main): Fix missing "to" in error message and update
	"initialise" to "initialize".  Update comment too.
	* find/ftsfind.c (main): Update spelling in error message.
	* lib/listfile.c (print_name_with_quoting): spelling change in
	comment.
	* find/tree.c (init_pred_perf): Likewise.
	* lib/extendbuf.c (extendbuf): Likewise.
	* lib/splitstring.h: Likewise.
	* find/print.c (format_date): Likewise.
	* doc/find-maint.texi (Tools): Update spelling.

2014-07-19  James Youngman  <jay@gnu.org>

	Did 'make dist'

2014-07-19  James Youngman  <jay@gnu.org>

	Bug #42793: mention the bugfix in NEWS.
	* NEWS: mention the bugfix.

2014-07-19  James Youngman  <jay@gnu.org>

	Fix bug #42793: "Failed to write output" with -ls.
	* lib/listfile.c (print_name_with_quoting): Avoid using the
	variable fprintf_result before it is initialised.  I hope this
	fixes Savannah bug #42793.

2014-07-19  James Youngman  <jay@gnu.org>

	Update the version number following the recent release.
	* configure.ac: Move on from 4.5.13.
	* NEWS: Move on from 4.5.13.

2014-07-16  James Youngman  <jay@gnu.org>

	Prepare for release of 4.5.13.
	* configure.ac: Change the version number to 4.5.13.
	* NEWS: Mention some documentation bug fixes which have been
	applied (ChangeLog entries already exist for these).  Change the
	version number of the top section of the NEWS file.

2014-06-01  James Youngman  <jay@gnu.org>

	Routinely check .xo and .exp test file lists in a clearer way.
	* find/testsuite/checklists.py: Tiny program for checking that the
	correct lists of .xo and .exp files exist in the Makefile.am file.
	* Makefile.am (checklists): Update target to use the new program.
	Make this target phony.

2014-05-31  James Youngman  <jay@gnu.org>

	Check there are no duplicate configuration entries for test files.
	* find/testsuite/Makefile.am (EXTRA_DIST_XO): Remove duplicate items.
	(EXTRA_DIST_EXP): Likewise.
	(checklists): Run with the other checks, using check-local.  Don't
	echo the full command, because it will make the summary of the
	Automake-driven tests scroll offscreen.
	(TEST_EXTENSIONS): Add .sh and .py.

2014-05-31  James Youngman  <jay@gnu.org>

	Enable parallel tests.
	* find/testsuite/Makefile.am (AUTOMAKE_OPTIONS): Enable
	parallel-tests.  This will only include tests known directly via
	$(TESTS), not DejaGnu tests.

2014-05-31  James Youngman  <jay@gnu.org>

	Locate the Python and faketime binaries

2014-05-25  Eric S. Raymond  <esr@thyrsus.com>

	Fix errant backslash in find manpage.
	* find/find.1 (UNUSUAL FILENAMES): Fix errant backslash.

2014-05-12  James Youngman  <jay@gnu.org>

	Update German translation.
	* po/de.po: Update German translation from the Translation
	Project.

2014-05-12  James Youngman  <jay@gnu.org>

	Several updates and clarifications to README-hacking.
	* README-hacking: Explain that tool-versions.txt is not checked
	into git.  The repository has grown from 14MB to 16MB.  Gnulib is
	now a submodule and the directory we keep it in has changed.
	Remove the suggestion to rsync the translations from the
	translation project, since the files that fetches seem to be out
	of date.  Move the instruction to update ChangeLog to a more
	prominent place.  Mention that there is an electronic process for
	assignments in some locations.  Update the copyright year.

2014-05-11  James Youngman  <jay@gnu.org>

	* gnulib: Update submodule to current version at origin/master.

2014-05-11  James Youngman  <jay@gnu.org>

	Fix inadequte quoting in AC_ARG_ENABLE usage.
	* configure.ac: Quote second argument of AC_ARG_ENABLE.

2014-01-15  James Youngman  <jay@gnu.org>

	Fix typo "ouptut".
	* locate/locate.1 (OPTIONS): fix typo "ouptut" (from an anonymous
	Savannah bug report #40804).

2014-01-12  James Youngman  <jay@gnu.org>

	Add source files to po/POTFILES.in.
	* po/POTFILES.in: Add some source file names which were missing.

2014-01-12  Nguyễn Thái Ngọc Duy  <pclouds@gmail.com>

	* po/POTFILES.in: mark strings from gnulib for translation.

2014-01-06  Richard Hartmann  <richih@debian.org>

	* find/find.1: Fix highlighting

2014-01-06  James Youngman  <jay@gnu.org>

	Updated various translations from the Translation Project.
	* po/ru.po: Updated Russian translation from the Translation
	Project.
	* po/fr.po: Updated French translation.
	* po/pt_BR.po: Updated Brazilian Portuguese translation.
	* po/it.po: Updated Italian translation.
	* po/sr.po: Updated Serbian translation.
	* po/eo.po: Updated Esperanto translation.
	* po/tr.po: Updated Turkish translation.
	* po/fi.po: Updated Finnish translation.
	* po/el.po: Updated Greek translation.

2014-01-05  James Youngman  <jay@gnu.org>

	Updated Slovenian translation.
	* po/sl.po: Updated Slovenian translation from the Translation
	Project.

2013-12-08  James Youngman  <jay@gnu.org>

	Bug #35753: check the success/failure of material I/O operations.
	* lib/listfile.c (list_file): Check the result of fprintf to
	determine if there was an I/O error on output.  Return false (bool
	instead of void) if so.
	(print_name_without_quoting): Likewise.
	(print_name_with_quoting): Likewise.
	(print_name): Propagate the result of print_name_without_quoting
	or print_name_with_quoting (and make all three functions return bool).
	* find/pred.c (is_ok): Check the result of fprintf to
	determine if there was an I/O error on output.  Exit fatally if
	there was a problem (since we cannot expect the user to say "yes"
	or "no" to a prompt they will not have seen).
	* xargs/xargs.c (print_args): Check the result of fprintf and
	fflush to determine if there was an I/O error on output.  Exit
	fatally for the same reason as above if there is a problem.
	* NEWS: Mention this bugfix (now that it is fully fixed).

	Fix some signed/unsigned problems.
	* find/util.c (show_valid_debug_options): change type of array
	subscript to size_t to avoid signed/unsigned problems.
	(set_stat_placeholders): Silence unuseful compiler warning about
	unused parameter.
	* find/ftsfind.c (show_outstanding_execdirs): change type of array
	subscript to size_t to avoid signed/unsizned problems.

	Fix format specifier in safe_read error message.
	* xargs/xargs.c (xargs_do_exec): print size_t values with %zu, not
	%d (since size_t is not and never can be the same type as int).

	Bug #35753: detect failure of the atexit library function.
	* find/find.c (main): Issue a fatal error message if atexit fails.
	* xargs/xargs.c (main): Likewise.
	* find/ftsfind.c (main): Likewise.
	* locate/code.c (main): Likewise.
	* locate/frcode.c (main): Likewise.
	* locate/locate.c (dolocate): Likewise.
	* locate/bigram.c (main): Likewise; also include <errno.h>.

2013-10-27  James Youngman  <jay@gnu.org>

	* THANKS: Add Eric S. Raymond.

2013-10-27  Eric S. Raymond  <esr@thyrsus.com>

	Add bracket missing from synopsis in locate manpage.
	* locate/locate.1 (SYNOPSIS): Add missing bracket.

2013-10-26  James Youngman  <jay@gnu.org>

	Clearly explain the result of -exec/-execdir ... +
	* doc/find.texi (Single File): Explain that "-exec command ;"
	returns true of the command exited with a status of 0.
	(Multiple Files): Explain that "-execdir command +" always returns
	true.  Likewise for "-exec command +".
	* find/find.1: similar changes.

2013-09-24  James Youngman  <jay@gnu.org>

	Fix bug #40094: minor inconsistencies in xargs option descriptions.
	* xargs/xargs.1: Update the description of -e option to emphasize
	that the argument must follow the option letter immediately (in
	other words, that it may not appear in the next program argument).
	Likewise for the the -i and -l (lower-case L) options.
	* xargs/xargs.c (usage): Minor consistency improvements to help
	text.

	Update Vietnamese, Czech and Dutch translations.
	* po/nl.po: Update Dutch translation.
	* po/cs.po: Update Czech translation.
	* po/vi.po: Update Vietnamese translation.

2013-09-23  James Youngman  <jay@gnu.org>

	Fix bug #39162: -printf reads beyond arguments terminated by \
	* find/print.c (insert_fprintf): If a \ is found at the end of a
	format string, issue a warning (and render it as-is).
	* NEWS: Mention this bugfix.

	Update version number to 4.5.13-git.
	* configure.ac: Update version number to 4.5.13-git.
	* NEWS: Likewise.

	Updated Estonian, Polish, Ukrainian translations.
	* po/et.po: Updated the Estonian translation from the Translation
	Project.
	* po/pl.po: Updated the Polish translation.
	* po/uk.po: Updated the Ukrainian translation.
	* NEWS: Mention these updates.

2013-09-22  James Youngman  <jay@gnu.org>

	Release findutils-4.5.12.
	* configure.ac (AC_INIT): Change version number to 4.5.12.
	* NEWS: Change version number of most recent release to 4.5.12.

	Issue an error message when fts_read fails. Fixes bug #39324.
	* find/ftsfind.c (find): when fts_read fails, issue an error
	message, set the exit status to zero and stop.  Previously the
	program would just stop (i.e. it failed to distinguish "done" from
	"failed").
	* find/find.1 (-exec): explain that on failure, some pending
	command launches may not happen.  The Texinfo documentation
	already pointed this out, so that didn't need to be changed.
	* NEWS: Mention this bugfix.

	Add a bug number for bug #40088.
	* NEWS: Add a bug number for bug #40088: potential buffer overflow
	in -execdir and -okdir.  Re-order the bugs listed to be
	decreasing numerically by ID.

2013-09-21  James Youngman  <jay@gnu.org>

	find: state that -execdir command is run locally to the matched file.
	* doc/find.texi (Single File): Correct the description of what the
	current directory will be when the command specified by -execdir
	gets run.  This fixes a documentation but reported by Eric
	Hanchrow.
	* NEWS: Mention this fix.

2013-09-21  Bernhard Voelker  <mail@bernhard-voelker.de>

	xargs: wait for process before prompting in interactive mode (-p)
	* xargs/xargs.c (xargs_do_exec): Move the code for waiting for
	forked processes up, so that the child process terminates before
	we prompt for the next command.
	* NEWS: Mention the fix.

2013-09-21  Dmitry V. Levin  <ldv@altlinux.org>

	find: fix potential buffer overflow in -execdir and -okdir.
	* lib/buildcmd.c (bc_push_arg): Take prefix length into account
	to avoid state->argbuf overflow.
	* NEWS: Mention this fix.

2013-09-21  James Youngman  <jay@gnu.org>

	Make sv-34976-execdir-fd-leak.sh test more POSIX-compliant.
	* find/testsuite/sv-34976-execdir-fd-leak.sh: Avoid using seq;
	instead, use pre-generated lists of test file names.  Also avoid
	using file descriptors 0, 1, 2 in the test.

	Fix typo "sturct".
	* find/exec.c (impl_pred_exec): Typo fix: struct/struct.
	* ChangeLog (2007-03-28): Likewise.

2013-09-20  Bernhard Voelker  <mail@bernhard-voelker.de>

	find: fix fd leak with --execdir option (bug#34976)
	* find/exec.c (impl_pred_exec): Free the working directory if find
	executes the command in the local dir, i.e. if it has been saved
	by record_exec_dir().  Re-indent code.
	* find/testsuite/sv-34976-execdir-fd-leak.sh: Add test.
	* find/testsuite/Makefile.am (test_shell_progs): Mention the test.
	* NEWS: Mention the fix.

2013-09-20  James Youngman  <jay@gnu.org>

	Updated Greek translation.
	* po/el.po: Updated Greek translation from the Translation
	Project.

2013-09-20  Bernhard Voelker  <mail@bernhard-voelker.de>

	xargs: Fix integer overflow in implicit conversion in do_exec.
	* xargs/xargs.c (xargs_do_exec): Change type of r from int to
	size_t, since that is the type that safe_read actually returns.

2013-09-20  James Youngman  <jay@gnu.org>

	Add Bernhard Voelker to AUTHORS.
	* AUTHORS: Add Bernhard Voelker.

	* configure.ac: Check for prefixed versions of ranlib, too.

2013-09-20  Benedikt Morbach  <benedikt.morbach@googlemail.com> (tiny change)

	Check for both prefixed and unprefixed versions of "ar".
	* configure.ac: Look for '${host}-ar' as set by AC_CANONICAL_HOST
	before looking for the unprefixed 'ar'.  This is useful when
	cross-compiling when all your binutils are prefixed.

2013-09-20  James Youngman  <jay@gnu.org>

	Fix compilation error where struct dirent lacks a d_ino member.
	* find/find.c (NOT_AN_INODE_NUMBER): Add missing identifier which
	(when missing) caused a compilation error on system where struct
	dirent lacks a d_ino member.

	Be consistent about what we call the places the search starts.
	* find/find.1: Consistently describe the paths at which the search
	begins as "satrting points".

	Refer to the info manual in a clearer and more explicit way.
	* find/find.1 (SEE ALSO): Explain how to invoke info to read the
	Texinfo manual.
	* locate/locate.1 (SEE ALSO): Likewise.
	* locate/updatedb.1 (SEE ALSO): Likewise.
	* xargs/xargs.1 (SEE ALSO): Likewise.

2013-06-02  James Youngman  <jay@gnu.org>

	Add unlinkat moduile.
	* import-gnulib.config (modules): Add unlinkat module, following
	bug report from Martin von Gagern.

2013-04-22  Paul Eggert  <eggert@cs.ucla.edu>

	More removal of support for -perm +MODE.
	* find/parser.c (parse_perm): Remove no-longer-needed local var
	and associated code.  Reported by Eric Blake in
	<https://savannah.gnu.org/bugs/?38474#comment9>.

2013-04-21  Paul Eggert  <eggert@cs.ucla.edu>

	Remove support for obsolete -perm +MODE syntax.
	Also, do not reject -perm /MODE merely because of POSIXLY_CORRECT.
	Problem reported in <https://savannah.gnu.org/bugs/?38474>.
	* NEWS:
	* doc/find.texi (Mode Bits): Document this.
	(Environment Variables): POSIXLY_CORRECT does not affect -perm.
	* find/parser.c (parse_help): Mention /MODE, not +MODE.
	(non_posix_mode): Remove.
	(parse_perm): Remove support for -perm +MODE.
	Do not reject -perm /MODE merely because POSIXLY_CORRECT is set;
	POSIXLY_CORRECT is not supposed to be for pedantic checking.
	* find/find.1 (-perm): describe this change.
	(HISTORY): update the existing statement about the deprecation of
	+MODE to explain that support has now been removed.

2013-04-22  James Youngman  <jay@gnu.org>

	Fix documentation typo.
	* doc/find.texi (Mode Bits): Fix typo "it set" -> "is set".

2013-04-20  Paul Eggert  <eggert@cs.ucla.edu>

	doc: fix typos uncovered by texinfo 5.0
	* doc/find-maint.texi: Fix typos that cause 'make' to fail
	if texinfo 5.0 is installed.

2013-04-22  James Youngman  <jay@gnu.org>

	Enable assertions in locate.
	* locate/locate.c: Don't #define NDEBUG.

2013-04-21  James Youngman  <jay@gnu.org>

	* find/find.1 (-size): explain the rounding-up semantics more
	clearly.

	Add example for find -printf.
	* doc/find.texi (Print File Information): Add an example for "find
	-printf" suggested by Karl Berry.

2011-12-31  Karl Berry  <karl@gnu.org>

	Further documentation improvements.
	* doc/find.texi: use @code for environment variable names, and
	other improvements.

2009-08-03  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* locate/locate.c: Simplify handling of slocate databases.
	Fix the bug assuming second path extends the first one.
	* locate/testsuite/locate.gnu/slocate.{exp,xo}: New testcase
	for slocate databse, exposing this bug.
	* locate/testsuite/Makefile.am: Add new test case.

2009-08-03  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* locate/locate.c: Enable assertions and fix the off-by-one
	bugs that prevented this.

2009-08-03  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* doc/find.texi: Remove duplicate paragraph and fix a typo.

2013-03-31  James Youngman  <jay@gnu.org>

	Don't use reserved identifiers in macro names; fix other code smells.
	* build-aux/src-sniff.py (checkers): Check for #define directives
	which use a macro name which is reserved.
	(MakefileRegexChecker): New class which performs regex checks on
	makefiles; this ensures that we don't check Makefile.in if we're
	going to check Makefile.am anyway.
	* lib/unused-result.h: Don't use a reserved identifier in the
	macro name defined as the #include guard.
	* locate/locatedb.h: Likewise.
	* Makefile.am (findutils-check-smells): Don't check gnulib code.
	* import-gnulib.sh (hack_gnulib_tool_output): Move the 'do' of a
	for loop onto the line following the 'for' (instead of the same
	line).

2013-03-29  James Youngman  <jay@gnu.org>

	Document that -0/-d turns off logical end-of-file processing.
	* doc/find.texi (xargs options): Explain that the logical end of
	file marker string set with -E is not special if -d or -0 was
	specified.
	* xargs/xargs.c (usage): Mention this in the --help output.
	(read_string): Correct the function header comment to point out
	that there is no logical end-of-file processing for this case.
	Also point out that the delimiter may not always be NUL.
	This documentation update fixes Savannah bug #36652.
	(main): Emit a warning message if -0/-d is specified and -E was
	also used.
	* xargs/testsuite/xargs.gnu/E_-0.exp: Don't compare stderr output,
	since for this case xargs now emits a warning message.
	* NEWS: Mention this change.

2013-03-29  James Youngman  <jay@gnu.org>

	Updated the Galician translation.
	* gl.po: Updated Galician translation.

2013-03-26  James Youngman  <jay@gnu.org>

	Updated a number of translations.
	* cs.po: Updated Czech translation.
	* et.po: Updated Estonian translation.
	* fi.po: Updated Finnish translation.
	* fr.po: Updated French translation.
	* nl.po: Updated Dutch translation.
	* pl.po: Updated Polish translation.
	* ru.po: Updated Russian translation.
	* uk.po: Updated Ukrainian translation.
	* vi.po: Updated Vietnamese translation.
	* zh_CN.po: Updated Chinese (simplified) translation.

2013-03-26  Kamil Dudka  <kdudka@redhat.com>

	Fix compile-time warnings.
	* find/defs.h (struct predicate): Add a missing const modifier.
	* find/find.c (wd_sanity_check): Suppress a warning in #else branch.
	(process_dir): Remove an unused variables and statements.
	* find/pred.c (pred_context): Use const modifier in the prototype.
	* lib/buildcmd.{c,h} (bc_args_exceed_testing_limit): Remove a const
	modifier causing unnecessary warnings.
	* xargs/xargs.c (main): Add explicit type-casts.

2013-03-24  James Youngman  <jay@gnu.org>

	Expand on warning about xargs -P and stdout, including in Info.
	* xargs/xargs.1: Expand on the warning about sharing stdout for
	"xargs -P".
	* doc/find.texi (Controlling Parallelism): Add a suitable warning
	about sharing resources here, too.
	* NEWS: Mention that all relevant documentation was updated with
	this warning.

2013-03-24  Bernhard Voelker  <mail@bernhard-voelker.de>

	Improve error message for find -type X (X = an unknown file type).
	* find/parser.c (insert_type): Give a more comprehensible error
	message when the type letter following -type or -xtype corresponds
	to a type of file which was unknown on the system which compiled
	the find binary.
	* NEWS: Mention this improvement.

	xargs: split usage text to help translators, and clarify it.
	* xargs/xargs.c (usage):  Define HTL macro to print one help text
	line (or entry).  Split the option descriptions up by using the
	above macro.  Refine the messages to adapt to the common way:
	change the start of each option's description to lower case, do
	not use periods at the end, use semicolons where needed, indent
	secondary lines, several other minor improvements.
	* NEWS: Mention this improvement.

	* xargs/xargs.1: Add note for -P suggesting the use of a locking
	system to avoid corrupted stdout.

2013-03-24  James Youngman  <jay@gnu.org>

	Fix Savannah bug #38583: errno-buffer read failed in xargs_do_exec
	* import-gnulib.config (modules): Import the safe-read module.
	* xargs/xargs.c (xargs_do_exec): Use safe_read so that the read
	system-call is retried if we handle a signal (for example
	SIGUSR[12]) while we are trying to read the errno vlaue from the
	child process.

	Fix misleading message from import-gnulib.sh; allow .git symlink.
	* import-gnulib.sh (check_old_gnulib_dir_layout): Really apply the
	bugfix by Kamil Dudka which eliminates a misleading message of
	import-gnulib.sh on a fresh repository obtained by 'git clone
	--recursive', by requiring gnulib/.git to exist but not requiring
	it to be a directory.

	Bugfix to "make clean": do not delete header files.
	* lib/Makefile.am (coverage-clean): Remove output files left
	behind by gcc -fprofile-arcs -ftest-coverage by using $(RM) with a
	glob pattern rather than a $(libfindtools_a_SOURCES.c=.gcno)
	Makefile substitution, because the latter caused us to delete
	header files entirely (their names do not end in .c).  This had
	meant that it was impossible to compile findutils after "make
	clean".  Bug report by David Gilbert.
	* find/Makefile.am (coverage-clean): Likewise.
	* xargs/Makefile.am (coverage-clean): Likewise.
	* locate/Makefile.am (coverage-clean): Likewise.
	* Makefile.am (coverage-clean): Likewise, but also do this in the
	subdirectories whose Makefile.am files are generated by
	gnulib-tool.

	Move on from 4.5.11, to 4.5.12-git
	* NEWS: Add a new section for 4.5.12-git.  Mention the bugfix to
	find/testsuite/sv-bug-32043.sh.
	* configure.ac: Update the version number.

	Fix Bash-ism [[ ... ]].
	* find/testsuite/sv-bug-32043.sh: Change [[ ... ]] to [ ... ]
	because the first pattern is a Bash-ism.  Bug reported by David
	Gilbert.

2013-02-03  Kamil Dudka  <kdudka@redhat.com>

	Avoid using 'INCLUDES =' in automake templates.
	* find/Makefile.am: Use AM_CPPFLAGS instead of deprecated INCLUDES.
	* lib/Makefile.am: Likewise.
	* locate/Makefile.am: Likewise.
	* xargs/Makefile.am: Likewise.

	Eliminate a misleading message of import-gnulib.sh on a fresh
	repository obtained by 'git clone --recursive'.
	* import-gnulib.sh (check_old_gnulib_dir_layout): Do not require
	./gnulib/.git to be a directory.

2013-02-03  James Youngman  <jay@gnu.org>

	Fix Savannah bug #38239, missing variable initialisation in locate
	* locate/locate.c (cleanup_quote_opts): New atexit function, frees
	quote_opts which otherwise would leak.
	(dolocate): Eliminate the redundant boolean variable
	they_chose_db, whose true/false-ness followed the not-NULL-ness of
	locate_path.  Rename locate_path to user_selected_locate_path to
	make this explicit.
	(dolocate): When we get to the bottom of the loop, don't try to
	check for a further element in user_selected_locate_path if it is
	NULL (that is, $LOCATE_PATH was unset and the -d option was not
	used).

	* po/findutils.pot: Updated template file from the Translation
	Project

2013-02-02  James Youngman  <jay@gnu.org>

	Release findutils-4.5.11.
	* NEWS: update version number from 4.5.11-git to 4.5.11.
	* configure.ac (AC_INIT): Likewise.

	Reduce needless calls to complete_pending_execdirs.
	* find/exec.c (impl_pred_exec): Once pushing an argument for
        -exec{,dir} ... +, Only set state.execdirs_outstanding if
	there were previously no todo items on ths command line.
	This avoids spurious calls to complete_pending_execdirs().

2012-12-19  James Youngman  <jay@gnu.org>

	Make the manual section ordering and menu item ordering consistent.
	* doc/find.texi (Top): Re-order menu items to be consistent with
	ordering of sections ('Reference' is moved).
	(Print File Information): Add missing menu item 'Formatting Flags'
	and remove that menu item from inside 'Format Directives'.
	(Formatting Flags): Hence this is a subsection, not a
	subsubsection.

2012-12-15  Stefano Lattarini  <stefano.lattarini@gmail.com> (trivial change)

	build: remove redundant AC_SUBST of var INCLUDES
	* configure.ac: don't call AC_SUBST(INCLUDES).

2012-12-15  Bernhard Voelker  <mail@bernhard-voelker.de> (trivial change)

	* locate/updatedb.sh (PRUNEFS): Avoid 9P, cifs and nfs4
	filesystems by default.

2012-12-15  James Youngman  <jay@gnu.org>

	Tweak updatedb.sh to make diffs easier to read.
	* locate/updatedb.sh (PRUNEFS): List the default items in
	alphabetical order to make diffs easier to read.
	(PRUNEPATHS): likewise.

	Re-generate doc/regexprops.texi.
	* doc/regexprops.texi: re-generate to describe the changes to
	gnulib for the regular expression types "awk" (to add character
	class support), "gnu-awk" (to add range support) and "posix-awk"
	(also to add range suport).
	* NEWS: Describe this change.

2012-11-17  Dmitry V. Levin  <ldv@altlinux.org>

	find: use FTS_VERBATIM
	* gnulib: update to latest, to get FTS_VERBATIM support.
	* find/ftsfind.c (ftsoptions): Set the FTS_VERBATIM bit.  This
	Patch was contributed on 2012-11-18, but was applied with the
	above regexprops change)

2012-12-14  James Youngman  <jay@gnu.org>

	Fix bug #37926 (wrong result for oldfind -inum)
	* find/find.c (D_INO): Define D_INO as a convenience accessor for
	the inode number in struct dirent; use 0 if there is no d_ino
	member in struct dirent.
	(main): Pass the inode number of the top-level directory to
	process_top_path.
	(at_top): Add argument inum, the inode number of the file we are
	looking at.  Pass this to the action function.
	(do_process_top_dir): Pass the inode number to process_path.
	(do_process_predicate): Take (but ignore) the inode number
	argument.
	(process_path): Add argument inum, the inode number of the file we are
	looking at.  Populate statbuf.st_ino with this value.  This avoids
	a stat call in pred_inum if the stat information would not
	otherwise be used.
	(process_dir): Pass the inode number to process_path.
	* import-gnulib.config (modules): Add d-ino.
	* NEWS: Mention this bugfix.

2012-11-17  James Youngman  <jay@gnu.org>

	Update the Vietnamese, Ukranian and Croatian translations.
	* po/vi.po, po/uk.po, po/hr.po: Update the translation files from
	the translation project.

2012-09-18  Jim Meyering  <meyering@redhat.com>

	find: fix two time-formatting leaks (bug #37356)
	* find/print.c (do_time_format): Call xmalloc for static "buf" only
	the first time.
	When reallocating buf, be sure to update its buf_size.
	Also free "altbuf".
	Reported by Nemo Maelstrom Thorx in http://bugs.debian.org/687358
	via Andreas Metzler in https://savannah.gnu.org/bugs/?37356

	find: minor tweaks
	* find/print.c (do_time_format): Use memcpy in place of sprintf.
	When calling x2nrealloc, use "sizeof *buf" as the element size,
	rather than "2u".

	build: avoid import-gnulib.sh failure
	* import-gnulib.config (extra_files): Remove build-aux/missing,
	since that file has been removed from gnulib.

	build: stop using now-obsolete macro, AM_C_PROTOTYPES
	* configure.ac: Don't use obsolete AM_C_PROTOTYPES.

2011-12-30  Karl Berry  <karl@gnu.org>

	Documentation improvements (UK spelling, use of @code).
	* find.texi (@copying): add 2011, period outside quotes.
	(thoughout): use UK spelling and " -- " convention.
	(section names): use @code where needed.

2011-09-11  Jim Meyering  <meyering@redhat.com>

	Fix a typo in find.texi.
	* doc/find.texi (Error Messages From find): Fix typo s/an/a/.

2011-08-20  James Youngman  <jay@gnu.org>

	Describe recent memory savings on very large directories.
	* NEWS: Describe the recent changes which reduce the amount of
	heap memory used in processing directories containing very many
	entries.

	Remove no-longer-used files savedir.[ch].
	* lib/savedirinfo.c: delete unused file.
	* lib/savedirinfo.h: delete unused file.
	* lib/Makefile.am (libfind_a_SOURCES): Remove savedirinfo.c.
	(EXTRA_DIST): Remove savedirinfo.h.

	Reduce memory consumption of oldfind on large directories.
	* find/find.c (process_dir): Reduce memory consumption for large
	directories.  Don't save the whole directory content with
	xsavedir, instead just loop over the results of readdir.  This
	means that oldfind will consume one file descriptor per directory
	level.
	* find/testsuite/sv-34079.sh: verify that the memory consumption
	of oldfind is reasonable on large directories.

	Reduce memory consumption of fts.
	* gnulib: update to latest, mainly to include a bugfix (gnulib
	commit 47cb657eca1abf2c26c32c8ce03def994a3ee37c) which limits the
	memory consumed by fts.
	* find/testsuite/sv-34079.sh: New test, verifying that memory
	consumption in ftsfind does not grow indefinitely as the size of
	directories increases.
	* find/testsuite/Makefile.am (test_shell_progs): Added sv-34079.sh.

2011-06-29  James Youngman  <jay@gnu.org>

	Fix some constness warnings when dealing with -printf formats.
	* find/parser.c (collect_arg_nonconst): Rename collect_arg to
	collect_arg_nonconst and change the collected argument from const
	char* to char*.
	(collect_arg): Call collect_arg_nonconst to do the real work.
	(parse_printf): Call collect_arg_nonconst instead of collect_arg.
	Change `format' from const char* to char*.
	(parse_fprintf): Likewise.
	* find/print.h: Change 'format' from const char* to char*, since
	actually we edit it in place.
	* find/print.c (parse_octal_escape): Instead of updating a const
	char* pointer to indicate how many characters from the input we
	consumed, update a size_t value.
	(insert_fprintf): Change function definition to match updated
	prototype.  Eliminate fmt_inpos.  Introduce a `readpos' offset
	variable which takes the previous role of fmt_inpos.

2011-06-28  James Youngman  <jay@gnu.org>

	Refactor insert_fprintf to minimise calls to make_segment.
	* find/print.c (get_format_flags_length): Factor out of
	insert_fprintf; computes the length of the format flags for a
	format specifier (that is everything after the % but before the
	format control character).
	(get_format_specifer_length): Also factored out of insert_fprintf;
	returns the number of format control characters (e.g. 2 for %A@)
	or 0 for error.
	(insert_fprintf): Keep fmt_editpos and fmt_inpos more closely in
	step, instead of initialising fmt_inpos only when we need it (the
	idea eventually will be to make fmt_inpos the loop control
	variable).  Call get_format_specifer_length and
	get_format_flags_length when needed. Reduce the number of
	different calls to make_segment.  We now have one for each KIND_
	value plus one for the error case.

2011-06-27  James Youngman  <jay@gnu.org>

	Factor some of the code out of insert_fprintf.
	* find/print.c (insert_fprintf): Factor out the handling of
	eascape codes into new functions parse_escape_char,
	parse_octal_escape.

2011-06-25  James Youngman  <jay@gnu.org>

	Separate out the handling of \c.
	* find/print.c (insert_fprintf): Deal with \c as a special case.

	Remove some redundant continue statements.
	* find/print.c (insert_fprintf): Remove a pair of redundant
	'continue' statements.

	Simplify -fprintf %%; handle %% like a regular format specifier.
	* find/print.c (make_segment): Handle foo%% by simply generating a
	format string of foo%% (that is, let vfprintf handle the escaped
	%).
	(insert_fprintf): Handle %% as KIND_FORMAT instead of KIND_PLAIN.
	(do_fprintf): Handle %%.

	Clarify variable naming in insert_fprintf.
	* find/print.c (insert_fprintf): Rename some variables for greater
	clarity:
	format is now segstart, since it points to the start of the part
	of the format string we're next going to pass to make_segment.
	scan2 is now fmt_inpos (which is a const char*) and is the
	scanning position beyond segstart which we're reading to locate
	the end of this segment.
	scan is now fmt_editpos and is the scanning position at which we
	are modifying the format string (for example to change \n in the
	format to the value of the '\n' character).

2011-06-19  James Youngman  <jay@gnu.org>

	Test find -printf %i.
	* find/testsuite/test_inode.sh: New test, for find -printf %i.
	* find/testsuite/Makefile.am (test_shell_progs): Add test_inode.sh.

	Extract common test code into a sourced file.
	* find/testsuite/binary_locations.sh: New file, extracting common
	code from the test scripts.
	* find/testsuite/test_escape_c.sh: Source binary_locations.sh.
	* find/testsuite/test_escapechars.sh: Source binary_locations.sh.
	* find/testsuite/Makefile.am (EXTRA_DIST): Distribute
	binary_locations.sh.

2011-06-18  James Youngman  <jay@gnu.org>

	Fix some compiler warnings in xargs.
	* xargs/xargs.c: Remove definition of the unused macro VOID.
	Include error.h instead of declaring error (incorrectly).
	Change the type of lineno from int to size_t.
	(get_char_oct_or_hex_escape): Don't point endp unnecessarily at p,
	because they have different constness.  There's no need for this,
	just initialise it to NULL.
	(main): Make input_file const.   Make the default arglist
	non-const, to avoid a constness warning.
	(main): Pass the option name as the argument to error's %s format,
	as opposed to the whole struct (this was a bug, but since the name
	member was the first in the struct, there were probably no
	symptoms).
	(main): read_args returns an int, but the only negative value it
	can return is -1.  Once we know that didn't happen, assign the
	value to a size_t variable to avoid signed/unsigned warnings
	elsewhere.
	(xargs_do_exec): Manually inhibit some unused-parameters warnings.
	(print_args): Use size_t as the type of a loop variable.
	(wait_for_proc): Since procs_executing is an unsigned long, use a
	%lu format specifier to print it.
	(increment_proc_max): Inhibit an unused-parameter warning (the
	signal number).
	(decrement_proc_max): Likewise.
	* lib/buildcmd.h (struct buildcmd_control): Make member
	replace_pat const.  Change the type of lines_per_exec to unsigned
	long.

2011-06-20  James Youngman  <jay@gnu.org>

	Use a consistent include order in header files too.
	* lib/printquoted.h: Use the preferred header-file inclusion order
	here too.

	Use a consistent order for header-file inclusion.
	* find/exec.c: Include config.h, then system headers followed by
	gnulib headers and last, find-specific headers.
	* find/find.c: Likewise.
	* find/finddata.c: Likewise.
	* find/fstype.c: Likewise.
	* find/ftsfind.c: Likewise.
	* find/parser.c: Likewise.
	* find/pred.c: Likewise.
	* find/tree.c: Likewise.
	* find/util.c: Likewise.
	* lib/buildcmd.c: Likewise.
	* lib/dircallback.c: Likewise.
	* lib/extendbuf.c: Likewise.
	* lib/fdleak.c: Likewise.
	* lib/findutils-version.c: Likewise.
	* lib/listfile.c: Likewise.
	* lib/printquoted.c: Likewise.
	* lib/qmark.c: Likewise.
	* lib/regexprops.c: Likewise.
	* lib/regextype.c: Likewise.
	* lib/safe-atoi.c: Likewise.
	* lib/savedirinfo.c: Likewise.
	* lib/splitstring.c: Likewise.
	* lib/test_splitstring.c: Likewise.
	* lib/waitpid.c: Likewise.
	* locate/bigram.c: Likewise.
	* locate/code.c: Likewise.
	* locate/frcode.c: Likewise.
	* locate/locate.c: Likewise.
	* locate/word_io.c: Likewise.
	* xargs/xargs.c: Likewise.

	Take gnulib-tool's advice about which header files to include.
	* locate/locate.c: Include <regex.h> instead of "regex.h".
	Include "fnmatch.h" instead of <fnmatch.h> (because we use
	fnmatch-gnu).  Include "gettext.h".
	* lib/regexprops.c: Include <regex.h> instead of "regex.h".
	* find/tree.c: Include "gettext.h".  Include "fnmatch.h" instead
	of <fnmatch.h> (because we use fnmatch-gnu).
	* find/parser.c: Include "gettext.h" and <regex.h>.  Include
	"fnmatch.h" instead of <fnmatch.h> (because we use fnmatch-gnu).
	* find/pred.c: Likewise.
	* find/exec.c: Include "gettext.h".
	* find/find.c: Likewise.
	* find/fstype.c: Likewise.
	* find/ftsfind.c: Likewise.
	* find/print.c: Likewise.
	* lib/buildcmd.c: Likewise.
	* lib/fdleak.c: Likewise.
	* lib/findutils-version.c: Likewise.
	* lib/regextype.c: Likewise.
	* lib/safe-atoi.c: Likewise.
	* find/util.c: Likewise.
	* locate/bigram.c: Likewise.
	* locate/code.c: Likewise.
	* locate/frcode.c: Likewise.
	* locate/word_io.c: Likewise.
	* xargs/xargs.c: Likewise.
	* find/Makefile.am: Add a comment explaining why gnulib-tool
	advised us to use each library.

2011-06-19  James Youngman  <jay@gnu.org>

	Update gnulib.
	* gnulib: update to latest version.

2011-06-18  James Youngman  <jay@gnu.org>

	Remove test-coverage output files for "make clean".
	* find/Makefile.am (CLEANFILES): Clean the .gcda and .gcdo files
	which are produced by running programs that were compile with gcc
	-fprofile-arcs -ftest-coverage.
	* lib/Makefile.am (CLEANFILES): Likewise.
	* locate/Makefile.am (CLEANFILES): Likewise.
	* xargs/Makefile.am (CLEANFILES): Likewise.

	Move the printing code into print.c.
	* find/print.c (scan_for_digit_differences): Move to this file
	from pred.c.
	(do_time_format): Move to this file from pred.c.
	(format_date): Likewise.
	(weekdays): Likewise.
	(months): Likewise.
	(ctime_format): Likewise.
	(file_sparseness): Likewise.
	(checked_fprintf): Likewise.
	(checked_print_quoted): Likewise.
	(checked_fwrite): Likewise.
	(checked_fflush): Likewise.
	(HANDLE_TYPE): Likewise.
	(do_fprintf): Likewise.
	(pred_fprintf): Likewise.
	* find/pred.c: Don't include human.h, filemode.h, verify.h or
	xalloc.h, we don't need them.  Don't define MAX.  Don't declare
	ctime_format or format_date.  Each of the functions moved into
	print.c were moved out of this file.

	Reserve format specifiers %(, %{ and %[ for future use.
	* find/print.c (insert_fprintf): Reject %(, %{ and %[.
	(make_segment): Remove code which previously supposedly rejected
	these format specifiers, but in fact did nothing.   Replace with
	an assertion to document the fact that we do not expect to see
	these format characters in make_segment.
	* find/testsuite/find.gnu/printf-reserved.exp: New test case, for
	%(, %{ and %[, which are all rejected.
	* find/testsuite/Makefile.am (EXTRA_DIST_EXP): Add
	find.gnu/printf-reserved.exp.
	* doc/find.texi (Reserved and Unknown Directives): Document this.
	* find/find.1: Document this.
	* NEWS: Mention this change.

	Additional test cases for printf field width, precision and sign.
	* find/testsuite/find.gnu/printf.exp: Add test cases for left and
	right string alignment (%-10p), string truncation (%10.6p),
	explicit signs (%+d), left and right alignment (%10p, %-10p),
	zero-filling on decimal fields.
	* find/testsuite/find.gnu/printf.xo: Add expected outputs for the
	new tests.

	Add a test for find -printf ... %%.
	* find/testsuite/find.gnu/printf.exp: Also test %%.
	* find/testsuite/find.gnu/printf.xo: Add expected output for the
	%% test case.

	Add a test for "find -printf \c".
	* find/testsuite/Makefile.am (test_shell_progs): Add
	test_escape_c.sh.
	* find/testsuite/test_escape_c.sh: New test for "find -printf
	\c".

	Remove an unnecessary argument from insert_fprintf.
	* find/print.c (insert_fprintf): Eliminate the 'func' argument,
	since it is always pref_fprintf.
	* find/print.h: Adjust the prototype accordingly.
	* find/parser.c (parse_fprintf): Don't pass the func argument to
	insert_fprintf.
	(parse_printf): Likewise.

	Add new test for octal and letter escapes in -printf format.
	* find/testsuite/test_escapechars.golden: Expected output file.
	* find/testsuite/Makefile.am (EXTRA_DIST_GOLDEN): New variable;
	distribute test_escapechars.golden.
	* find/testsuite/test_escapechars.sh: New test.
	* find/testsuite/Makefile.am (test_shell_progs): New variable,
	where we keep the list of shell script tests.  Move existing
	examples from TESTS and add test_escapechars.sh.
	* find/testsuite/Makefile.am (TESTS): Refer to test_shell_progs.
	* cfg.mk: allow trailing blanks and space-tab sequences in
	find/testsuite/test_escapechars.golden.

2011-06-17  James Youngman  <jay@gnu.org>

	Split find's printf-related code into a new file.
	* find/print.h: New file.  Declare insert_fprintf and
	make_segment.
	* find/print.c: New file. Move definitions of insert_fprintf and
	make_segment to here.
	* find/parser.c: Include "parser.h".  Move declarations of
	insert_fprintf and make_segment into that file; move the
	definitions into parser.c.
	* find/Makefile.am (libfindtools_a_SOURCES): Add print.c.
	(EXTRA_DIST): Add print.h.
	* po/POTFILES.in: Add find/print.c.

2011-06-15  James Youngman  <jay@gnu.org>

	Fix compiler warnings in lib/regextype.c and find/parser.c.
	* lib/regextype.c (tagRegexTypeMap): make the name field const.
	* find/parser.c (parse_version): instead of counting features, use
	a boolean variable, nofeatures.  This avoids compiler warnings
	about overflow.

	Adopt the use of the manywarnings module.
	* import-gnulib.config (modules): Add manywarnings.
	* configure.ac: Invoke gl_MANYWARN_ALL_GCC and
	gl_MANYWARN_COMPLEMENT.
	* configure.ac: Turn on the compiler warnings only if
	--enable-compiler-warnings was specified to configure.

2011-06-14  James Youngman  <jay@gnu.org>

	Avoid pointer/integer comparison on value returned by strchr.
	* find/parser.c (parse_newerXY): Compare the result of strchr
	against NULL rather than 0.

	Fix further compiler warnings.
	* find/ftsfind.c (show_outstanding_execdirs): Now that
	execp->state.cmd_argc is a size_t, we can't print it with %d.  So
	print it with PRIuMAX (and include <inttypes.h> to define that).
	* find/tree.c (prec_name): change return type to const char*.
	(type_name): Likewise.
	* find/exec.c (impl_pred_exec): use a separate variable (buf) to
	point the memory allocated/freed with malloc/free, so that the
	existing variable target can then be const (and so we can assign
	pathname to it without a compiler warning).

	Eliminate some compiler warnings.
	* find/find.c: Remove definition of SAFE_CHDIR, which we don't
	use.
	* find/defs.h: Remove redundant declaration of launch.
	* find/parser.c (parse_false): Cast unused arguments to void.
	(parse_print0): Likewise.
	(pred_context): Likewise.
	(parse_newerXY): Add some parens for slightly greater clarity.
	(make_segment): Avoid switch-missing-default-case warning by
	turning it into an if statement.
	(check_path_safety): Remove unused argument.
	(insert_exec_ok): Don't pass the unwanted argument to
	check_path_safety.
	(get_relative_timestamp): silence compiler warning by adding a
	case for the remaining enumeration value rather than using
	default.
	* find/pred.c (months): the strings can be const char*, rather
	than just char*.
	(ctime_format): change TIME_BUF_LEN to an integer constant to
	avoid signed/unsigned comparison.
	(blank_rtrim): Change to new-style function definition(!) and
	remove unnecessary parentheses around a return value.
	* lib/buildcmd.c: Omit redundant declaration of environ.
	* find/tree.c (get_expr): Make static.
	(cost_assoc): make the name field const.
	(prec_assoc): make the prec_name field const.
	(op_assoc): make the type_name field const.
	(type_name): turn into an ANSI function definition(!).
	(prec_name): Likewise!  Also remove spurious parentheses around
	return value.
	(prec_name): Remove spurious parentheses around return value.
	* lib/buildcmd.h (buildcmd_state): change types of several fields
	to size_t: cmd_argc, cmd_argv_alloc, largest_successful_arg_count,
	smallest_failed_arg_count.
	(buildcmd_control): change types of several fields
	to size_t: max_arg_count, initial_argc, lines_per_exec,
	args_per_exec.

	Assume SIGCHLD and O_NOFOLLOW are defined by gnulib.
	* find/find.c: Since gnulib defines O_NOFOLLOW, don't check to see
	if the macro is defined.  Check instead to see if it is 0.
	(safely_chdir_nofollow): Point this out.
	(safely_chdir): Check O_NOFOLLOW for zeroness.
	* find/exec.c: Don't #define SIGCHLD.
	* xargs/xargs.c: Likewise.

2011-06-14  James Youngman  <jay@gnu.org>

	Fix coredump bug introduced in the previous change.
	* locate/locate.c (dolocate): Remove declaration of e, which was
	replaced by the variable db_name.  Change the last two uses of 'e'
	to use 'db_name'.  This bugfix prevents possible coredumps when
	issuing error messages about reads from the locate database (or
	warnings about byte order for old databases).  This bug had been
	introduced in the previous change.

2011-06-13  James Youngman  <jay@gnu.org>

	Split strings into fields nondestructively.
	* lib/splitstring.c: New file; defines splitstring(), which will
	non-destructively locate character-separated fields in a string.
	* lib/splitstring.h: New file; declares splitstring.
	* lib/test_splitstring.c: New file; unit test for splitstring.c.
	* lib/nextelem.c: Delete (obsoleted by splitstring.c).
	* lib/nextelem.h: Delete (obsoleted by splitstring.h).
	* lib/Makefile.am (libfind_a_SOURCES): Add splitstring.c,
	splitstring.c.  Remove nextelem.c, nextelem.h.
	(check_PROGRAMS): Add test_splitstring.
	(TESTS): Add test_splitstring.
	(test_splitstring_SOURCES): Sources for the
	test_splitstring unit test.
	* locate/locate.c: Include splitstring.h rather than nextelem.h.
	(dolocate): Use splitstring rather than next_element.  In places
	where we need a nul-terminated string, use strndup() to create it.
	Convert some space-tab sequences to regular spacing.
	* find/parser.c: Include splitstring.h rather than nextelem.h.
	(check_path_safety): Use splitstring rather than next_element.
	* import-gnulib.config (modules): Depend on the module strndup.
	* cfg.mk: Exempt lib/test_splitstring.c from calling
	bindtextdomain or set_program_name.

2011-06-13  James Youngman  <jay@gnu.org>

	Fix compilation failure in bigram.c by including <locale.h>.
	* locate/bigram.c: Include <locale.h>.

2011-06-12  James Youngman  <jay@gnu.org>

	Split exec-related code into a new file, exec.c
	* find/exec.c: New file.
	(initialise_wd_for_exec): Move out of pred.c
	(record_exec_dir): Likewise.
	(impl_pred_exec): Likewise.
	(prep_child_for_exec): Likewise.
	(launch): Likewise.
	* find/pred.c: These functions are moved out of this file.
	* find/defs.h: impl_pred_exec is no longer static in pred.c, so
	add an external declaration for it.  Move the declaration of
	launch to here also.
	* find/Makefile.am (libfindtools_a_SOURCES): Add exec.c.
	* po/POTFILES.in: Add find/exec.c.

	Eliminate .x-sc_prohibit_empty_lines_at_EOF and .x-sc_bindtextdomain
	* cfg.mk: Move definition of which files we should not check to
	exclude_file_name_regexp--sc_prohibit_empty_lines_at_EOF, instead
	of .x-sc_prohibit_empty_lines_at_EOF.
	Move contents of .x-sc_bindtextdomain into
	exclude_file_name_regexp--sc_bindtextdomain.
	.x-sc_prohibit_empty_lines_at_EOF: Delete.
	.x-sc_bindtextdomain: Delete.

	Enable sc_makefile_at_at_check; fix problems it identifies.
	* lib/Makefile.am: Use $(FINDLIBOBJS) instead of @FINDLIBOBJS@.
	* find/Makefile.am (LDADD): Use $(FINDLIBS) instead of @FINDLIBS@.
	* locate/Makefile.am (updatedb): Use $(VERSION) and
	$(PACKAGE_NAME) instead of @VERSION@ and @PACKAGE_NAME@.
	* cfg.mk: remove sc_makefile_at_at_check from local-checks-to-skip

2011-06-12  James Youngman  <jay@gnu.org>

	Improve src-sniff.py.

	* build-aux/src-sniff.py: Mention that many of these checks would
	be better as gnulib syntax checks (since there are more flexible
	ways to disable these).
	(RegexChecker.__init__): Don't pass a spurious second "self"
	argument.
	(RegexChecker.Check): Provide a more intelligible message when
	complaining about use atof/scanf.
	(RegexChecker.Check): Enable the check for HAVE_FCNTL_H.
	(RegexChecker.Check): When checking for trailing whitespace, don't
	complain about trailing newlines(!)
	(RegexChecker.Check): Indicate what the out-of-date address is
	when we find one.

2011-06-11  James Youngman  <jay@gnu.org>

	Enable the sc_trailing_blank check.
	* cfg.mk: Enable sc_trailing_blank check.
	(exclude_file_name_regexp--sc_trailing_blank): Exclude
	xargs test inputs and outputs.  Exclude the COPYING file.  Exclude
	a find test output.  Exclude the .po files.
	* xargs/xargs.c: Remove trailing blanks.
	* xargs/testsuite/config/unix.exp: Likewise.
	* find/testsuite/find.posix/bracket-depth.exp: Likewise.
	* find/testsuite/find.posix/files-not-expressions1.exp: Likewise.
	* find/testsuite/find.posix/files-not-expressions2.exp: Likewise.
	* find/testsuite/find.posix/files-not-expressions3.exp: Likewise.
	* find/testsuite/find.posix/nameslash.exp: Likewise.
	* find/testsuite/find.posix/perm-vanilla.exp: Likewise.
	* find/testsuite/find.posix/sizes.exp: Likewise.
	* find/testsuite/find.posix/sv-bug-25359.exp: Likewise.
	* find/testsuite/find.posix/typesize.exp: Likewise.
	* find/testsuite/find.gnu/access.exp: Likewise.
	* find/testsuite/find.gnu/deletedir.exp: Likewise.
	* find/testsuite/find.gnu/deletefile.exp: Likewise.
	* find/testsuite/find.gnu/exec-one-rtn-fail.exp: Likewise.
	* find/testsuite/find.gnu/execdir-hier.exp: Likewise.
	* find/testsuite/find.gnu/execdir-pwd.exp: Likewise.
	* find/testsuite/find.gnu/execdir-root-only.exp: Likewise.
	* find/testsuite/find.gnu/follow-arg-parent-symlink.exp: Likewise.
	* find/testsuite/find.gnu/ilname.exp: Likewise.
	* find/testsuite/find.gnu/lname.exp: Likewise.
	* find/testsuite/find.gnu/perm-slash.exp: Likewise.
	* find/testsuite/find.gnu/posix-h.exp: Likewise.
	* find/testsuite/find.gnu/sv-bug-17782.exp: Likewise.
	* find/testsuite/find.gnu/sv-bug-24169.exp: Likewise.
	* find/testsuite/find.gnu/used-invarg.exp: Likewise.
	* find/testsuite/find.gnu/used-missing.exp: Likewise.
	* find/testsuite/excuses.txt: Likewise.
	* locate/testsuite/config/unix.exp: Likewise.
	* locate/testsuite/locate.gnu/bigendian.exp: Likewise.
	* locate/testsuite/locate.gnu/bigprefix1.exp: Likewise.
	* locate/testsuite/locate.gnu/exists2.exp: Likewise.
	* locate/testsuite/locate.gnu/exists3.exp: Likewise.
	* locate/testsuite/locate.gnu/littleendian.exp: Likewise.
	* locate/testsuite/locate.gnu/notexists2.exp: Likewise.
	* locate/testsuite/locate.gnu/notexists3.exp: Likewise.
	* locate/testsuite/locate.gnu/sv-bug-14535.exp: Likewise.
	* xargs/testsuite/xargs.posix/arg_max_32bit_linux_bug.exp: Likewise.
	* xargs/testsuite/xargs.posix/arg_max_64bit_linux_bug.exp: Likewise.
	* xargs/testsuite/xargs.posix/rc-125.exp: Likewise.
	* xargs/testsuite/xargs.posix/sv-bug-18714.exp: Likewise.
	* xargs/testsuite/xargs.posix/sv-bug-18714b.exp: Likewise.
	* po/Makevars (EXTRA_LOCALE_CATEGORIES): Likewise.
	* xargs/xargs.1 (SEE ALSO): Likewise.

	Enable the sc_space_tab check
	* cfg.mk: Enable the sc_space_tab check.  Exclude various xargs
	test inputs and outputs from the check.  Remove some obsolete
	comments.
	* locate/Makefile.am (dblocation.texi): Remove space-tab sequences.

	Enable the sc_texinfo_acronym check
	* cfg.mk: Enable the sc_texinfo_acronym check.  Exempt
	doc/perm.text, which isn't ours anyway.
	* doc/find.texi (Deleting Files): Say just POSIX rather than
	@acronym{POSIX}, simply because this is the convention in GNU
	documentation.  The motivation is that it's hard to do so
	consistently (because, for example, you can't use @acronym in a
	node name).

	Enable syntax check sc_obsolete_symbols.
	(exclude_file_name_regexp--sc_obsolete_symbols): Don't check
	build-aux/src-sniff.py.

	Enable more syntax checks, eliminate useless C preprocessor parentheses
	* find/defs.h: Eliminate useless parentheses in #if.
	* find/find.c (safely_chdir): Likewise.
	* find/pred.c: Likewise.
	* lib/buildcmd.c: Likewise.
	* lib/fdleak.c: Likewise
	* xargs/xargs.c: Likewise.
	* find/parser.c: Likewise.
	(ISDIGIT): Simplify, and avoid undefining isascii.
	* cfg.mk (local-checks-to-skip): Remove sc_prohibit_cvs_keyword,
	since the test produces no hits anyway.  Explain why we avoid
	sc_two_space_separator_in_usage. Enable the sc_useless_cpp_parens
	check.

	Use stat-size macros in pred.c also.
	* find/pred.c: Include stat-size.  Eliminate definitions of
	DEV_BSIZE, ST_BLKSIZE, ST_NBLOCKS, ST_NBLOCKSIZE macros which are
	now in stat-size.h (yes, this is the second set of these macros
	we've removed).
	(file_sparseness): Use ST_NBLOCKS and ST_NBLOCKSIZE.
	* cfg.mk (local-checks-to-skip): Don't skip
	sc_prohibit_stat_st_blocks, because now we no loner access the
	st_blocks field of struct stat, directly.
	* lib/listfile.c (file_blocksize): Eliminate this function, it's
	no longer needed.
	* lib/listfile.h: Don't declare file_blocksize.

	Adopt the new gnulib module stat-size.
	* lib/listfile.c: Include "stat-size.h".  Delete the DEV_BSIZE,
	ST_BLKSIZE, ST_NBLOCKS, ST_NBLOCKSIZE macros which are now in
	stat-size.h.
	* gnulib: Update to latest.
	* import-gnulib.config (modules): Add stat-size.

2011-06-05  James Youngman  <jay@gnu.org>

	Don't include sys/param.h where we don't need it.
	* xargs/xargs.c: Don't include sys/param.h, we don't use it.

	Don't include "stdio-safer.h" where it is not used.
	* find/parser.c: Don't include stdio-safer.h, it's not used.
	* lib/findutils-version.c: Likewise.

	Don't include <stddef.h> where it is not used.
	* lib/dircallback.c: Don't include <stddef.h>, it's not used.
	* lib/extendbuf.c: Likewise.
	* lib/qmark.c: Likewise.
	* lib/savedirinfo.c: Likewise.

	Fixes for empty-lines-at-EOF syntax check.
	* .x-sc_bindtextdomain: Add newline at EOF.
	* locate/Makefile.am: Remove empty trailing line at EOF.
	* find/testsuite/sv-bug-32043.sh: Likewise.
	* .x-sc_prohibit_empty_lines_at_EOF: Don't apply this check to
	m4/order-good.bin m4/order-bad.bin
	locate/testsuite/locate.gnu/locateddb.old.x86.xi
	locate/testsuite/locate.gnu/locateddb.old.powerpc.xi.

	Avoid some false positives for the sc_prohibit_doubled_word check.
	* .x-sc_prohibit_doubled_word: don't perform this check on
	xargs/testsuite/xargs.sysv/iquotes.xo or ChangeLog.
	Don't check .po files for doubled English words (because they're
	not in English).
	* find/tree.c: Modify some text to avoid saying "AND and",
	which one of the syntax checks doesn't like.
	(opt_expr): Likewise.
	(consider_arm_swap): Likewise.
	* README: Likewise.

	Include dirent.h uncontintionally (since gnulib provides it).
	* find/pred.c: Include <dirent.h> unconditionally; gnulib provides
	it.
	* lib/savedirinfo.c: Likewise.

	Silence some false positives for sc_prohibit_always_true_header_tests.
	* .x-sc_prohibit_always_true_header_tests: New file; exclude
	build-aux/src-sniff.py from C inclusion tests, because it itself
	contains examples of string the syntac checkers don't like
	(because it's also a syntax checker).
	ChangeLog: also exclude this because it frequently contains the
	specifics of items added/removed, including examples of text which
	are this syntax check looks for.

	Prefer "cannot" to "can not".
	* locate/locatedb.5: Change "can not" to "cannot".
	* locate/updatedb.1: Likewise.

	Update xargs error message.
	* doc/find.texi (Error Messages From xargs): the message "can not
	fit single argument within argument list size limit" is now
	"argument list too long".

2011-06-04  James Youngman  <jay@gnu.org>

	Use the gnulib byteswap and uname modules.
	* import-gnulib.config (modules): Add byteswap and uname.
	* locate/word_io.c: Include byteswap.h.   Don't #define bswap_32.
	* find/util.c: sys/utsname.h no longer needs include guards since
	gnulib always provides it.
	* configure.ac: Don't check for sys/utsname.

	gnulib already defines O_CLOEXEC.
	* lib/fdleak.c: gnulib's fcntl.h always defines O_CLOEXEC, so
	don't define it here.

	Add internationalisation support to bigram but not regexprops.
	* locate/bigram.c: Use libintl.h.
	(main): Call bindtextdomain.
	* .x-sc_bindtextdomain: Exempt lib/regexprops.c from needing to
	use bindtextdomain.  The output of regexprops is intended to be
	determined entirely by the properties of the GNU regex
	implementation.

	Update gnulib.
	* gnulib: update to current head.

	Update the copyright year in C source files.
	* find/defs.h: Update copyright year.
	* find/find.c: Update copyright year.
	* find/finddata.c: Update copyright year.
	* find/ftsfind.c: Update copyright year.
	* find/parser.c: Update copyright year.
	* find/pred.c: Update copyright year.
	* find/sharefile.c: Update copyright year.
	* find/sharefile.h: Update copyright year.
	* find/tree.c: Update copyright year.
	* find/util.c: Update copyright year.
	* lib/buildcmd.c: Update copyright year.
	* lib/buildcmd.h: Update copyright year.
	* lib/dircallback.c: Update copyright year.
	* lib/dircallback.h: Update copyright year.
	* lib/extendbuf.c: Update copyright year.
	* lib/extendbuf.h: Update copyright year.
	* lib/fdleak.c: Update copyright year.
	* lib/fdleak.h: Update copyright year.
	* lib/findutils-version.c: Update copyright year.
	* lib/findutils-version.h: Update copyright year.
	* lib/forcefindlib.c: Update copyright year.
	* lib/listfile.c: Update copyright year.
	* lib/listfile.h: Update copyright year.
	* lib/nextelem.c: Update copyright year.
	* lib/nextelem.h: Update copyright year.
	* lib/printquoted.c: Update copyright year.
	* lib/printquoted.h: Update copyright year.
	* lib/qmark.c: Update copyright year.
	* lib/regexprops.c: Update copyright year.
	(copying): Update copyright year in the output file, too.
	* lib/regextype.c: Update copyright year.
	* lib/regextype.h: Update copyright year.
	* lib/safe-atoi.c: Update copyright year.
	* lib/safe-atoi.h: Update copyright year.
	* lib/savedirinfo.c: Update copyright year.
	* lib/savedirinfo.h: Update copyright year.
	* lib/unused-result.h: Update copyright year.
	* lib/waitpid.c: Update copyright year.
	* locate/bigram.c: Update copyright year.
	* locate/code.c: Update copyright year.
	* locate/frcode.c: Update copyright year.
	* locate/locate.c: Update copyright year.
	* locate/locatedb.h: Update copyright year.
	* locate/word_io.c: Update copyright year.
	* xargs/xargs.c: Update copyright year.

	More copyright year updates.
	* build-aux/check-testfiles.sh: Update copyright year.
	* m4/noreturn.m4: Update copyright year.
	* po/POTFILES.in: Update copyright year.

	Update the copyright year in test/documentation files, updatedb.
	* build-aux/src-sniff.py: Update copyright year.
	* doc/find-maint.texi: Update copyright year.
	* doc/regexprops.texi: Update copyright year.
	* find/testsuite/config/unix.exp: Update copyright year.
	* locate/testsuite/config/unix.exp: Update copyright year.
	* xargs/testsuite/config/unix.exp: Update copyright year.
	* locate/updatedb.sh: Update copyright year.

2011-06-03  James Youngman  <jay@gnu.org>

	Warn about lack of birth time information only when it's true.
	* find/pred.c (pred_newerXY): Issue a warning about the inability
	to get the birth time of a file, only if we actually failed to
	obtain the birth time of the file.  This is a bugfix; there was a
	misplaced semicolon after an if condition, so the immediately
	succeeding block qould be executed unconditionally.

	Compiler warning fixes in find/pred.c.
	* find/pred.c (mode_to_filetype): return const char*.
	(impl_pred_exec): Make target and prefix variables const.
	(impl_pred_exec): Separate 'target' variable (which sometimes
	points to a string literal) from a separate 'buf' variable (which,
	if set, is always the value returned by base_name, which needs to
	be freed.
	(checked_fwrite): Store the result of fwrite in a size_t (i.e. the
	same type the function returns).

	Eliminate some compiler warnings in parser.c
	* find/parser.c: Don't define the macros STRINGIFY and
	PARSE_ACTION_NP.
	(optionh_getfilecon): Make this function static
	since it is not used elsewhere.
	(optionl_getfilecon): Likewise.
	(optionp_getfilecon): Likewise.
	(found_parser): Likewise.

	Avoid code redundancy in lib/buildcmd.c.
	* lib/buildcmd.c (bc_get_arg_max): Recheck val only if we might
	have changed it (i.e. when ARG_MAX is defined).

	Eliminate some compiler warnings in find/parser.c.
	* find/defs.h (struct parser_table): Make parser_name field const.
	* find/parser.c: Remove redundant declaration of parse_print.
	(insert_path_check): Change name of parameter pred_name to avoid
	shadowing the function of that name.
	(find_parser): Make search_name parameter const.

	Fix a compiler warning in lib/buildcmd.c
	* lib/buildcmd.c: special_terminating_arg should be const.

	Fix compiler warnings in lib/fdleak.c
	* lib/fdleak.c (visit_open_fds): Rename loop variable from i to j
	to avoid shadowing.
	(get_proc_max_fd): Fix definition (it's a void function, not a
	traditional pre-ANSI function definition).

	Fix several small compiler warnings.
	* lib/dircallback.c: Include dircallback.h.
	* lib/dircallback.h: Correct declaration of run_in_dir.
	* lib/listfile.c (file_blocksize): Use the otherwise-unused parameter.
	* find/defs.h: Remove redundant declaration of variable options.

	Fix some compiler warnings in findutils-version.c.
	* lib/findutils-version.c: include findutils-version.h.  Make
	version_string const.  Don't #define N_, since we don't use it.

	Don't display a separate gnulib version.
	* lib/findutils-version.c (display_findutils_version): Don't
	display gnulib_version because it's no longer defined (because
	there is no gnulib version separate from the findutils version,
	now that gnulib is a submodule).
	* import-gnulib.config: remove gnulib_version and destdir, they
	are not needed any more.
	* lib/Makefile.am (EXTRA_DIST): Don't distribute gnulib-version.h
	or gnulib-version.c.
	(BUILT_SOURCES): delete, there are no longer any built sources.
	* lib/gnulib-version.h: Remove.
	* locate/code.c: Don't include gnulib-version.h
	* xargs/xargs.c: Don't include gnulib-version.h

2011-06-01  James Youngman  <jay@gnu.org>

	Take the last matching entry in /etc/mtab, not the first.
	* find/fstype.c (file_system_type_uncached): Instead of taking the
	first match, take the last match.  This deals better with mtab
	implementations in which there can be duplicate entries, for
	example Linux-based systems in which /etc/mtab is a symlink to
	/proc/mounts) can have duplicate entries in the file system list.
	This happens most frequently for /.
	* NEWS: Mention this change.

2011-06-02  James Youngman  <jay@gnu.org>

	Remove unnecessary header checks and include guards.
	* configure.ac (AC_CHECK_HEADERS): Remove checks for header files
	that gnulib either assumes are always present, or provides
	itself.  These include errno.h fcntl.h inttypes.h limits.h
	locale.h stddef.h stdint.h stdlib.h string.h sys/types.h
	unistd.h.
	* lib/buildcmd.c: Remove include guard for limits.h.
	* find/fstype.c: Remove include guard for sys/types.h.
	* lib/savedirinfo.c: Likewise.
	* find/find.c: Remove include guard for locale.h.
	* find/ftsfind.c: Likewise.

2011-06-01  James Youngman  <jay@gnu.org>

	Better error handling for the result of set_fstype_devno.
	* find/fstype.c (file_system_type_uncached): If set_fstype_devno
	fails for an entry (that is, the device number stays at -1) don't
	consider it a match.
	(get_mounted_filesystems): Don't call set_fstype_devno since we
	don't need to check the device number.
	(get_mounted_devices): If set_fstype_devno fails for a file
	system, don't return it.

2011-05-31  James Youngman  <jay@gnu.org>

	import-gnulib.sh now stops if it sees the old directory layout.
	* import-gnulib.sh (check_old_gnulib_dir_layout): Check the
	./gnulib-git, ./gnulib/ and ./gl/ subdirectories to figure out if
	we are using a current version of import-gnulib.sh with an old
	directory layout.  If so, print an explanation of the problem and
	return false.
	(main): stop if check_old_gnulib_dir_layout didn't like the
	directory layout.

	Minor fixes in import-gnulib.sh.
	* import-gnulib.sh (fixmsg): Fix punctuation in the commands given
	for installing the changelog driver.
	(usage): Explain what the -a option does.
	(run_gnulib_tool): delete broken symlinks in the output directory,
	not the gnulib source.
	(check_merge_driver): fix the path to the ChangeLog merge driver
	source.

2011-05-30  James Youngman  <jay@gnu.org>

	Manage gnulib as a git submodule.
	* .gitmodules: New file; manage gnulib as a submodule.  For future
	compatibility with the "bootstrap" script, keep the gnulib
	submodule in the gnulib directory (instead of the gnulib-git
	directory as before).  This means we need to find a new directory
	for the output of gnulib-tool; we will use "gl" for that.
	* import-gnulib.sh (do_checkout): Replace with do_submodule.
	(do_submodule): initialise and configure the gnulib module.
	(main): call do_submodule instead of do_checkout.  Don't call
	move_cvsdir, it's obsolete.
	(move_cvsdir): delete
	(run_gnulib_tool): change gnulib to ${gldest} (and set that variable).
	(hack_gnulib_tool_output): generate gl/Makefile.am, not
	gnulib/Makefile.am.
	(refresh_output_files): Rename gnulib to gl.
	(update_version_file): Check the state of the submodule.
	* Makefile.am (SUBDIRS): Rename gnulib to gl.
	(ACLOCAL_AMFLAGS): Likewise.
	* lib/Makefile.am (INCLUDES): Likewise.
	(LDADD): Likewise.
	(findutils-check-smells): Rename gnulib-git to gnulib.
	* find/Makefile.am (INCLUDES): Change gnulib to gl.
	(LDADD): Likewise.
	* xargs/Makefile.am (INCLUDES): Change gnulib to gl.
	(LDADD): Likewise.
	* locate/Makefile.am (INCLUDES): Rename gnulib to gl.
	(LDADD): Likewise.
	* .gitignore: Rename gnulib to gl.
	* configure.ac (AC_CONFIG_MACRO_DIR): Change to gl/m4.
	(AC_CONFIG_FILES): use gl/Makefile and gl/lib/Makefile instead of
	gnulib/Makefile and gnulib/lib/Makefile.
	* find/fstype.c: Include gnulib include files as "foo.h", not
	"../gnulib/lib/foo.h", because the relative path is not needed and
	in any case has changed.

2011-05-29  James Youngman  <jay@gnu.org>

	Savannah bug #31424: Revert Interix-specific change.
	Gnulib will use suacomp for solving this problem, so findutils
	will not need a workaround here.
	* lib/arg-max.h: Delete this file.
	* lib/Makefile.am (libfind_a_SOURCES): Remove arg-max.h.
	* lib/buildcmd.c: Don't include arg-max.h.
	* xargs/xargs.c: Likewise.

2011-05-24  James Youngman  <jay@gnu.org>

	Fix Savannah bug #33384.
	* locate/updatedb.sh: Don't reset $PATH, because the hard-coded
	value we were using isn't guaranteed to contain all the utilities
	(for example rm, chmod and so on) we would like to use.
	* NEWS: Mention this bugfix.

2011-05-22  James Youngman  <jay@gnu.org>

	Don't assume that "echo" lives in /bin.
	* xargs/xargs.c (main): Change default_cmd from "/bin/echo" (which
	may not be present on some POSIX systems) to "echo" (which must
	exist somewhere on $PATH on any POSIX system).
	* doc/find.texi (Multiple Files): document this.
	* NEWS: Describe this change.
	* xargs/testsuite/xargs.sysv/empty_def-t.xe: Change /bin/echo to
	echo.
	* xargs/testsuite/xargs.gnu/n2-s26-x-0.exp: Change -s26 to -s21 to
	keep the expected test result the same.  Rename the test to
	reflect the updated arguments.
	* xargs/testsuite/xargs.gnu/n2-s26-x-0.xo: Rename to
	n2-s21-x-0.xo.
	* xargs/testsuite/xargs.gnu/n2-s26-0.exp: Rename to n2-s21-0.exp,
	update -s argument.
	* xargs/testsuite/xargs.posix/s30.exp: Rename to s25.exp, update -s.
	* xargs/testsuite/xargs.posix/s30.xo: Rename to s25.xo.
	* xargs/testsuite/xargs.gnu/s30-0.exp: Rename to s25-0.exp, update
	-s argument.
	* xargs/testsuite/xargs.gnu/s30-0.xo: Rename to s25-0.xo.
	* xargs/testsuite/xargs.sysv/s30-t.exp: Rename to s25-t.exp,
	update -s.
	* xargs/testsuite/xargs.sysv/s30-t.xo: Rename to s25-t.xo.
	* xargs/testsuite/xargs.sysv/s30-t.xe: Rename to s25-t.xe, change
	/bin/echo to just echo.
	* xargs/testsuite/xargs.posix/s47.exp: Rename to s42.exp, update -s.
	* xargs/testsuite/xargs.posix/s47.xo: Rename to s42.xo.
	* xargs/testsuite/xargs.gnu/n3-s36-0.exp: Rename to n3-s31-0.exp,
	update -s.
	* xargs/testsuite/xargs.gnu/n3-s36-0.xo: Rename to n3-s31-0.xo.
	* xargs/testsuite/xargs.gnu/s20-0.exp: Rename to s15-0.exp, update
	-s.
	* xargs/testsuite/xargs.gnu/s20-0.xo: Rename to s15-0.xo.
	* xargs/testsuite/xargs.posix/n2-s26.exp: Rename to n2-s21.exp,
	update -s.
	* xargs/testsuite/xargs.posix/n2-s26.xo: Rename to n2-s21.xo.
	* xargs/testsuite/xargs.gnu/s19-0.exp: Rename to s14-0.exp, update
	-s.
	* xargs/testsuite/xargs.gnu/s19-0.xo: Rename to s14-0.xo.
	* xargs/testsuite/xargs.gnu/s19_2-0.exp: Rename to s14_2-0.exp,
	update -s.
	* xargs/testsuite/xargs.gnu/s19_2-0.xo: Rename to s14_2-0.xo.
	* xargs/testsuite/xargs.posix/n3-s36.exp: Rename to n3-s31.exp,
	update -s.
	* xargs/testsuite/xargs.posix/n3-s36.xo: Rename to n3-s31.xo.
	* xargs/testsuite/xargs.posix/s19.exp: Rename to s14.exp, update
	-s.
	* xargs/testsuite/xargs.posix/s19.xo: Rename to s14.xo.
	* xargs/testsuite/xargs.posix/s19_2.exp: Rename to s14_2.exp,
	update -s.
	* xargs/testsuite/xargs.posix/s19_2.xo: Rename to s14_2.xo.
	* xargs/testsuite/xargs.posix/s20.exp: Rename to s15.exp,
	update -s.
	* xargs/testsuite/xargs.posix/s20.xo: Rename to s15.xo.
	* xargs/testsuite/Makefile.am (EXTRA_DIST_XO): Update names.
	(EXTRA_DIST_EXP): Likewise.

2011-05-17  James Youngman  <jay@gnu.org>

	Document ftsfind/oldfind and configure options.
	* doc/find.texi (Configuration): New section documenting the
	important configuration options that can be passed to configure,
	including --without-fts.
	* find/find.1 (BINARIES): New section explaining why two binaries
	are installed.
	* find/oldfind.1: New manual page explaining how 'oldfind' is
	different to 'find'.
	* find/ftsfind.1: New manual page explaining how 'ftsfind' is
	different to 'find'.
	* find/Makefile.am (man_MANS): As well as find.1, install one of
	ftsfind.1 or oldfind.1, depending on whether --without-fts was
	specified to configure.
	* NEWS: Mention this change.

2011-05-15  James Youngman  <jay@gnu.org>

	Add lib/fdleak.c to translatable files.
	* po/POTFILES.in: Add lib/fdleak.c.

	Fix Savannah bug #18227 (-ls doesn't print device major/minor).
	* lib/listfile.c (list_file): check HAVE_STRUCT_STAT_ST_RDEV
	instead of HAVE_ST_RDEV, fixing this bug.  HAVE_ST_RDEV was
	defined by the obsolete Autoconf macro AC_STRUCT_ST_RDEV, but
	findutils hasn't actually called AC_STRUCT_ST_RDEV since Apr 5
	2000.
	* NEWS: Mention this bugfix.

	#29698: Correct and clarify documentation of xargs -d option
	* xargs/xargs.1: Update documentation for -d option to more
	clearly distinguish the treatment of backslashes in the input and
	the treatment of backslashes in the argument to -d.
	* NEWS: Mention this bugfix.

	Implement xargs --process-slot-var.
	* xargs/xargs.c (set_slot_var): New function; sets an environment
	variable to the index of the entry in pids[] that represents the
	relevant child process.  This can be used in rudimentary load
	distribution systems.
	(slot_var_name): the name of the variable to use (selected by
	--process-slot-var).
	(enum LongOptionIdentifier): Unique identifiers for long options
	with no short option equivalent (--process-slot-var is the first).
	(longopts): Add --process-slot-var.
	(add_proc): return the index within pids[] that we selected.
	(main): Pass &option_index to getopt_long (option_index is a new
	variable) in order to identify which long option was passed.
	Handle --process-slot-var.
	(prep_child_for_exec): Call set_slot_var.
	(usage): Mention --process-slot-var.
	* doc/find.texi (xargs options): Document --process-slot-var.
